|	subroutine dmxvip(iop,n1,n2,a,lda,x,incx,y,incy,info)
|
|	at present this implements only iop = 0
|	y <- Ax for matrices that have fewer than 64 columns
|
|************************************************************
|  Argument list layout:
	piop	= 0
	pn1	= 4
	pn2 	= 8
	pa	= 12
	plda	= 16
	px 	= 20
	pincx	= 24
	py	= 28
	pincy	= 32
	pinfo	= 36


|  Stack frame layout:
	arglist		= 0 - 4		| arglist pointer
	ccu_sv		= arglist - 32	| cnest/cunnest save area
	stack_size	= ccu_sv

	.globl	_dmxvip_
_dmxvip_:			| mcount.sed search point


	link	a6,#stack_size


	cnest	a6@(ccu_sv)		| prepare for concurrency
	movl	a0,a6@(arglist)		| save the argument list pointer
	movl	a0@(pn1)@,d7
	subql	#1,d7

	cstart	d7

	clrl	__CEDAR$PO__
	movl	a6@(arglist),a0		| restore argument list
	movl	a0@(pn2)@,d1
	movl	a0@(pa),a1
	movl	a0@(px),a2
	movl	a0@(py),a3
	movl	a0@(pincx)@,d2
	movl	a0@(pincy)@,d3
	movl	a0@(plda)@,d0

	movl	#-1,vm
	movl	vm,__CEDAR$MR__
	movl	d1,vl
	subil	#32,vl

	bgt	C64

	movl	d1,vl
	movl	d2,vi
	mulsl	#8,d2
	movl	d2,__CEDAR$SR__
	movl	vl,__CEDAR$LR__
	ldstprf	a2@
	vmoved	a2@,v1			| fetch x into register
	clrl	__CEDAR$PO__
	movl	d0,d2
	mulsl	#8,d2
	movl	d2,__CEDAR$SR__
	movl	d0,vi

L1:	
	movl	#0,d2
	fmoveld	d2,fp0
	movl	vl,__CEDAR$LR__
	ldstprf	a1@[d7:l:D]
	vdotd	a1@[d7:l:D],v1,fp0	
	clrl	__CEDAR$PO__
	movl	d3,d2
	mulsl	d7,d2
	fmoved	fp0,a3@[d2:l:D]		| store y(d7+1)
	crepeat	L1

	cunnest	a6@(ccu_sv)
	unlk	a6
	rts

C64:

	movl	d1,vl
	movl	d2,vi
	mulsl	#8,d2
	movl	d2,__CEDAR$SR__
	movl	vl,__CEDAR$LR__
	ldstprf	a2@
	vmoved	a2@+,v1			| fetch x into register
	subil	#32,vl
	vmoved  a2@,v2
	clrl	__CEDAR$PO__
	movl	d0,d2
	mulsl	#8,d2
	movl	d2,__CEDAR$SR__
	movl	d0,vi

L2:	
	movl	d1,vl
	movl	#0,d2
	fmoveld	d2,fp0
	lea	a1@[d7:l:D],a0
	movl	vl,__CEDAR$LR__
	ldstprf	a0@
	vdotd	a0@+,v1,fp0	
	subil	#32,vl
	vdotd	a0@,v2,fp0
	clrl	__CEDAR$PO__
	movl	d3,d2
	mulsl	d7,d2
	fmoved	fp0,a3@[d2:l:D]		| store y(d7+1)

	crepeat	L2

	cunnest	a6@(ccu_sv)
	unlk	a6
	rts


