
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
 
      SUBROUTINE BESSEL(NB,I)
      IF(I.LE.6) THEN
        NB=4
      ELSEIF(I.LE.26) THEN
        NB=5
      ELSEIF(I.LE.64) THEN
        NB=6
      ELSEIF(I.LE.120) THEN
        NB=7
      ELSEIF(I.LE.189) THEN
        NB=8
      ELSEIF(I.LE.281) THEN
        NB=9
      ELSE
        NB=10
      ENDIF
      RETURN
      END

C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
      SUBROUTINE CFFT9X(AR,AI,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C PURPOSE      PERFORMS MULTIPLE FAST FOURIER TRANSFORMS.  THIS PACKAGE
C              WILL PERFORM A NUMBER OF SIMULTANEOUS COMPLEX PERIODIC
C              FOURIER TRANSFORMS OR CORRESPONDING INVERSE TRANSFORMS.
C              THAT IS, GIVEN A SET OF COMPLEX GRIDPOINT VECTORS, THE
C              PACKAGE RETURNS A SET OF COMPLEX FOURIER
C              COEFFICIENT VECTORS, OR VICE VERSA.  THE LENGTH OF THE
C              TRANSFORMS MUST BE A NUMBER GREATER THAN 1 THAT HAS
C              NO PRIME FACTORS OTHER THAN 2, 3, AND 5.
C
C              THE PACKAGE CFFT9X CONTAINS SEVERAL USER-LEVEL ROUTINES:
C
C            SUBROUTINE CFTFAX
C                AN INITIALIZATION ROUTINE THAT MUST BE CALLED ONCE
C                BEFORE A SEQUENCE OF CALLS TO CFFT9X
C                (PROVIDED THAT N IS NOT CHANGED).
C
C            SUBROUTINE CFFT9X
C                THE ACTUAL TRANSFORM ROUTINE, CABABLE OF
C                PERFORMING BOTH THE TRANSFORM AND ITS INVERSE.
C                HOWEVER, AS THE TRANSFORMS ARE NOT NORMALIZED,
C                THE APPLICATION OF A TRANSFORM FOLLOWED BY ITS
C                INVERSE WILL YIELD THE ORIGINAL VALUES MULTIPLIED
C
C USAGE        LET N BE OF THE FORM 2**P * 3**Q * 5**R, WHERE P .GE. 0,
C              Q .GE. 0, AND R .GE. 0.  THEN A TYPICAL SEQUENCE OF
C              CALLS TO TRANSFORM A GIVEN SET OF COMPLEX VECTORS OF
C              LENGTH N TO A SET OF (UNSCALED) COMPLEX FOURIER
C              COEFFICIENT VECTORS OF LENGTH N IS
C
C                   DIMENSION IFAX(13),TRIGS(2*N)
C                   COMPLEX A(...), WORK(...)
C
C                   CALL CFTFAX (N, IFAX, TRIGS)
C                   CALL CFFT9X (A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C              THE OUTPUT VECTORS OVERWRITE THE INPUT VECTORS, AND
C              THESE ARE STORED IN A.  WITH APPROPRIATE CHOICES FOR
C              THE OTHER ARGUMENTS, THESE VECTORS MAY BE CONSIDERED
C              EITHER THE ROWS OR THE COLUMNS OF THE ARRAY A.
C              SEE THE INDIVIDUAL WRITE-UPS FOR CFTFAX AND
C              CFFT9X BELOW, FOR A DETAILED DESCRIPTION OF THE
C              ARGUMENTS.
C
C HISTORY      THE PACKAGE WAS WRITTEN BY CLIVE TEMPERTON AT ECMWF IN
C              NOVEMBER, 1978.  IT WAS MODIFIED, DOCUMENTED, AND TESTED
C              FOR NCAR BY RUSS REW IN SEPTEMBER, 1980.  IT WAS
C              FURTHER MODIFIED FOR THE FULLY COMPLEX CASE BY DAVE
C              FULKER IN NOVEMBER, 1980.
C
C-----------------------------------------------------------------------
      DIMENSION AR(1),AI(1),TRIGS(1),IFAX(1)
      INTEGER L1
      REAL WORK(20000)
C
C     SUBROUTINE "CFFT9X" - MULTIPLE FAST COMPLEX FOURIER TRANSFORM
C
C     A IS THE ARRAY CONTAINING INPUT AND OUTPUT DATA
C     WORK IS AN AREA OF SIZE N*LOT
C     TRIGS IS A PREVIOUSLY PREPARED LIST OF TRIG FUNCTION VALUES
C     IFAX IS A PREVIOUSLY PREPARED LIST OF FACTORS OF N
C     INC IS THE INCREMENT WITHIN EACH DATA 'VECTOR'
C         (E.G. INC=1 FOR CONSECUTIVELY STORED DATA)
C*$*       ASSERT RELATION (INC.GE.1)
C     JUMP IS THE INCREMENT BETWEEN THE START OF EACH DATA VECTOR
C     N IS THE LENGTH OF THE DATA VECTORS
C*$*       ASSERT RELATION (JUMP.GE.N)
C*$*       ASSERT RELATION (N.GT.0)
C     LOT IS THE NUMBER OF DATA VECTORS
C     ISIGN = +1 FOR TRANSFORM FROM SPECTRAL TO GRIDPOINT
C           = -1 FOR TRANSFORM FROM GRIDPOINT TO SPECTRAL
C
C
C     VECTORIZATION IS ACHIEVED ON CRAY BY DOING THE TRANSFORMS IN
C     PARALLEL.
      LL=LOT+LOT
      INK=INC
      JUM=JUMP
      NFAX=IFAX(1)
C
C
C     PERFORM THE TRANSFORM PASSES, ONE PASS FOR EACH FACTOR.  DURING
C     EACH PASS THE DATA ARE MOVED FROM A TO WORK OR FROM WORK TO A.
C     IF NFAX IS ODD, THE LAST FACTOR IS PROCESSED IN PLACE.
C
      LA=1
      NMOD = MOD(NFAX,2)
      NINK = N*INK
      IF(ISIGN.GT.0) THEN
 
cD       call start_interval( 24 )
D        call trace_enter (2001) 
        DO 10 K=1+NMOD,NFAX,2
          CALL CPASS (AR(1),AI(1),WORK(1),WORK(1+LOT),TRIGS,
     *    INK,LL,JUM,1,LOT,N,IFAX(K+1),LA)
          LA=LA*IFAX(K+1)
          CALL CPASS (WORK(1),WORK(1+LOT),AR(1),AI(1),TRIGS,
     *    LL,INK,1,JUM,LOT,N,IFAX(K+2),LA)
          LA=LA*IFAX(K+2)
 10     CONTINUE
cD       call end_interval( 24 )

D        call trace_exit (2002) 
        IF( NMOD .NE. 0 ) THEN
Cgjx          CPASS cannot be used in-place
Cgjx          IF (IFAX(2) .NE. 5) THEN
Cgjx            CALL CPASS (AR(1),AI(1),AR(1),AI(1),TRIGS,
Cgjx     *        INK,INK,JUM,JUM,LOT,N,IFAX(2),LA)
Cgjx          ELSE
D           call start_interval( 25 )
            L1 = N * LOT
            WORK(1:$L1:2) = AR(1:$L1:INK)
            WORK(2:$L1:2) = AI(1:$L1:INK)
D12         call end_interval( 25 )
            CALL CPASS (WORK(1),WORK(2),AR(1),AI(1),TRIGS,
     *           2,INK,JUM,JUM,LOT,N,IFAX(2),LA)
Cgjx          ENDIF
        ENDIF
      ELSE
 
cD       call start_interval( 26 )
D        call trace_enter (2003) 
        DO 30 K=1+NMOD,NFAX,2
          CALL CPASSM(AR(1),AI(1),WORK(1),WORK(1+LOT),TRIGS,
     *          INK,LL,JUM,1,LOT,N,IFAX(K+1),LA)
          LA=LA*IFAX(K+1)
          CALL CPASSM(WORK(1),WORK(1+LOT),AR(1),AI(1),TRIGS,
     *         LL,INK,1,JUM,LOT,N,IFAX(K+2),LA)
          LA=LA*IFAX(K+2)
 30     CONTINUE
cD       call end_interval( 26 )
D        call trace_exit (2004) 
        IF( NMOD .NE. 0 ) THEN
Cgjx          CPASSM cannot be used inplace 
Cgjx          IF (IFAX(2) .NE. 5) THEN
Cgjx            CALL CPASSM(AR(1),AI(1),AR(1),AI(1),TRIGS,
Cgjx     *            INK,INK,JUM,JUM,LOT,N,IFAX(2),LA)
Cgjx          ELSE
D           call start_interval( 27 )
            L1 = N * LOT
            WORK(1:$L1:2) = AR(1:$L1:INK)
            WORK(2:$L1:2) = AI(1:$L1:INK)
D32         call end_interval( 27 )
            CALL CPASSM(WORK(1),WORK(2),AR(1),AI(1),TRIGS,
     *           2,INK,JUM,JUM,LOT,N,IFAX(2),LA)
Cgjx          ENDIF
        ENDIF
      ENDIF
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
 
      SUBROUTINE CFTFAX(N,IFAX,TRIGS)
      DIMENSION IFAX(1),TRIGS(1)
C
C     THIS ROUTINE WAS MODIFIED FROM TEMPERTON"S ORIGINAL
C     BY DAVE FULKER.  IT NO LONGER PRODUCES FACTORS IN ASCENDING
C     ORDER, AND THERE ARE NONE OF THE ORIGINAL 'MODE' OPTIONS.
C
C ON INPUT     N
C               THE LENGTH OF EACH COMPLEX TRANSFORM TO BE PERFORMED
C
C               N MUST BE GREATER THAN 1 AND CONTAIN NO PRIME
C               FACTORS GREATER THAN 5.
C
C ON OUTPUT    IFAX
C               IFAX(1)
C                 THE NUMBER OF FACTORS CHOSEN OR -99 IN CASE OF ERROR
C               IFAX(2) THRU IFAX( IFAX(1)+1 )
C                 THE FACTORS OF N IN THE FOLLOWIN ORDER:  APPEARING
C                 FIRST ARE AS MANY FACTORS OF 4 AS CAN BE OBTAINED.
C                 SUBSEQUENT FACTORS ARE PRIMES, AND APPEAR IN
C                 ASCENDING ORDER, EXCEPT FOR MULTIPLE FACTORS.
C
C              TRIGS
C               2N SIN AND COS VALUES FOR USE BY THE TRANSFORM ROUTINE
C
      CALL FACT(N,IFAX)
      K = IFAX(1)
      IF (K .LT. 1 .OR. IFAX(K+1) .GT. 5) IFAX(1) = -99
C     IF (IFAX(1) .LE. 0 )CALL ABORT  ***ABORT NOT ANSI
      IF (IFAX(1) .LE. 0) STOP 'ABORT'
      CALL CFTRIG (N, TRIGS)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
      SUBROUTINE CFTRIG(N,TRIGS)
      DIMENSION TRIGS(2,N)
      REAL ANGLE1 (:)
C     PI=2.0*ASIN(1.0)
      DEL=(4.*ASIN(1.))/FLOAT(N)
cD       call start_interval( 44 )
        ALLOCATE (ANGLE1(N))
        ANGLE1(1:$N) = [1 :$ N] * DEL
        TRIGS(1,1:$N) = COS (ANGLE1(1:$N))
        TRIGS(2,1:$N) = SIN (ANGLE1(1:$N))
        DEALLOCATE (ANGLE1)
cD       call end_interval( 44 )
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
 
      SUBROUTINE CPASS (A,B,C,D,TRIGS,INC1,INC2,INC3,INC4,LOT,N,IFAC,LA)
      DIMENSION A(N),B(N),C(N),D(N),TRIGS(N)
C
C     SUBROUTINE "CPASS" - MULTIPLE VERSION OF "CPASSA"
C     PERFORMS ONE PASS THROUGH DATA
C     AS PART OF MULTIPLE COMPLEX (INVERSE) FFT ROUTINE
C     A IS FIRST REAL INPUT VECTOR
C     B IS FIRST IMAGINARY INPUT VECTOR
C     C IS FIRST REAL OUTPUT VECTOR
C     D IS FIRST IMAGINARY OUTPUT VECTOR
C     TRIGS IS PRECALCULATED TABLE OF SINES & COSINES
C     INC1 IS ADDRESSING INCREMENT FOR A AND B
C*$*       ASSERT RELATION (INC1.GT.0)
C     INC2 IS ADDRESSING INCREMENT FOR C AND D
C*$*       ASSERT RELATION (INC2.GT.0)
C     INC3 IS ADDRESSING INCREMENT BETWEEN A"S & B"S
C*$*       ASSERT RELATION (INC3.GT.0)
C     INC4 IS ADDRESSING INCREMENT BETWEEN C"S & D"S
C*$*       ASSERT RELATION (INC4.GT.0)
C     LOT IS THE NUMBER OF VECTORS
C     N IS LENGTH OF VECTORS
C*$*       ASSERT RELATION (N.GT.0)
C     IFAC IS CURRENT FACTOR OF N
C*$*       ASSERT RELATION (N.GE.IFAC)
C*$*       ASSERT RELATION (IFAC.GT.0)
C     LA IS PRODUCT OF PREVIOUS FACTORS
C*$*       ASSERT RELATION (LA.GT.0)
      INTEGER II1, II2, II3, II4, II5, II6, II7, II8, II9, II10, II11,
     X  II12, II13, II14, II15, II16, II17, II18, II19, II20, II21, II22
     X  , II23, II24, II25, II26, II27, II28, II29, II30, II31, II32, K1
     X  , K2, II33, II34, II35, II36
C
      DATA SIN36/0.587785252292473/,COS36/0.809016994374947/,
     *     SIN72/0.951056516295154/,COS72/0.309016994374947/,
     *     SIN60/0.866025403784437/
C
      M=N/IFAC
      IINK=M*INC1
      JINK=LA*INC2
      JUMP=(IFAC-1)*JINK
      IBASE=0
      JBASE=0
      GO TO (10,10,50,90,130),IFAC
      RETURN
C
C     CODING FOR FACTOR 2
C
   10 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
cD       call start_interval( 28 )
D        call trace_enter (2005) 
      DO 20 L=1,LA
CDIR$ IVDEP
      C(JA+JBASE:$LOT:INC4) = A(IA+IBASE:$LOT:INC3) + A(IB+IBASE:$LOT:INC3)
      D(JA+JBASE:$LOT:INC4) = B(IA+IBASE:$LOT:INC3) + B(IB+IBASE:$LOT:INC3)
      C(JB+JBASE:$LOT:INC4) = A(IA+IBASE:$LOT:INC3) - A(IB+IBASE:$LOT:INC3)
      D(JB+JBASE:$LOT:INC4) = B(IA+IBASE:$LOT:INC3) - B(IB+IBASE:$LOT:INC3)
      IBASE = IBASE + INC1
      JBASE = JBASE + INC2
   20 CONTINUE
cD       call end_interval( 28 )
D        call trace_exit (2006) 
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
cD       call start_interval( 29 )
        II6 = JBASE
        II5 = IBASE
      K1 = LA + 1
      K2 = (N / IFAC - 1) / LA
      II33 = (-1)
D        call trace_enter (2007) 
      DO 40 K=K1,K1+((-1)+K2)*LA,LA
      II33 = II33 + 1
      KB=K+K-2
      C1 = TRIGS(KB+1)
      S1 = TRIGS(KB+2)
      DO 30 L=1,LA
      I = II5 + ((-1) + (L + LA * II33)) * INC1
      J = II6 + ((-1) + (L + LA * II33)) * INC2 + II33 * JUMP
CDIR$ IVDEP
      II7 = II6 + ((-1) + (L + LA * II33)) * INC2 + II33 *
     X  JUMP
      II8 = II5 + ((-1) + (L + LA * II33)) * INC1
      C(JA+II7:$LOT:INC4) = A(IA+II8:$LOT:INC3) + A(IB+II8:$LOT:INC3)
      D(JA+II7:$LOT:INC4) = B(IA+II8:$LOT:INC3) + B(IB+II8:$LOT:INC3)
      C(JB+II7:$LOT:INC4) = C1 * (A(IA+II8:$LOT:INC3) - A(IB+II8:$LOT:
     X  INC3)) - S1 * (B(IA+II8:$LOT:INC3) - B(IB+II8:$LOT:INC3))
      D(JB+II7:$LOT:INC4) = S1 * (A(IA+II8:$LOT:INC3) - A(IB+II8:$LOT:
     X  INC3)) + C1 * (B(IA+II8:$LOT:INC3) - B(IB+II8:$LOT:INC3))
      IBASE = II5 + ((-1) + (L + LA * II33)) * INC1 + INC1
      JBASE = II6 + ((-1) + (L + LA * II33)) * INC2 + II33 *
     X  JUMP + INC2
   30 CONTINUE
   40 CONTINUE
cD       call end_interval( 29 )
D        call trace_exit (2008) 
      RETURN
C
C     CODING FOR FACTOR 3
C
   50 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
cD       call start_interval( 30 )
        II10 = JBASE
        II9 = IBASE
D        call trace_enter (2009) 
      DO 60 L=1,LA
      I = II9 + ((-1) + L) * INC1
      J = II10 + ((-1) + L) * INC2
CDIR$ IVDEP
      II11 = II10 + ((-1) + L) * INC2
      II12 = II9 + ((-1) + L) * INC1
      C(JA+II11:$LOT:INC4) = A(IA+II12:$LOT:INC3) + (A(IB+II12:$LOT:INC3
     X  ) + A(IC+II12:$LOT:INC3))
      D(JA+II11:$LOT:INC4) = B(IA+II12:$LOT:INC3) + (B(IB+II12:$LOT:INC3
     X  ) + B(IC+II12:$LOT:INC3))
      C(JB+II11:$LOT:INC4) = (A(IA+II12:$LOT:INC3) - 0.5 * (A(IB+II12:$
     X  LOT:INC3) + A(IC+II12:$LOT:INC3))) - (SIN60 * (B(IB+II12:$LOT:
     X  INC3) - B(IC+II12:$LOT:INC3)))
      C(JC+II11:$LOT:INC4) = (A(IA+II12:$LOT:INC3) - 0.5 * (A(IB+II12:$
     X  LOT:INC3) + A(IC+II12:$LOT:INC3))) + (SIN60 * (B(IB+II12:$LOT:
     X  INC3) - B(IC+II12:$LOT:INC3)))
      D(JB+II11:$LOT:INC4) = (B(IA+II12:$LOT:INC3) - 0.5 * (B(IB+II12:$
     X  LOT:INC3) + B(IC+II12:$LOT:INC3))) + (SIN60 * (A(IB+II12:$LOT:
     X  INC3) - A(IC+II12:$LOT:INC3)))
      D(JC+II11:$LOT:INC4) = (B(IA+II12:$LOT:INC3) - 0.5 * (B(IB+II12:$
     X  LOT:INC3) + B(IC+II12:$LOT:INC3))) - (SIN60 * (A(IB+II12:$LOT:
     X  INC3) - A(IC+II12:$LOT:INC3)))
   60 CONTINUE
D        call trace_exit (2010) 
      IBASE = II9 + ((-1) + LA) * INC1 + INC1
      JBASE = II10 + ((-1) + LA) * INC2 + INC2
cD       call end_interval( 30 )
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
cD       call start_interval( 31 )
        II14 = JBASE
        II13 = IBASE
      K1 = LA + 1
      K2 = (N / IFAC - LA + LA - 1) / LA
      II34 = (-1)
D        call trace_enter (2011) 
      DO 80 K=K1,K1+((-1)+K2)*LA,LA
      II34 = II34 + 1
      KB=K+K-2
      KC = K + K - 2 + (K + K - 2)
      C1 = TRIGS(K+K-1)
      S1 = TRIGS(K+K)
      C2 = TRIGS(K+K+(K+K)-3)
      S2 = TRIGS(K+K+(K+K)-2)
      DO 70 L=1,LA
      I = II13 + ((-1) + (L + LA * II34)) * INC1
      J = II14 + ((-1) + (L + LA * II34)) * INC2 + II34 * JUMP
CDIR$ IVDEP
      II15 = II14 + ((-1) + (L + LA * II34)) * INC2 + II34 * (
     X  ((-1) + IFAC) * (LA * INC2))
      II16 = II13 + ((-1) + (L + LA * II34)) * INC1
      C(JA+II15:$LOT:INC4) = A(IA+II16:$LOT:INC3) + (A(IB+II16:$LOT:INC3
     X  ) + A(IC+II16:$LOT:INC3))
      D(JA+II15:$LOT:INC4) = B(IA+II16:$LOT:INC3) + (B(IB+II16:$LOT:INC3
     X  ) + B(IC+II16:$LOT:INC3))
      C(JB+II15:$LOT:INC4) = C1 * ((A(IA+II16:$LOT:INC3) - 0.5 * (A(IB+
     X   II16:$LOT:INC3) + A(IC+II16:$LOT:INC3))) - (SIN60 * (B(IB+II16
     X   :$LOT:INC3) - B(IC+II16:$LOT:INC3)))) - S1 * ((B(IA+II16:$LOT:
     X   INC3) - 0.5 * (B(IB+II16:$LOT:INC3) + B(IC+II16:$LOT:INC3))) +
     X   (SIN60 * (A(IB+II16:$LOT:INC3) - A(IC+II16:$LOT:INC3))))
      D(JB+II15:$LOT:INC4) = S1 * ((A(IA+II16:$LOT:INC3) - 0.5 * (A(IB+
     X   II16:$LOT:INC3) + A(IC+II16:$LOT:INC3))) - (SIN60 * (B(IB+II16
     X   :$LOT:INC3) - B(IC+II16:$LOT:INC3)))) + C1 * ((B(IA+II16:$LOT:
     X   INC3) - 0.5 * (B(IB+II16:$LOT:INC3) + B(IC+II16:$LOT:INC3))) +
     X   (SIN60 * (A(IB+II16:$LOT:INC3) - A(IC+II16:$LOT:INC3))))
      C(JC+II15:$LOT:INC4) = C2 * ((A(IA+II16:$LOT:INC3) - 0.5 * (A(IB+
     X   II16:$LOT:INC3) + A(IC+II16:$LOT:INC3))) + (SIN60 * (B(IB+II16
     X   :$LOT:INC3) - B(IC+II16:$LOT:INC3)))) - S2 * ((B(IA+II16:$LOT:
     X   INC3) - 0.5 * (B(IB+II16:$LOT:INC3) + B(IC+II16:$LOT:INC3))) -
     X   (SIN60 * (A(IB+II16:$LOT:INC3) - A(IC+II16:$LOT:INC3))))
      D(JC+II15:$LOT:INC4) = S2 * ((A(IA+II16:$LOT:INC3) - 0.5 * (A(IB+
     X   II16:$LOT:INC3) + A(IC+II16:$LOT:INC3))) + (SIN60 * (B(IB+II16
     X   :$LOT:INC3) - B(IC+II16:$LOT:INC3)))) + C2 * ((B(IA+II16:$LOT:
     X   INC3) - 0.5 * (B(IB+II16:$LOT:INC3) + B(IC+II16:$LOT:INC3))) -
     X   (SIN60 * (A(IB+II16:$LOT:INC3) - A(IC+II16:$LOT:INC3))))
      IBASE = II13 + ((-1) + (L + LA * II34)) * INC1 + INC1
      JBASE = II14 + ((-1) + (L + LA * II34)) * INC2 + II34 *
     X  JUMP + INC2
   70 CONTINUE
   80 CONTINUE
cD       call end_interval( 31 )
D        call trace_exit (2012) 
      RETURN
C
C     CODING FOR FACTOR 4
C
   90 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
      ID=IC+IINK
      JD=JC+JINK
cD       call start_interval( 32 )
        II18 = JBASE
        II17 = IBASE
D        call trace_enter (2013) 
      DO 100 L=1,LA
      I = II17 + ((-1) + L) * INC1
      J = II18 + ((-1) + L) * INC2
CDIR$ IVDEP
      II19 = II18 + ((-1) + L) * INC2
      II20 = II17 + ((-1) + L) * INC1
      C(JA+II19:$LOT:INC4) = (A(IA+II20:$LOT:INC3) + A(IC+II20:$LOT:INC3
     X  )) + (A(IB+II20:$LOT:INC3) + A(ID+II20:$LOT:INC3))
      C(JC+II19:$LOT:INC4) = (A(IA+II20:$LOT:INC3) + A(IC+II20:$LOT:INC3
     X  )) - (A(IB+II20:$LOT:INC3) + A(ID+II20:$LOT:INC3))
      D(JA+II19:$LOT:INC4) = (B(IA+II20:$LOT:INC3) + B(IC+II20:$LOT:INC3
     X  )) + (B(IB+II20:$LOT:INC3) + B(ID+II20:$LOT:INC3))
      D(JC+II19:$LOT:INC4) = (B(IA+II20:$LOT:INC3) + B(IC+II20:$LOT:INC3
     X  )) - (B(IB+II20:$LOT:INC3) + B(ID+II20:$LOT:INC3))
      C(JB+II19:$LOT:INC4) = (A(IA+II20:$LOT:INC3) - A(IC+II20:$LOT:INC3
     X  )) - (B(IB+II20:$LOT:INC3) - B(ID+II20:$LOT:INC3))
      C(JD+II19:$LOT:INC4) = (A(IA+II20:$LOT:INC3) - A(IC+II20:$LOT:INC3
     X  )) + (B(IB+II20:$LOT:INC3) - B(ID+II20:$LOT:INC3))
      D(JB+II19:$LOT:INC4) = (B(IA+II20:$LOT:INC3) - B(IC+II20:$LOT:INC3
     X  )) + (A(IB+II20:$LOT:INC3) - A(ID+II20:$LOT:INC3))
      D(JD+II19:$LOT:INC4) = (B(IA+II20:$LOT:INC3) - B(IC+II20:$LOT:INC3
     X  )) - (A(IB+II20:$LOT:INC3) - A(ID+II20:$LOT:INC3))
  100 CONTINUE
D        call trace_exit (2014) 
      IBASE = II17 + ((-1) + LA) * INC1 + INC1
      JBASE = II18 + ((-1) + LA) * INC2 + INC2
cD       call end_interval( 32 )
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
cD       call start_interval( 33 )
        II22 = JBASE
        II21 = IBASE
      K1 = LA + 1
      K2 = (N / IFAC - LA + LA - 1) / LA
      II35 = (-1)
D        call trace_enter (2015) 
      DO 120 K=K1,K1+((-1)+K2)*LA,LA
      II35 = II35 + 1
      KB=K+K-2
      KC = K + K - 2 + (K + K - 2)
      KD = K + K - 2 + (K + K - 2) + (K + K - 2)
      C1 = TRIGS(K+K-1)
      S1 = TRIGS(K+K)
      C2 = TRIGS(K+K+(K+K)-3)
      S2 = TRIGS(K+K+(K+K)-2)
      C3 = TRIGS(K+K+(K+K)+(K+K)-5)
      S3 = TRIGS(K+K+(K+K)+(K+K)-4)
      DO 110 L=1,LA
      I = II21 + ((-1) + (L + LA * II35)) * INC1
      J = II22 + ((-1) + (L + LA * II35)) * INC2 + II35 * JUMP
CDIR$ IVDEP
      II23 = II22 + ((-1) + (L + LA * II35)) * INC2 + II35 * (
     X  ((-1) + IFAC) * (LA * INC2))
      II24 = II21 + ((-1) + (L + LA * II35)) * INC1
      C(JA+II23:$LOT:INC4) = (A(IA+II24:$LOT:INC3) + A(IC+II24:$LOT:INC3
     X  )) + (A(IB+II24:$LOT:INC3) + A(ID+II24:$LOT:INC3))
      D(JA+II23:$LOT:INC4) = (B(IA+II24:$LOT:INC3) + B(IC+II24:$LOT:INC3
     X  )) + (B(IB+II24:$LOT:INC3) + B(ID+II24:$LOT:INC3))
      C(JC+II23:$LOT:INC4) = C2 * ((A(IA+II24:$LOT:INC3) + A(IC+II24:$
     X   LOT:INC3)) - (A(IB+II24:$LOT:INC3) + A(ID+II24:$LOT:INC3))) -
     X   S2 * ((B(IA+II24:$LOT:INC3) + B(IC+II24:$LOT:INC3)) - (B(IB+
     X   II24:$LOT:INC3) + B(ID+II24:$LOT:INC3)))
      D(JC+II23:$LOT:INC4) = S2 * ((A(IA+II24:$LOT:INC3) + A(IC+II24:$
     X   LOT:INC3)) - (A(IB+II24:$LOT:INC3) + A(ID+II24:$LOT:INC3))) +
     X   C2 * ((B(IA+II24:$LOT:INC3) + B(IC+II24:$LOT:INC3)) - (B(IB+
     X   II24:$LOT:INC3) + B(ID+II24:$LOT:INC3)))
      C(JB+II23:$LOT:INC4) = C1 * ((A(IA+II24:$LOT:INC3) - A(IC+II24:$
     X   LOT:INC3)) - (B(IB+II24:$LOT:INC3) - B(ID+II24:$LOT:INC3))) -
     X   S1 * ((B(IA+II24:$LOT:INC3) - B(IC+II24:$LOT:INC3)) + (A(IB+
     X   II24:$LOT:INC3) - A(ID+II24:$LOT:INC3)))
      D(JB+II23:$LOT:INC4) = S1 * ((A(IA+II24:$LOT:INC3) - A(IC+II24:$
     X   LOT:INC3)) - (B(IB+II24:$LOT:INC3) - B(ID+II24:$LOT:INC3))) +
     X   C1 * ((B(IA+II24:$LOT:INC3) - B(IC+II24:$LOT:INC3)) + (A(IB+
     X   II24:$LOT:INC3) - A(ID+II24:$LOT:INC3)))
      C(JD+II23:$LOT:INC4) = C3 * ((A(IA+II24:$LOT:INC3) - A(IC+II24:$
     X   LOT:INC3)) + (B(IB+II24:$LOT:INC3) - B(ID+II24:$LOT:INC3))) -
     X   S3 * ((B(IA+II24:$LOT:INC3) - B(IC+II24:$LOT:INC3)) - (A(IB+
     X   II24:$LOT:INC3) - A(ID+II24:$LOT:INC3)))
      D(JD+II23:$LOT:INC4) = S3 * ((A(IA+II24:$LOT:INC3) - A(IC+II24:$
     X   LOT:INC3)) + (B(IB+II24:$LOT:INC3) - B(ID+II24:$LOT:INC3))) +
     X   C3 * ((B(IA+II24:$LOT:INC3) - B(IC+II24:$LOT:INC3)) - (A(IB+
     X   II24:$LOT:INC3) - A(ID+II24:$LOT:INC3)))
      IBASE = II21 + ((-1) + (L + LA * II35)) * INC1 + INC1
      JBASE = II22 + ((-1) + (L + LA * II35)) * INC2 + II35 *
     X  JUMP + INC2
  110 CONTINUE
  120 CONTINUE
cD       call end_interval( 33 )
D        call trace_exit (2016) 
      RETURN
C
C     CODING FOR FACTOR 5
C
  130 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
      ID=IC+IINK
      JD=JC+JINK
      IE=ID+IINK
      JE=JD+JINK
cD       call start_interval( 34 )
        II26 = JBASE
        II25 = IBASE
D        call trace_enter (2017) 
      DO 140 L=1,LA
      I = II25 + ((-1) + L) * INC1
      J = II26 + ((-1) + L) * INC2
CDIR$ IVDEP
      II27 = II26 + ((-1) + L) * INC2
      II28 = II25 + ((-1) + L) * INC1
      C(JA+II27:$LOT:INC4) = A(IA+II28:$LOT:INC3) + (A(IB+II28:$LOT:INC3
     X  ) + A(IE+II28:$LOT:INC3)) + (A(IC+II28:$LOT:INC3) + A(ID+II28:$
     X  LOT:INC3))
      D(JA+II27:$LOT:INC4) = B(IA+II28:$LOT:INC3) + (B(IB+II28:$LOT:INC3
     X  ) + B(IE+II28:$LOT:INC3)) + (B(IC+II28:$LOT:INC3) + B(ID+II28:$
     X  LOT:INC3))
      C(JB+II27:$LOT:INC4) = (A(IA+II28:$LOT:INC3) + COS72 * (A(IB+II28
     X  :$LOT:INC3) + A(IE+II28:$LOT:INC3)) - COS36 * (A(IC+II28:$LOT:
     X  INC3) + A(ID+II28:$LOT:INC3))) - (SIN72 * (B(IB+II28:$LOT:INC3)
     X  - B(IE+II28:$LOT:INC3)) + SIN36 * (B(IC+II28:$LOT:INC3) - B(ID+
     X  II28:$LOT:INC3)))
      C(JE+II27:$LOT:INC4) = (A(IA+II28:$LOT:INC3) + COS72 * (A(IB+II28
     X  :$LOT:INC3) + A(IE+II28:$LOT:INC3)) - COS36 * (A(IC+II28:$LOT:
     X  INC3) + A(ID+II28:$LOT:INC3))) + (SIN72 * (B(IB+II28:$LOT:INC3)
     X  - B(IE+II28:$LOT:INC3)) + SIN36 * (B(IC+II28:$LOT:INC3) - B(ID+
     X  II28:$LOT:INC3)))
      D(JB+II27:$LOT:INC4) = (B(IA+II28:$LOT:INC3) + COS72 * (B(IB+II28
     X  :$LOT:INC3) + B(IE+II28:$LOT:INC3)) - COS36 * (B(IC+II28:$LOT:
     X  INC3) + B(ID+II28:$LOT:INC3))) + (SIN72 * (A(IB+II28:$LOT:INC3)
     X  - A(IE+II28:$LOT:INC3)) + SIN36 * (A(IC+II28:$LOT:INC3) - A(ID+
     X  II28:$LOT:INC3)))
      D(JE+II27:$LOT:INC4) = (B(IA+II28:$LOT:INC3) + COS72 * (B(IB+II28
     X  :$LOT:INC3) + B(IE+II28:$LOT:INC3)) - COS36 * (B(IC+II28:$LOT:
     X  INC3) + B(ID+II28:$LOT:INC3))) - (SIN72 * (A(IB+II28:$LOT:INC3)
     X  - A(IE+II28:$LOT:INC3)) + SIN36 * (A(IC+II28:$LOT:INC3) - A(ID+
     X  II28:$LOT:INC3)))
      C(JC+II27:$LOT:INC4) = (A(IA+II28:$LOT:INC3) - COS36 * (A(IB+II28
     X  :$LOT:INC3) + A(IE+II28:$LOT:INC3)) + COS72 * (A(IC+II28:$LOT:
     X  INC3) + A(ID+II28:$LOT:INC3))) - (SIN36 * (B(IB+II28:$LOT:INC3)
     X  - B(IE+II28:$LOT:INC3)) - SIN72 * (B(IC+II28:$LOT:INC3) - B(ID+
     X  II28:$LOT:INC3)))
      C(JD+II27:$LOT:INC4) = (A(IA+II28:$LOT:INC3) - COS36 * (A(IB+II28
     X  :$LOT:INC3) + A(IE+II28:$LOT:INC3)) + COS72 * (A(IC+II28:$LOT:
     X  INC3) + A(ID+II28:$LOT:INC3))) + (SIN36 * (B(IB+II28:$LOT:INC3)
     X  - B(IE+II28:$LOT:INC3)) - SIN72 * (B(IC+II28:$LOT:INC3) - B(ID+
     X  II28:$LOT:INC3)))
      D(JC+II27:$LOT:INC4) = (B(IA+II28:$LOT:INC3) - COS36 * (B(IB+II28
     X  :$LOT:INC3) + B(IE+II28:$LOT:INC3)) + COS72 * (B(IC+II28:$LOT:
     X  INC3) + B(ID+II28:$LOT:INC3))) + (SIN36 * (A(IB+II28:$LOT:INC3)
     X  - A(IE+II28:$LOT:INC3)) - SIN72 * (A(IC+II28:$LOT:INC3) - A(ID+
     X  II28:$LOT:INC3)))
      D(JD+II27:$LOT:INC4) = (B(IA+II28:$LOT:INC3) - COS36 * (B(IB+II28
     X  :$LOT:INC3) + B(IE+II28:$LOT:INC3)) + COS72 * (B(IC+II28:$LOT:
     X  INC3) + B(ID+II28:$LOT:INC3))) - (SIN36 * (A(IB+II28:$LOT:INC3)
     X  - A(IE+II28:$LOT:INC3)) - SIN72 * (A(IC+II28:$LOT:INC3) - A(ID+
     X  II28:$LOT:INC3)))
  140 CONTINUE
D        call trace_exit (2018) 
      IBASE = II25 + ((-1) + LA) * INC1 + INC1
      JBASE = II26 + ((-1) + LA) * INC2 + INC2
cD       call end_interval( 34 )
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
cD       call start_interval( 35 )
        II30 = JBASE
        II29 = IBASE
      K1 = LA + 1
      K2 = (N / IFAC - LA + LA - 1) / LA
      II36 = (-1)
D        call trace_enter (2019) 
      DO 160 K=K1,K1+((-1)+K2)*LA,LA
      II36 = II36 + 1
      KB=K+K-2
      KC = K + K - 2 + (K + K - 2)
      KD = K + K - 2 + (K + K - 2) + (K + K - 2)
      KE = K + K - 2 + (K + K - 2) + (K + K - 2) + (K + K - 2)
      C1 = TRIGS(K+K-1)
      S1 = TRIGS(K+K)
      C2 = TRIGS(K+K+(K+K)-3)
      S2 = TRIGS(K+K+(K+K)-2)
      C3 = TRIGS(K+K+(K+K)+(K+K)-5)
      S3 = TRIGS(K+K+(K+K)+(K+K)-4)
      C4 = TRIGS(K+K+(K+K)+(K+K)+(K+K)-7)
      S4 = TRIGS(K+K+(K+K)+(K+K)+(K+K)-6)
      DO 150 L=1,LA
      I = II29 + ((-1) + (L + LA * II36)) * INC1
      J = II30 + ((-1) + (L + LA * II36)) * INC2 + II36 * JUMP
CDIR$ IVDEP
      II31 = II30 + ((-1) + (L + LA * II36)) * INC2 + II36 * (
     X  ((-1) + IFAC) * (LA * INC2))
      II32 = II29 + ((-1) + (L + LA * II36)) * INC1
      C(JA+II31:$LOT:INC4) = A(IA+II32:$LOT:INC3) + (A(IB+II32:$LOT:INC3
     X  ) + A(IE+II32:$LOT:INC3)) + (A(IC+II32:$LOT:INC3) + A(ID+II32:$
     X  LOT:INC3))
      D(JA+II31:$LOT:INC4) = B(IA+II32:$LOT:INC3) + (B(IB+II32:$LOT:INC3
     X  ) + B(IE+II32:$LOT:INC3)) + (B(IC+II32:$LOT:INC3) + B(ID+II32:$
     X  LOT:INC3))
      C(JB+II31:$LOT:INC4) = C1 * ((A(IA+II32:$LOT:INC3) + COS72 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) - COS36 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) - (SIN72 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) + SIN36 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) - S1 * ((B(IA+II32:$
     X      LOT:INC3) + COS72 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) - COS36 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) + (SIN72 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       + SIN36 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      D(JB+II31:$LOT:INC4) = S1 * ((A(IA+II32:$LOT:INC3) + COS72 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) - COS36 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) - (SIN72 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) + SIN36 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) + C1 * ((B(IA+II32:$
     X      LOT:INC3) + COS72 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) - COS36 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) + (SIN72 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       + SIN36 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      C(JE+II31:$LOT:INC4) = C4 * ((A(IA+II32:$LOT:INC3) + COS72 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) - COS36 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) + (SIN72 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) + SIN36 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) - S4 * ((B(IA+II32:$
     X      LOT:INC3) + COS72 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) - COS36 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) - (SIN72 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       + SIN36 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      D(JE+II31:$LOT:INC4) = S4 * ((A(IA+II32:$LOT:INC3) + COS72 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) - COS36 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) + (SIN72 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) + SIN36 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) + C4 * ((B(IA+II32:$
     X      LOT:INC3) + COS72 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) - COS36 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) - (SIN72 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       + SIN36 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      C(JC+II31:$LOT:INC4) = C2 * ((A(IA+II32:$LOT:INC3) - COS36 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) + COS72 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) - (SIN36 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) - SIN72 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) - S2 * ((B(IA+II32:$
     X      LOT:INC3) - COS36 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) + COS72 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) + (SIN36 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       - SIN72 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      D(JC+II31:$LOT:INC4) = S2 * ((A(IA+II32:$LOT:INC3) - COS36 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) + COS72 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) - (SIN36 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) - SIN72 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) + C2 * ((B(IA+II32:$
     X      LOT:INC3) - COS36 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) + COS72 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) + (SIN36 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       - SIN72 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      C(JD+II31:$LOT:INC4) = C3 * ((A(IA+II32:$LOT:INC3) - COS36 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) + COS72 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) + (SIN36 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) - SIN72 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) - S3 * ((B(IA+II32:$
     X      LOT:INC3) - COS36 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) + COS72 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) - (SIN36 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       - SIN72 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      D(JD+II31:$LOT:INC4) = S3 * ((A(IA+II32:$LOT:INC3) - COS36 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) + COS72 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) + (SIN36 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) - SIN72 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) + C3 * ((B(IA+II32:$
     X      LOT:INC3) - COS36 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) + COS72 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) - (SIN36 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       - SIN72 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      IBASE = II29 + ((-1) + (L + LA * II36)) * INC1 + INC1
      JBASE = II30 + ((-1) + (L + LA * II36)) * INC2 + II36 *
     X  JUMP + INC2
  150 CONTINUE
  160 CONTINUE
cD       call end_interval( 35 )
D        call trace_exit (2020) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
 
      SUBROUTINE CPASSM(A,B,C,D,TRIGS,INC1,INC2,INC3,INC4,LOT,N,IFAC,LA)
      DIMENSION A(N),B(N),C(N),D(N),TRIGS(N)
C
C     SUBROUTINE "CPASSM" - MULTIPLE VERSION
C     PERFORMS ONE PASS THROUGH DATA
C     AS PART OF MULTIPLE COMPLEX (INVERSE) FFT ROUTINE
C     A IS FIRST REAL INPUT VECTOR
C     B IS FIRST IMAGINARY INPUT VECTOR
C     C IS FIRST REAL OUTPUT VECTOR
C     D IS FIRST IMAGINARY OUTPUT VECTOR
C     TRIGS IS PRECALCULATED TABLE OF SINES & COSINES
C     INC1 IS ADDRESSING INCREMENT FOR A AND B
C*$* ASSERT RELATION (INC1.GT.0)
C     INC2 IS ADDRESSING INCREMENT FOR C AND D
C*$* ASSERT RELATION (INC2.GT.0)
C     INC3 IS ADDRESSING INCREMENT BETWEEN A"S & B"S
C*$* ASSERT RELATION (INC3.GT.0)
C     INC4 IS ADDRESSING INCREMENT BETWEEN C"S & D"S
C*$* ASSERT RELATION (INC4.GT.0)
C     LOT IS THE NUMBER OF VECTORS
C     N IS LENGTH OF VECTORS
C*$* ASSERT RELATION (N.GT.0)
C     IFAC IS CURRENT FACTOR OF N
C*$* ASSERT RELATION (N.GE.IFAC)
C*$* ASSERT RELATION (IFAC.GT.0)
C     LA IS PRODUCT OF PREVIOUS FACTORS
C*$* ASSERT RELATION (LA.GT.0)
      INTEGER II1, II2, II3, II4, II5, II6, II7, II8, II9, II10, II11,
     X  II12, II13, II14, II15, II16, II17, II18, II19, II20, II21, II22
     X  , II23, II24, II25, II26, II27, II28, II29, II30, II31, II32, K1
     X  , K2, II33, II34, II35, II36
C
      DATA SIN36/-0.587785252292473/,COS36/0.809016994374947/,
     *     SIN72/-0.951056516295154/,COS72/0.309016994374947/,
     *     SIN60/-0.866025403784437/
C
      M=N/IFAC
      IINK=M*INC1
      JINK=LA*INC2
      JUMP=(IFAC-1)*JINK
      IBASE=0
      JBASE=0
      GO TO (10,10,50,90,130),IFAC
      RETURN
C
C     CODING FOR FACTOR 2
C
   10 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
cD       call start_interval( 36 )
        II2 = JBASE
        II1 = IBASE
D        call trace_enter (2021) 
      DO 20 L=1,LA
        I = II1 + ((-1) + L) * INC1
        J = II2 + ((-1) + L) * INC2
CDIR$ IVDEP
        II3 = II2 + ((-1) + L) * INC2
        II4 = II1 + ((-1) + L) * INC1
          C(JA+II3:$LOT:INC4) = A(IA+II4:$LOT:INC3) + A(IB+II4:$LOT:INC3
     X      )
          D(JA+II3:$LOT:INC4) = B(IA+II4:$LOT:INC3) + B(IB+II4:$LOT:INC3
     X      )
          C(JB+II3:$LOT:INC4) = A(IA+II4:$LOT:INC3) - A(IB+II4:$LOT:INC3
     X      )
          D(JB+II3:$LOT:INC4) = B(IA+II4:$LOT:INC3) - B(IB+II4:$LOT:INC3
     X      )
 20   CONTINUE
D        call trace_exit (2022) 
        IBASE = II1 + ((-1) + LA) * INC1 + INC1
        JBASE = II2 + ((-1) + LA) * INC2 + INC2
cD       call end_interval( 36 )
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
cD       call start_interval( 37 )
        II6 = JBASE
        II5 = IBASE
      K1 = LA + 1
      K2 = (N / IFAC - LA + LA - 1) / LA
      II33 = (-1)
D        call trace_enter (2023) 
      DO 40 K=K1,K1+((-1)+K2)*LA,LA
      II33 = II33 + 1
        KB=K+K-2
        C1 = TRIGS(K+K-1)
        S1 = -TRIGS(K+K)
        DO 30 L=1,LA
          I = II5 + ((-1) + (L + LA * II33)) * INC1
          J = II6 + ((-1) + (L + LA * II33)) * INC2 + II33 *
     X      JUMP
CDIR$ IVDEP
          II7 = II6 + ((-1) + (L + LA * II33)) * INC2 + II33 *
     X       JUMP
          II8 = II5 + ((-1) + (L + LA * II33)) * INC1
            C(JA+II7:$LOT:INC4) = A(IA+II8:$LOT:INC3) + A(IB+II8:$LOT:
     X        INC3)
            D(JA+II7:$LOT:INC4) = B(IA+II8:$LOT:INC3) + B(IB+II8:$LOT:
     X        INC3)
            C(JB+II7:$LOT:INC4) = C1 * (A(IA+II8:$LOT:INC3) - A(IB+II8:$
     X        LOT:INC3)) - S1 * (B(IA+II8:$LOT:INC3) - B(IB+II8:$LOT:
     X        INC3))
            D(JB+II7:$LOT:INC4) = S1 * (A(IA+II8:$LOT:INC3) - A(IB+II8:$
     X        LOT:INC3)) + C1 * (B(IA+II8:$LOT:INC3) - B(IB+II8:$LOT:
     X        INC3))
          IBASE = II5 + ((-1) + (L + LA * II33)) * INC1 + INC1
          JBASE = II6 + ((-1) + (L + LA * II33)) * INC2 + II33
     X       * JUMP + INC2
 30     CONTINUE
 40   CONTINUE
cD       call end_interval( 37 )
D        call trace_exit (2024) 
      RETURN
C
C     CODING FOR FACTOR 3
C
   50 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
cD       call start_interval( 38 )
        II10 = JBASE
        II9 = IBASE
D        call trace_enter (2025) 
      DO 60 L=1,LA
      I = II9 + ((-1) + L) * INC1
      J = II10 + ((-1) + L) * INC2
CDIR$ IVDEP
      II11 = II10 + ((-1) + L) * INC2
      II12 = II9 + ((-1) + L) * INC1
      C(JA+II11:$LOT:INC4) = A(IA+II12:$LOT:INC3) + (A(IB+II12:$LOT:INC3
     X  ) + A(IC+II12:$LOT:INC3))
      D(JA+II11:$LOT:INC4) = B(IA+II12:$LOT:INC3) + (B(IB+II12:$LOT:INC3
     X  ) + B(IC+II12:$LOT:INC3))
      C(JB+II11:$LOT:INC4) = (A(IA+II12:$LOT:INC3) - 0.5 * (A(IB+II12:$
     X  LOT:INC3) + A(IC+II12:$LOT:INC3))) - (SIN60 * (B(IB+II12:$LOT:
     X  INC3) - B(IC+II12:$LOT:INC3)))
      C(JC+II11:$LOT:INC4) = (A(IA+II12:$LOT:INC3) - 0.5 * (A(IB+II12:$
     X  LOT:INC3) + A(IC+II12:$LOT:INC3))) + (SIN60 * (B(IB+II12:$LOT:
     X  INC3) - B(IC+II12:$LOT:INC3)))
      D(JB+II11:$LOT:INC4) = (B(IA+II12:$LOT:INC3) - 0.5 * (B(IB+II12:$
     X  LOT:INC3) + B(IC+II12:$LOT:INC3))) + (SIN60 * (A(IB+II12:$LOT:
     X  INC3) - A(IC+II12:$LOT:INC3)))
      D(JC+II11:$LOT:INC4) = (B(IA+II12:$LOT:INC3) - 0.5 * (B(IB+II12:$
     X  LOT:INC3) + B(IC+II12:$LOT:INC3))) - (SIN60 * (A(IB+II12:$LOT:
     X  INC3) - A(IC+II12:$LOT:INC3)))
   60 CONTINUE
D        call trace_exit (2026) 
      IBASE = II9 + ((-1) + LA) * INC1 + INC1
      JBASE = II10 + ((-1) + LA) * INC2 + INC2
cD       call end_interval( 38 )
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
cD       call start_interval( 39 )
        II14 = JBASE
        II13 = IBASE
      K1 = LA + 1
      K2 = (N / IFAC - LA + LA - 1) / LA
      II34 = (-1)
D        call trace_enter (2027) 
      DO 80 K=K1,K1+((-1)+K2)*LA,LA
      II34 = II34 + 1
      KB=K+K-2
      KC = K + K - 2 + (K + K - 2)
      C1 = TRIGS(K+K-1)
      S1 = -TRIGS(K+K)
      C2 = TRIGS(K+K+(K+K)-3)
      S2 = -TRIGS(K+K+(K+K)-2)
      DO 70 L=1,LA
      I = II13 + ((-1) + (L + LA * II34)) * INC1
      J = II14 + ((-1) + (L + LA * II34)) * INC2 + II34 * JUMP
CDIR$ IVDEP
      II15 = II14 + ((-1) + (L + LA * II34)) * INC2 + II34 * (
     X  ((-1) + IFAC) * (LA * INC2))
      II16 = II13 + ((-1) + (L + LA * II34)) * INC1
      C(JA+II15:$LOT:INC4) = A(IA+II16:$LOT:INC3) + (A(IB+II16:$LOT:INC3
     X  ) + A(IC+II16:$LOT:INC3))
      D(JA+II15:$LOT:INC4) = B(IA+II16:$LOT:INC3) + (B(IB+II16:$LOT:INC3
     X  ) + B(IC+II16:$LOT:INC3))
      C(JB+II15:$LOT:INC4) = C1 * ((A(IA+II16:$LOT:INC3) - 0.5 * (A(IB+
     X   II16:$LOT:INC3) + A(IC+II16:$LOT:INC3))) - (SIN60 * (B(IB+II16
     X   :$LOT:INC3) - B(IC+II16:$LOT:INC3)))) - S1 * ((B(IA+II16:$LOT:
     X   INC3) - 0.5 * (B(IB+II16:$LOT:INC3) + B(IC+II16:$LOT:INC3))) +
     X   (SIN60 * (A(IB+II16:$LOT:INC3) - A(IC+II16:$LOT:INC3))))
      D(JB+II15:$LOT:INC4) = S1 * ((A(IA+II16:$LOT:INC3) - 0.5 * (A(IB+
     X   II16:$LOT:INC3) + A(IC+II16:$LOT:INC3))) - (SIN60 * (B(IB+II16
     X   :$LOT:INC3) - B(IC+II16:$LOT:INC3)))) + C1 * ((B(IA+II16:$LOT:
     X   INC3) - 0.5 * (B(IB+II16:$LOT:INC3) + B(IC+II16:$LOT:INC3))) +
     X   (SIN60 * (A(IB+II16:$LOT:INC3) - A(IC+II16:$LOT:INC3))))
      C(JC+II15:$LOT:INC4) = C2 * ((A(IA+II16:$LOT:INC3) - 0.5 * (A(IB+
     X   II16:$LOT:INC3) + A(IC+II16:$LOT:INC3))) + (SIN60 * (B(IB+II16
     X   :$LOT:INC3) - B(IC+II16:$LOT:INC3)))) - S2 * ((B(IA+II16:$LOT:
     X   INC3) - 0.5 * (B(IB+II16:$LOT:INC3) + B(IC+II16:$LOT:INC3))) -
     X   (SIN60 * (A(IB+II16:$LOT:INC3) - A(IC+II16:$LOT:INC3))))
      D(JC+II15:$LOT:INC4) = S2 * ((A(IA+II16:$LOT:INC3) - 0.5 * (A(IB+
     X   II16:$LOT:INC3) + A(IC+II16:$LOT:INC3))) + (SIN60 * (B(IB+II16
     X   :$LOT:INC3) - B(IC+II16:$LOT:INC3)))) + C2 * ((B(IA+II16:$LOT:
     X   INC3) - 0.5 * (B(IB+II16:$LOT:INC3) + B(IC+II16:$LOT:INC3))) -
     X   (SIN60 * (A(IB+II16:$LOT:INC3) - A(IC+II16:$LOT:INC3))))
      IBASE = II13 + ((-1) + (L + LA * II34)) * INC1 + INC1
      JBASE = II14 + ((-1) + (L + LA * II34)) * INC2 + II34 *
     X  JUMP + INC2
   70 CONTINUE
   80 CONTINUE
cD       call end_interval( 39 )
D        call trace_exit (2028) 
      RETURN
C
C     CODING FOR FACTOR 4
C
   90 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
      ID=IC+IINK
      JD=JC+JINK
cD       call start_interval( 40 )
        II18 = JBASE
        II17 = IBASE
D        call trace_enter (2029) 
      DO 100 L=1,LA
      I = II17 + ((-1) + L) * INC1
      J = II18 + ((-1) + L) * INC2
CDIR$ IVDEP
      II19 = II18 + ((-1) + L) * INC2
      II20 = II17 + ((-1) + L) * INC1
      C(JA+II19:$LOT:INC4) = (A(IA+II20:$LOT:INC3) + A(IC+II20:$LOT:INC3
     X  )) + (A(IB+II20:$LOT:INC3) + A(ID+II20:$LOT:INC3))
      C(JC+II19:$LOT:INC4) = (A(IA+II20:$LOT:INC3) + A(IC+II20:$LOT:INC3
     X  )) - (A(IB+II20:$LOT:INC3) + A(ID+II20:$LOT:INC3))
      D(JA+II19:$LOT:INC4) = (B(IA+II20:$LOT:INC3) + B(IC+II20:$LOT:INC3
     X  )) + (B(IB+II20:$LOT:INC3) + B(ID+II20:$LOT:INC3))
      D(JC+II19:$LOT:INC4) = (B(IA+II20:$LOT:INC3) + B(IC+II20:$LOT:INC3
     X  )) - (B(IB+II20:$LOT:INC3) + B(ID+II20:$LOT:INC3))
      C(JB+II19:$LOT:INC4) = (A(IA+II20:$LOT:INC3) - A(IC+II20:$LOT:INC3
     X  )) + (B(IB+II20:$LOT:INC3) - B(ID+II20:$LOT:INC3))
      C(JD+II19:$LOT:INC4) = (A(IA+II20:$LOT:INC3) - A(IC+II20:$LOT:INC3
     X  )) - (B(IB+II20:$LOT:INC3) - B(ID+II20:$LOT:INC3))
      D(JB+II19:$LOT:INC4) = (B(IA+II20:$LOT:INC3) - B(IC+II20:$LOT:INC3
     X  )) - (A(IB+II20:$LOT:INC3) - A(ID+II20:$LOT:INC3))
      D(JD+II19:$LOT:INC4) = (B(IA+II20:$LOT:INC3) - B(IC+II20:$LOT:INC3
     X  )) + (A(IB+II20:$LOT:INC3) - A(ID+II20:$LOT:INC3))
  100 CONTINUE
D        call trace_exit (2030) 
      IBASE = II17 + ((-1) + LA) * INC1 + INC1
      JBASE = II18 + ((-1) + LA) * INC2 + INC2
cD       call end_interval( 40 )
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
cD       call start_interval( 41 )
        II22 = JBASE
        II21 = IBASE
      K1 = LA + 1
      K2 = (N / IFAC - LA + LA - 1) / LA
      II35 = (-1)
D        call trace_enter (2031) 
      DO 120 K=K1,K1+((-1)+K2)*LA,LA
      II35 = II35 + 1
      KB=K+K-2
      KC = K + K - 2 + (K + K - 2)
      KD = K + K - 2 + (K + K - 2) + (K + K - 2)
      C1 = TRIGS(K+K-1)
      S1 = -TRIGS(K+K)
      C2 = TRIGS(K+K+(K+K)-3)
      S2 = -TRIGS(K+K+(K+K)-2)
      C3 = TRIGS(K+K+(K+K)+(K+K)-5)
      S3 = -TRIGS(K+K+(K+K)+(K+K)-4)
      DO 110 L=1,LA
      I = II21 + ((-1) + (L + LA * II35)) * INC1
      J = II22 + ((-1) + (L + LA * II35)) * INC2 + II35 * JUMP
CDIR$ IVDEP
      II23 = II22 + ((-1) + (L + LA * II35)) * INC2 + II35 * (
     X  ((-1) + IFAC) * (LA * INC2))
      II24 = II21 + ((-1) + (L + LA * II35)) * INC1
      C(JA+II23:$LOT:INC4) = (A(IA+II24:$LOT:INC3) + A(IC+II24:$LOT:INC3
     X  )) + (A(IB+II24:$LOT:INC3) + A(ID+II24:$LOT:INC3))
      D(JA+II23:$LOT:INC4) = (B(IA+II24:$LOT:INC3) + B(IC+II24:$LOT:INC3
     X  )) + (B(IB+II24:$LOT:INC3) + B(ID+II24:$LOT:INC3))
      C(JC+II23:$LOT:INC4) = C2 * ((A(IA+II24:$LOT:INC3) + A(IC+II24:$
     X   LOT:INC3)) - (A(IB+II24:$LOT:INC3) + A(ID+II24:$LOT:INC3))) -
     X   S2 * ((B(IA+II24:$LOT:INC3) + B(IC+II24:$LOT:INC3)) - (B(IB+
     X   II24:$LOT:INC3) + B(ID+II24:$LOT:INC3)))
      D(JC+II23:$LOT:INC4) = S2 * ((A(IA+II24:$LOT:INC3) + A(IC+II24:$
     X   LOT:INC3)) - (A(IB+II24:$LOT:INC3) + A(ID+II24:$LOT:INC3))) +
     X   C2 * ((B(IA+II24:$LOT:INC3) + B(IC+II24:$LOT:INC3)) - (B(IB+
     X   II24:$LOT:INC3) + B(ID+II24:$LOT:INC3)))
      C(JB+II23:$LOT:INC4) = C1 * ((A(IA+II24:$LOT:INC3) - A(IC+II24:$
     X   LOT:INC3)) + (B(IB+II24:$LOT:INC3) - B(ID+II24:$LOT:INC3))) -
     X   S1 * ((B(IA+II24:$LOT:INC3) - B(IC+II24:$LOT:INC3)) - (A(IB+
     X   II24:$LOT:INC3) - A(ID+II24:$LOT:INC3)))
      D(JB+II23:$LOT:INC4) = S1 * ((A(IA+II24:$LOT:INC3) - A(IC+II24:$
     X   LOT:INC3)) + (B(IB+II24:$LOT:INC3) - B(ID+II24:$LOT:INC3))) +
     X   C1 * ((B(IA+II24:$LOT:INC3) - B(IC+II24:$LOT:INC3)) - (A(IB+
     X   II24:$LOT:INC3) - A(ID+II24:$LOT:INC3)))
      C(JD+II23:$LOT:INC4) = C3 * ((A(IA+II24:$LOT:INC3) - A(IC+II24:$
     X   LOT:INC3)) - (B(IB+II24:$LOT:INC3) - B(ID+II24:$LOT:INC3))) -
     X   S3 * ((B(IA+II24:$LOT:INC3) - B(IC+II24:$LOT:INC3)) + (A(IB+
     X   II24:$LOT:INC3) - A(ID+II24:$LOT:INC3)))
      D(JD+II23:$LOT:INC4) = S3 * ((A(IA+II24:$LOT:INC3) - A(IC+II24:$
     X   LOT:INC3)) - (B(IB+II24:$LOT:INC3) - B(ID+II24:$LOT:INC3))) +
     X   C3 * ((B(IA+II24:$LOT:INC3) - B(IC+II24:$LOT:INC3)) + (A(IB+
     X   II24:$LOT:INC3) - A(ID+II24:$LOT:INC3)))
      IBASE = II21 + ((-1) + (L + LA * II35)) * INC1 + INC1
      JBASE = II22 + ((-1) + (L + LA * II35)) * INC2 + II35 *
     X  JUMP + INC2
  110 CONTINUE
  120 CONTINUE
cD       call end_interval( 41 )
D        call trace_exit (2032) 
      RETURN
C
C     CODING FOR FACTOR 5
C
  130 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
      ID=IC+IINK
      JD=JC+JINK
      IE=ID+IINK
      JE=JD+JINK
cD       call start_interval( 42 )
        II26 = JBASE
        II25 = IBASE
D        call trace_enter (2033) 
      DO 140 L=1,LA
      I = II25 + ((-1) + L) * INC1
      J = II26 + ((-1) + L) * INC2
CDIR$ IVDEP
      II27 = II26 + ((-1) + L) * INC2
      II28 = II25 + ((-1) + L) * INC1
      C(JA+II27:$LOT:INC4) = A(IA+II28:$LOT:INC3) + (A(IB+II28:$LOT:INC3
     X  ) + A(IE+II28:$LOT:INC3)) + (A(IC+II28:$LOT:INC3) + A(ID+II28:$
     X  LOT:INC3))
      D(JA+II27:$LOT:INC4) = B(IA+II28:$LOT:INC3) + (B(IB+II28:$LOT:INC3
     X  ) + B(IE+II28:$LOT:INC3)) + (B(IC+II28:$LOT:INC3) + B(ID+II28:$
     X  LOT:INC3))
      C(JB+II27:$LOT:INC4) = (A(IA+II28:$LOT:INC3) + COS72 * (A(IB+II28
     X  :$LOT:INC3) + A(IE+II28:$LOT:INC3)) - COS36 * (A(IC+II28:$LOT:
     X  INC3) + A(ID+II28:$LOT:INC3))) - (SIN72 * (B(IB+II28:$LOT:INC3)
     X  - B(IE+II28:$LOT:INC3)) + SIN36 * (B(IC+II28:$LOT:INC3) - B(ID+
     X  II28:$LOT:INC3)))
      C(JE+II27:$LOT:INC4) = (A(IA+II28:$LOT:INC3) + COS72 * (A(IB+II28
     X  :$LOT:INC3) + A(IE+II28:$LOT:INC3)) - COS36 * (A(IC+II28:$LOT:
     X  INC3) + A(ID+II28:$LOT:INC3))) + (SIN72 * (B(IB+II28:$LOT:INC3)
     X  - B(IE+II28:$LOT:INC3)) + SIN36 * (B(IC+II28:$LOT:INC3) - B(ID+
     X  II28:$LOT:INC3)))
      D(JB+II27:$LOT:INC4) = (B(IA+II28:$LOT:INC3) + COS72 * (B(IB+II28
     X  :$LOT:INC3) + B(IE+II28:$LOT:INC3)) - COS36 * (B(IC+II28:$LOT:
     X  INC3) + B(ID+II28:$LOT:INC3))) + (SIN72 * (A(IB+II28:$LOT:INC3)
     X  - A(IE+II28:$LOT:INC3)) + SIN36 * (A(IC+II28:$LOT:INC3) - A(ID+
     X  II28:$LOT:INC3)))
      D(JE+II27:$LOT:INC4) = (B(IA+II28:$LOT:INC3) + COS72 * (B(IB+II28
     X  :$LOT:INC3) + B(IE+II28:$LOT:INC3)) - COS36 * (B(IC+II28:$LOT:
     X  INC3) + B(ID+II28:$LOT:INC3))) - (SIN72 * (A(IB+II28:$LOT:INC3)
     X  - A(IE+II28:$LOT:INC3)) + SIN36 * (A(IC+II28:$LOT:INC3) - A(ID+
     X  II28:$LOT:INC3)))
      C(JC+II27:$LOT:INC4) = (A(IA+II28:$LOT:INC3) - COS36 * (A(IB+II28
     X  :$LOT:INC3) + A(IE+II28:$LOT:INC3)) + COS72 * (A(IC+II28:$LOT:
     X  INC3) + A(ID+II28:$LOT:INC3))) - (SIN36 * (B(IB+II28:$LOT:INC3)
     X  - B(IE+II28:$LOT:INC3)) - SIN72 * (B(IC+II28:$LOT:INC3) - B(ID+
     X  II28:$LOT:INC3)))
      C(JD+II27:$LOT:INC4) = (A(IA+II28:$LOT:INC3) - COS36 * (A(IB+II28
     X  :$LOT:INC3) + A(IE+II28:$LOT:INC3)) + COS72 * (A(IC+II28:$LOT:
     X  INC3) + A(ID+II28:$LOT:INC3))) + (SIN36 * (B(IB+II28:$LOT:INC3)
     X  - B(IE+II28:$LOT:INC3)) - SIN72 * (B(IC+II28:$LOT:INC3) - B(ID+
     X  II28:$LOT:INC3)))
      D(JC+II27:$LOT:INC4) = (B(IA+II28:$LOT:INC3) - COS36 * (B(IB+II28
     X  :$LOT:INC3) + B(IE+II28:$LOT:INC3)) + COS72 * (B(IC+II28:$LOT:
     X  INC3) + B(ID+II28:$LOT:INC3))) + (SIN36 * (A(IB+II28:$LOT:INC3)
     X  - A(IE+II28:$LOT:INC3)) - SIN72 * (A(IC+II28:$LOT:INC3) - A(ID+
     X  II28:$LOT:INC3)))
      D(JD+II27:$LOT:INC4) = (B(IA+II28:$LOT:INC3) - COS36 * (B(IB+II28
     X  :$LOT:INC3) + B(IE+II28:$LOT:INC3)) + COS72 * (B(IC+II28:$LOT:
     X  INC3) + B(ID+II28:$LOT:INC3))) - (SIN36 * (A(IB+II28:$LOT:INC3)
     X  - A(IE+II28:$LOT:INC3)) - SIN72 * (A(IC+II28:$LOT:INC3) - A(ID+
     X  II28:$LOT:INC3)))
  140 CONTINUE
D        call trace_exit (2034) 
      IBASE = II25 + ((-1) + LA) * INC1 + INC1
      JBASE = II26 + ((-1) + LA) * INC2 + INC2
cD       call end_interval( 42 )
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
cD       call start_interval( 43 )
        II30 = JBASE
        II29 = IBASE
      K1 = LA + 1
      K2 = (N / IFAC - 1) / LA
      II36 = (-1)
D        call trace_enter (2035) 
      DO 160 K=K1,K1+((-1)+K2)*LA,LA
      II36 = II36 + 1
      KB=K+K-2
      KC = K + K - 2 + (K + K - 2)
      KD = K + K - 2 + (K + K - 2) + (K + K - 2)
      KE = K + K - 2 + (K + K - 2) + (K + K - 2) + (K + K - 2)
      C1 = TRIGS(K+K-1)
      S1 = -TRIGS(K+K)
      C2 = TRIGS(K+K+(K+K)-3)
      S2 = -TRIGS(K+K+(K+K)-2)
      C3 = TRIGS(K+K+(K+K)+(K+K)-5)
      S3 = -TRIGS(K+K+(K+K)+(K+K)-4)
      C4 = TRIGS(K+K+(K+K)+(K+K)+(K+K)-7)
      S4 = -TRIGS(K+K+(K+K)+(K+K)+(K+K)-6)
      DO 150 L=1,LA
      I = II29 + ((-1) + (L + LA * II36)) * INC1
      J = II30 + ((-1) + (L + LA * II36)) * INC2 + II36 * JUMP
CDIR$ IVDEP
      II31 = II30 + ((-1) + (L + LA * II36)) * INC2 + II36 * (
     X  ((-1) + IFAC) * (LA * INC2))
      II32 = II29 + ((-1) + (L + LA * II36)) * INC1
      C(JA+II31:$LOT:INC4) = A(IA+II32:$LOT:INC3) + (A(IB+II32:$LOT:INC3
     X  ) + A(IE+II32:$LOT:INC3)) + (A(IC+II32:$LOT:INC3) + A(ID+II32:$
     X  LOT:INC3))
      D(JA+II31:$LOT:INC4) = B(IA+II32:$LOT:INC3) + (B(IB+II32:$LOT:INC3
     X  ) + B(IE+II32:$LOT:INC3)) + (B(IC+II32:$LOT:INC3) + B(ID+II32:$
     X  LOT:INC3))
      C(JB+II31:$LOT:INC4) = C1 * ((A(IA+II32:$LOT:INC3) + COS72 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) - COS36 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) - (SIN72 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) + SIN36 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) - S1 * ((B(IA+II32:$
     X      LOT:INC3) + COS72 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) - COS36 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) + (SIN72 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       + SIN36 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      D(JB+II31:$LOT:INC4) = S1 * ((A(IA+II32:$LOT:INC3) + COS72 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) - COS36 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) - (SIN72 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) + SIN36 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) + C1 * ((B(IA+II32:$
     X      LOT:INC3) + COS72 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) - COS36 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) + (SIN72 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       + SIN36 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      C(JE+II31:$LOT:INC4) = C4 * ((A(IA+II32:$LOT:INC3) + COS72 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) - COS36 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) + (SIN72 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) + SIN36 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) - S4 * ((B(IA+II32:$
     X      LOT:INC3) + COS72 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) - COS36 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) - (SIN72 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       + SIN36 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      D(JE+II31:$LOT:INC4) = S4 * ((A(IA+II32:$LOT:INC3) + COS72 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) - COS36 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) + (SIN72 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) + SIN36 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) + C4 * ((B(IA+II32:$
     X      LOT:INC3) + COS72 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) - COS36 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) - (SIN72 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       + SIN36 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      C(JC+II31:$LOT:INC4) = C2 * ((A(IA+II32:$LOT:INC3) - COS36 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) + COS72 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) - (SIN36 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) - SIN72 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) - S2 * ((B(IA+II32:$
     X      LOT:INC3) - COS36 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) + COS72 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) + (SIN36 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       - SIN72 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      D(JC+II31:$LOT:INC4) = S2 * ((A(IA+II32:$LOT:INC3) - COS36 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) + COS72 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) - (SIN36 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) - SIN72 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) + C2 * ((B(IA+II32:$
     X      LOT:INC3) - COS36 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) + COS72 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) + (SIN36 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       - SIN72 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      C(JD+II31:$LOT:INC4) = C3 * ((A(IA+II32:$LOT:INC3) - COS36 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) + COS72 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) + (SIN36 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) - SIN72 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) - S3 * ((B(IA+II32:$
     X      LOT:INC3) - COS36 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) + COS72 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) - (SIN36 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       - SIN72 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      D(JD+II31:$LOT:INC4) = S3 * ((A(IA+II32:$LOT:INC3) - COS36 * (A(IB
     X      +II32:$LOT:INC3) + A(IE+II32:$LOT:INC3)) + COS72 * (A(IC+
     X      II32:$LOT:INC3) + A(ID+II32:$LOT:INC3))) + (SIN36 * (B(IB+
     X      II32:$LOT:INC3) - B(IE+II32:$LOT:INC3)) - SIN72 * (B(IC+II32
     X      :$LOT:INC3) - B(ID+II32:$LOT:INC3)))) + C3 * ((B(IA+II32:$
     X      LOT:INC3) - COS36 * (B(IB+II32:$LOT:INC3) + B(IE+II32:$LOT:
     X      INC3)) + COS72 * (B(IC+II32:$LOT:INC3) + B(ID+II32:$LOT:INC3
     X      ))) - (SIN36 * (A(IB+II32:$LOT:INC3) - A(IE+II32:$LOT:INC3))
     X       - SIN72 * (A(IC+II32:$LOT:INC3) - A(ID+II32:$LOT:INC3))))
      IBASE = II29 + ((-1) + (L + LA * II36)) * INC1 + INC1
      JBASE = II30 + ((-1) + (L + LA * II36)) * INC2 + II36 *
     X  JUMP + INC2
  150 CONTINUE
  160 CONTINUE
cD       call end_interval( 43 )
D        call trace_exit (2036) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
      SUBROUTINE CPUTIM(T)
      REAL T
      REAL*4 TARRAY(2),ETIME
      T=ETIME(TARRAY)
      T=TARRAY(1)
      RETURN
      END

C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
      SUBROUTINE DIFX(VIN,VOUT,AEQ,A,NNXT,NNYT,VEL,DZR)
      COMMON/FFT/TRIGX(1000),TRIGY(1000),IFAX(15),IFAY(15),RKX(400),
     .           RKY(400),RKXC(800),RKYC(800)
      DIMENSION VIN(NNXT,NNYT),VOUT(NNXT,NNYT),VEL(NNXT,NNYT)
      DIMENSION AEQ(NNXT,NNYT+2),A(NNXT,2,(NNYT+2)/2)
C gjx COMMON/WORK/WORK(20000)
      REAL TR1 (:)
      JC=(NNYT+1)/2
      JC2=JC*2
C     In APL:  A is NX (NY+2) take VIN  or (VIN,0),0
cD     call start_interval( 9 )
 2    AEQ(:, 1:$NNYT) = VIN
cD     call end_interval( 9 )
cD     call start_interval( 8 )
 1    AEQ(:, NNYT+1:$2) = 0.
cD     call end_interval( 8 )

cD     call start_interval( 10 )
D        call trace_enter (2037) 
      DO 600 IS=1,JC,64
        LN=MIN(64,JC-IS+1)
        CALL CFFT9X(A(1,1,IS),A(1,2,IS),TRIGX,IFAX,1,2*NNXT,NNXT,LN,-1)
 600  CONTINUE
cD     call end_interval( 10 )

cD     call start_interval( 11 )
D        call trace_exit (2038) 
      ALLOCATE (TR1(JC))
      IND = 1
D        call trace_enter (2039) 
      DO 105 I=1,NNXT
        TR1 = A(I,1,1:$JC)
        A(I,1,1:$JC) = TR1 * RKXC(IND)   - A(I,2,1:$JC) * RKXC(IND+1)
        A(I,2,1:$JC) = TR1 * RKXC(IND+1) + A(I,2,1:$JC) * RKXC(IND)
 105    IND = IND + 2
D        call trace_exit (2040) 
      DEALLOCATE (TR1)
cD     call end_interval( 11 )

cD     call start_interval( 12 )
D        call trace_enter (2041) 
      DO 700 IS=1,JC,64
        LN=MIN(64,JC-IS+1)
        CALL CFFT9X(A(1,1,IS),A(1,2,IS),TRIGX,IFAX,1,2*NNXT,NNXT,LN,1)
700   CONTINUE
cD     call end_interval( 12 )

cD     call start_interval( 13 )
D        call trace_exit (2042) 
      VOUT = VOUT - AEQ(:, 1:$NNYT) * VEL * DZR
cD     call end_interval( 13 )

      RETURN
      END

C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
      SUBROUTINE DIFY(VIN,VOUT,AEQ,A,NNXT,NNYT,VEL,DZR)
      COMMON/FFT/TRIGX(1000),TRIGY(1000),IFAX(15),IFAY(15),RKX(400),
     .           RKY(400),RKXC(800),RKYC(800)
      DIMENSION VIN(NNXT,NNYT),VOUT(NNXT,NNYT),VEL(NNXT,NNYT)
      DIMENSION AEQ(2*((NNXT+1)/2),NNYT),A(2,(NNXT+1)/2,NNYT)
C gjx COMMON/WORK/WORK(20000)
      REAL TR1 (:)
      JC=(NNXT+1)/2
      JC2=JC*2

cD     call start_interval( 14 )
 1    AEQ = 0.
cD     call end_interval( 14 )

cD     call start_interval( 15 )
D        call trace_enter (2043) 
      DO 2 NY=1,NNYT
 2      AEQ(1:$NNXT,NY) = VIN(1:$NNXT,NY)
cD     call end_interval( 15 )

cD     call start_interval( 16 )
D        call trace_exit (2044) 
D        call trace_enter (2045) 
      DO 600 IS=1,JC,64
        LN=MIN(64,JC-IS+1)
        CALL CFFT9X(A(1,IS,1),A(2,IS,1),TRIGY,IFAY,JC2,2,NNYT,LN,-1)
 600  CONTINUE
cD     call end_interval( 16 )

cD     call start_interval( 17 )
D        call trace_exit (2046) 
      ALLOCATE (TR1(JC))
      IND = 1
D        call trace_enter (2047) 
      DO 105 J=1,NNYT
        TR1 = A(1,:,J)
        A(1,:,J) = TR1 * RKYC(IND) - A(2,:,J) * RKYC(IND+1)
        A(2,:,J) = TR1 * RKYC(IND+1) + A(2,:,J) * RKYC(IND)
 105    IND = IND + 2
D        call trace_exit (2048) 
      DEALLOCATE (TR1)
cD     call end_interval( 17 )

cD     call start_interval( 18 )
D        call trace_enter (2049) 
      DO 700 IS=1,JC,64
        LN=MIN(64,JC-IS+1)
        CALL CFFT9X(A(1,IS,1),A(2,IS,1),TRIGY,IFAY,JC2,2,NNYT,LN,1)
 700  CONTINUE
cD     call end_interval( 18 )
 
cD     call start_interval( 19 )
D        call trace_exit (2050) 
D        call trace_enter (2051) 
      DO 12 NY=1,NNYT
 12      VOUT(:,NY) = VOUT(:,NY) - AEQ(1:$NNXT,NY) * VEL(:,NY) * DZR
cD     call end_interval( 19 )

D        call trace_exit (2052) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
      SUBROUTINE ELAPSE(T)
      REAL T
      INTEGER TIME
      T=MOD(TIME(),1000000)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
      SUBROUTINE FACT(N,IFAX)
C     FACTORIZATION ROUTINE THAT FIRST EXTRACTS ALL FACTORS OF 4
      DIMENSION IFAX(1)
      IF (N .LE. 1) THEN
      IFAX(1) = 0
      IF (N.LT.1) IFAX(1) = -99
      RETURN
      END IF
   10 NN=N
      K=1
C     TEST FOR FACTORS OF 4
   20 IF (MOD (NN, 4) .EQ. 0) THEN
      K=K+1
      IFAX(K)=4
      NN=NN/4
      IF (NN.EQ.1) GO TO 80
      GO TO 20
      ELSE
C     TEST FOR EXTRA FACTOR OF 2
   30 IF (MOD (NN, 2) .EQ. 0) THEN
      K=K+1
      IFAX(K)=2
      NN=NN/2
      IF (NN.EQ.1) GO TO 80
      END IF
C     TEST FOR FACTORS OF 3
   40 IF (MOD (NN, 3) .EQ. 0) THEN
      K=K+1
      IFAX(K)=3
      NN=NN/3
      IF (NN.EQ.1) GO TO 80
      GO TO 40
      ELSE
C     NOW FIND REMAINING FACTORS
   50 L=5
      MAX = SQRT(FLOAT(NN))
      INC=2
C     INC ALTERNATELY TAKES ON VALUES 2 AND 4
   60 IF (MOD (NN, L) .EQ. 0) THEN
      K=K+1
      IFAX(K)=L
      NN=NN/L
      IF (NN.EQ.1) GO TO 80
      GO TO 60
      ELSE
   70 IF (L .LE. MAX) THEN
      L=L+INC
      INC=6-INC
      GO TO 60
      END IF
   75 K = K+1
      IFAX(K) = NN
      END IF
      END IF
      END IF
   80 IFAX(1)=K-1
C     IFAX(1) NOW CONTAINS NUMBER OF FACTORS
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
      SUBROUTINE FAX(IFAX,N,MODE)
      DIMENSION IFAX(10)
      INTEGER II1
      NN=N
      IF (ABS (MODE) .NE. 1) THEN
      IF (ABS (MODE) .NE. 8) THEN
      NN1=N/2
      IF ((NN1 + NN1) .NE. N) THEN
      IFAX(1)=-99
      RETURN
      END IF
      END IF
      END IF
   10 K=1
C     TEST FOR FACTORS OF 4
   20 IF (MOD (NN, 4) .EQ. 0) THEN
      K=K+1
      IFAX(K)=4
      NN=NN/4
      IF (NN.EQ.1) GO TO 80
      GO TO 20
      ELSE
C     TEST FOR EXTRA FACTOR OF 2
   30 IF (MOD (NN, 2) .EQ. 0) THEN
      K=K+1
      IFAX(K)=2
      NN=NN/2
      IF (NN.EQ.1) GO TO 80
      END IF
C     TEST FOR FACTORS OF 3
   40 IF (MOD (NN, 3) .EQ. 0) THEN
      K=K+1
      IFAX(K)=3
      NN=NN/3
      IF (NN.EQ.1) GO TO 80
      GO TO 40
      ELSE
C     NOW FIND REMAINING FACTORS
   50 L=5
      INC=2
C     INC ALTERNATELY TAKES ON VALUES 2 AND 4
   60 IF (MOD (NN, L) .EQ. 0) THEN
      K=K+1
      IFAX(K)=L
      NN=NN/L
      IF (NN.EQ.1) GO TO 80
      GO TO 60
      ELSE
   70 L=L+INC
      INC=6-INC
      GO TO 60
      END IF
      END IF
      END IF
   80 IFAX(1)=K-1
C     IFAX(1) CONTAINS NUMBER OF FACTORS
      NFAX=IFAX(1)
C     SORT FACTORS INTO ASCENDING ORDER
cD       call start_interval( 83 )
        II1 = NFAX - 1
D        call trace_enter (2053) 
      DO 100 II=2,II1+1
        DO 90 I=2,NFAX-II+2
          IF (IFAX(I+1) .LT. IFAX(I)) THEN
          ITEM=IFAX(I)
          IFAX(I)=IFAX(I+1)
          IFAX(I+1)=ITEM
          END IF
 90     CONTINUE
 100  CONTINUE
cD       call end_interval( 83 )
D        call trace_exit (2054) 
 110  CONTINUE
      RETURN
      END

C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
      SUBROUTINE FFB(VIN,A,NX,NY)
      COMMON/FF1/RTRIG(1000),IFYA(15)
      COMMON/FFT/TRIGX(1000),TRIGY(1000),IFAX(15),IFAY(15)
      DIMENSION VIN(NX,NY),A(NX,NY+2)
C gjx COMMON/WORK/WORK(20000)
      JC=(NY+1)/2
      CALL CFFT9X(A(1,1),A(1,2),TRIGX,IFAX,1,2*NX,NX,JC+1,1)

cD     call start_interval( 22 )
 9    A = A / NX
cD     call end_interval( 22 )

      CALL FFT991(A,RTRIG,IFYA,NX,1,NY,NX,1)

cD     call start_interval( 23 )
 5    VIN = A(:,1:$NY)
cD     call end_interval( 23 )
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
 
      SUBROUTINE FFF(VIN,A,NX,NY)
      COMMON/FF1/RTRIG(1000),IFYA(15)
      COMMON/FFT/TRIGX(1000),TRIGY(1000),IFAX(15),IFAY(15)
C gjx COMMON/WORK/WORK(20000)
      DIMENSION VIN(NX,NY),A(NX,NY+2)
      JC=(NY+1)/2
cD     call start_interval( 20 )
 1    A(:,1:$NY) = VIN
cD     call end_interval( 20 )
cD     call start_interval( 21 )
 2    A(:,NY+1:$2) = 0.
cD     call end_interval( 21 )

      CALL FFT991(A,RTRIG,IFYA,NX,1,NY,NX,-1)
      CALL CFFT9X(A(1,1),A(1,2),TRIGX,IFAX,1,2*NX,NX,JC+1,-1)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
C
       SUBROUTINE FFT991(VIN,TR,IFF,INC1,INC2,N,NUM,ISIGN)
       DIMENSION VIN(1),TR(1),IFF(1),IFAX(15)
       REAL WORK(20000)
       INTEGER I1,I2
C       NFAC=IFF(1)
C       DO 1 K=1,NFAC
C1      IFAX(K)=IFF(K+1)
C---- PERFORM NUM FFTS
cD       call start_interval( 47 )
D        call trace_enter (2055) 
       DO 100 NN=1,NUM
         IP=(NN-1)*INC2+1
         IE2=N*INC1+IP
         IE1=IP+2*INC1
         IF (ISIGN.EQ.1) THEN
           I2 = N-1
  220        VIN(IE1-INC1:$I2:INC1) = VIN(IE1:$I2:INC1)
         ENDIF
C        CALL RFFT(VIN(IP),WORK,N,TR,IFAX,NFAC,INC1,ISIGN)
         CALL RFFT(VIN(IP),WORK,N,TR,IFF(2),IFF(1),INC1,ISIGN)
         IF (ISIGN.EQ.-1) THEN
C          REARRANGE DATA TO FFT991 ORDER
           I1 = -INC1
           I2 = (IE1 - IE2 + I1) / I1
  110        VIN(IE2:$I2:I1) = VIN(IE2-INC1:$I2:I1)
C          IMAGINARY NYQUIST
           VIN(IE2+INC1)=0.
C          IMAGINARY DC
           VIN(IE1-INC1)=0.
         ENDIF
 100   CONTINUE
cD       call end_interval( 47 )
D        call trace_exit (2056) 
       RETURN
       END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
      SUBROUTINE FFTFAX(N,IFAX,TRIGS)
      DIMENSION IFAX(13),TRIGS(1)
C
      DATA MODE /3/
      CALL FAX (IFAX, N, MODE)
      I = IFAX(1)
      IF (IFAX(I+1) .GT. 5) IFAX(1) = -99
C     IF (IFAX(1) .LE. 0 ) CALL ABORT  *** ABORT NOT ANSI
      IF (IFAX(1) .LE. 0 ) STOP 'ABORT'
      CALL FFTRIG (TRIGS, N, MODE)
      CALL FFTTRG(N,TRIGS)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
      SUBROUTINE FFTRIG(TRIGS,N,MODE)
      DIMENSION TRIGS(1)
      INTEGER I1
      REAL ANGLE1 (:), ANGLE2 (:), ANGLE3 (:), ANGLE4 (:)
      IMODE=ABS(MODE)
      NN=N
      IF (IMODE.GT.1.AND.IMODE.LT.6) NN=N/2
      DEL=(4.*ASIN(1.))/FLOAT(NN)
      L=NN+NN
cD       call start_interval( 84 )
        I1 = (NN + NN + 1) / 2
        ALLOCATE (ANGLE1(I1))
      ANGLE1(1:$I1) = 0.5 * FLOAT ([0 :$ I1 : 2]) * DEL
      TRIGS(1:$I1:2) = COS (ANGLE1(1:$I1))
      TRIGS(2:$I1:2) = SIN (ANGLE1(1:$I1))
      DEALLOCATE (ANGLE1)
cD       call end_interval( 84 )
      IF (IMODE.EQ.1) RETURN
      IF (IMODE.EQ.8) RETURN
      DEL=0.5*DEL
      NH=(NN+1)/2
      L=NH+NH
      LA=NN+NN
cD       call start_interval( 85 )
        I1 = ((NN + 1) / 2 + (NN + 1) / 2 + 1) / 2
        ALLOCATE (ANGLE2(I1))
      ANGLE2(1:$I1) = 0.5 * FLOAT ([0 :$ I1 : 2]) * DEL
      TRIGS(LA+1:$I1:2) = COS (ANGLE2(1:$I1))
      TRIGS(LA+2:$I1:2) = SIN (ANGLE2(1:$I1))
      DEALLOCATE (ANGLE2)
cD       call end_interval( 85 )
      IF (IMODE.LE.3) RETURN
      DEL=0.5*DEL
      LA=LA+NN
      IF (MODE .NE. 5) THEN
cD       call start_interval( 86 )
        I1 = NN - 1
        ALLOCATE (ANGLE3(I1))
      ANGLE3(1:$I1) = FLOAT ([1 :$ I1]) * DEL
      TRIGS(LA+2:$I1) = 2.0 * SIN (ANGLE3(1:$I1))
      DEALLOCATE (ANGLE3)
cD       call end_interval( 86 )
      RETURN
      END IF
   40 CONTINUE
      DEL=0.5*DEL
cD       call start_interval( 87 )
        I1 = N - 1
        ALLOCATE (ANGLE4(I1))
      ANGLE4(1:$I1) = FLOAT ([1 :$ I1]) * DEL
      TRIGS(LA+2:$I1) = SIN (ANGLE4(1:$I1))
      DEALLOCATE (ANGLE4)
cD       call end_interval( 87 )
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
      SUBROUTINE FFTTRG(N,TR)
      REAL CC, DN, TR(1)
      INTEGER I1
      REAL CC1 (:)
      DN = 3.141592653589793/N
cD       call start_interval( 88 )
        I1 = (2 * N + 1) / 2
        ALLOCATE (CC1(I1))
         CC1(1:$I1) = [0 :$ I1 : 2] * DN
         TR(1:$I1:2) = COS (CC1(1:$I1))
    1    TR(2:$I1:2) = SIN (CC1(1:$I1))
         DEALLOCATE (CC1)
cD       call end_interval( 88 )
      RETURN
      END
C  last modification: Fri Dec 27 14:29:43 1991
C kap command line: /usr/csrd/kap -lo=t -nc -limit=200 SMS.itrc.f
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
C  last modification: Thu Nov 21 17:21:07 1991
**-------------------------------------------**
CCC             MIGRATION PROGRAM
**-------------------------------------------**
      PROGRAM MAIN
      COMMON/GENRAL/NTRACE,NSAMP,NLINE,DX,DY,DZ,NFFT,DT,FCUT,NTOT,VEL0,
     .              NWJUMP,NZJUMP,NSTEPS,DW,NX,NY,VELMIN,VELMAX,IWCUT,
     $              REDUCTION_LOCK
      COMMON/FFT/TRIGX(1000),TRIGY(1000),IFAX(15),IFAY(15),RKX(400),
     .           RKY(400),RKXC(800),RKYC(800)
      COMMON/IO/NTT,ISSD,IDISK1,IDISK2,IIN,NIO,NLIN,NRES
C gjx COMMON/PP1/PP1( 61000),PM1( 60000)
C gjx COMMON/CDPP1/CDPP1( 60000),CDPM1( 60000)
C gjx COMMON        BUF(   120 320),AW( 61000)
C gjx COMMON       /VEL/VEL( 15000),DSECT( 15000)
      COMMON/DSECT/          DSECT( 15000)
      COMMON/FF1/RTRIG(1000),IFYA(15)
C MAXIMUM RECORD LENGTH FOR DIRECT ACCESS FILES IN BYTES. HERE, NTT*8
C IT IS ASSUMEM MAXRL.LE.962560
      PARAMETER (MAXRL=962560)
C
      REAL T1,T2,T3,T4
      INTEGER I
      REAL VEL(:,:)
C
D       call init_trace(1)
CD      call init_intervals('SMS.intvl')
      OPEN(UNIT=41,FILE='SMI41.new',STATUS='OLD')
C gjx                         ^^^^  Shortened input file
      OPEN(UNIT=10,FILE='SMV',STATUS='NEW')
 
C-------
C  READ OMMON BLOCKS
C-------
C
C.....CALL TIMING ROUTINES
C
      CALL CPUTIM(T1)
      CALL ELAPSE(T2)
C
      READ(41,201)NTRACE,NSAMP,NLINE,DX,DY,DZ,NFFT,DT,FCUT,NTOT,VEL0
      READ(41,202)NWJUMP,NZJUMP,NSTEPS,DW,NX,NY,VELMIN,VELMAX,IWCUT
C gjx Things not found in input file SMI41.new
C      READ(41,203)(TRIGX(I),TRIGY(I),I=1,1000)
C      READ(41,204)(IFAX(I),IFAY(I),I=1,15)
      READ(41,203)(RKX(I),RKY(I),I=1,400)
      READ(41,203)(RKXC(I),RKYC(I),I=1,800)
      READ(41,205)NTT,ISSD,IDISK1,IDISK2,IIN,NIO,NLIN,NRES
201   FORMAT(3(I5,1X),3(E16.8,1X)/I5,1X,2(E16.8,1X),I10,1X,E16.8)
202   FORMAT(3(I5,1X),E16.8,1X,2(I5,1X)/2(E16.8,1X),I5)
203   FORMAT(4(E16.8,1X)/)
204   FORMAT(5(I10,1X)/)
205   FORMAT(4(I10,1X)/)
***
* -------  OPEN FILES
***
C... NOTE:  ON CRAYS, FOR DIRECT ACCESS FILES THE RECORD LENGTH
C... 'RECL' IS IN BYTES
 
C     OPEN(ISSD,FILE='SMT1',FORM='UNFORMATTED',
C    .     ACCESS='DIRECT',RECL=8*NTT)
C REPLACE L. POINTER 10-89 TO HANDLE DIFFERENT RECORD LENGTH if NESS.
C MAXRL=962560=8*NTT
C gjx Converted to memory cause that's what it is
C gjx OPEN(UNIT=IDISK1,FORM='UNFORMATTED',STATUS='SCRATCH')
      OPEN(UNIT=IDISK2,FILE='SMO6',STATUS='NEW')
C
      CALL FFTFAX(NY,IFYA,RTRIG)
      CALL CFTFAX(NY,IFAY,TRIGY)
      CALL CFTFAX(NX,IFAX,TRIGX)
cD     call start_interval( 1 )
      NXY = NX * NY
      ALLOCATE (VEL(NXY,NSTEPS/NZJUMP))
D        call trace_enter (2057) 
      DO 77 I=1,NSTEPS/NZJUMP
C77     WRITE(IDISK1)(VEL(K),K=1,NXY)
 77     VEL(:,I) = 2000. + FLOAT ([1:$NXY])
cD     call end_interval( 1 )
C      REWIND(IDISK1)
 
D        call trace_exit (2058) 
      CALL MIGRAT(DSECT,VEL)
      CALL CPUTIM(T3)
      CALL ELAPSE(T4)
C
      WRITE(10,*)
      WRITE(10,*) 'ELAPSED CPU TIME IN SECONDS: ',T3-T1
C MFLOPS = MFLOP 1 CPU CRAY X-MP/CPU TIME
      WRITE(10,*) 'MFLOPS RATE: ', 11060.448/(T3-T1)
      WRITE(10,*) 'ELAPSED WALLCLOCK TIME IN SECONDS: ',
     *            MOD(T4-T2+1000000.0,1000000.0)
C
C     CALL REMARK('END MIGRAT')
D       call exit_trace()
CD      call exit_intervals('SMS.sum')
      STOP
      END

C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
      SUBROUTINE MARCH(BUF,VEL,PP1,PM1,CDPP1,CDPM1,AW,IW,W)
      COMMON/GENRAL/NTRACE,NSAMP,NLINE,DX,DY,DZ,NFFT,DT,FCUT,NTOT,VEL0,
     .              NWJUMP,NZJUMP,NSTEPS,DW,NX,NY,VELMIN,VELMAX,IWCUT
      COMMON/FFT/TRIGX(1000),TRIGY(1000),IFAX(15),IFAY(15),RKX(400),
     .           RKY(400),RKXC(800),RKYC(800)
      COMMON/IO/NTT,ISSD,IDISK1,IDISK2,IIN,NIO,NLIN,NRES
      DIMENSION BUF(NX,NY,2),VEL(NX,1),BES(150)
      DIMENSION PP1(NX,NY),PM1(NX,NY)
      DIMENSION CDPP1(NX,NY),CDPM1(NX,NY)
      DIMENSION AW(NX,NY)
      DATA BES/150*1.0/
      DZR = 1.
      CALL BESSEL(NBES,IW)
C
cD       call start_interval( 4 )
      PP1   = 0.
      CDPP1 = 0.
Cgjx  PM1   = BUF(:,:,1)
Cgjx  CDPM1 = BUF(:,:,2)
CC
cD       call end_interval( 4 )
      CALL MUL(PM1,CDPM1,PP1,CDPP1,VEL,DZR,W,AW)
CC
cD       call start_interval( 5 )
      BUF(:,:,1) = BES(1) * PM1   + BES(2) * PP1
   40 BUF(:,:,2) = BES(1) * CDPM1 + BES(2) * CDPP1
**
cD       call end_interval( 5 )
      DZR=DZR*2.
**
cD       call start_interval( 6 )
D        call trace_enter (2059) 
      DO 500 NB=3,NBES,2
        CALL MUL(PP1,CDPP1,PM1,CDPM1,VEL,DZR,W,AW)
        BUF(:,:,1) = BUF(:,:,1) + BES(NB) * PM1
        BUF(:,:,2) = BUF(:,:,2) + BES(NB) * CDPM1
        if (NB .NE. NBES) then
          CALL MUL(PM1,CDPM1,PP1,CDPP1,VEL,DZR,W,AW)
          BUF(:,:,1) = BUF(:,:,1) + BES(NB+1) * PP1
          BUF(:,:,2) = BUF(:,:,2) + BES(NB+1) * CDPP1
        endif
500   CONTINUE
cD       call end_interval( 6 )

D        call trace_exit (2060) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
 
      SUBROUTINE MIGRAT(DSECT,VEL)
      DIMENSION DSECT(NX,NY),VEL(1,1)
      COMMON/GENRAL/NTRACE,NSAMP,NLINE,DX,DY,DZ,NFFT,DT,FCUT,NTOT,VEL0,
     .              NWJUMP,NZJUMP,NSTEPS,DW,NX,NY,VELMIN,VELMAX,IWCUT,
     $              REDUCTION_LOCK
      COMMON/FFT/TRIGX(1000),TRIGY(1000),IFAX(15),IFAY(15),RKX(400),
     .           RKY(400),RKXC(800),RKYC(800)
      COMMON/IO/NTT,ISSD,IDISK1,IDISK2,IIN,NIO,NLIN,NRES
      REAL ZERO
      PARAMETER (ZERO=1.E-16)
C gjx PARAMETER (ZERO=1.E-40)
      REAL VELMAXse(NSTEPS/NZJUMP)
 
CCCC
      NXY=NX*NY
 
C     call start_interval( 2 )
C gjx DO 80 I=1,NTT
C gjx XDOALL 80 IW=1,IWCUT  ! Static schedule needed
C80     BUF(:,:,:,IW) = 1.
C     call end_interval( 2 )
 
C gjx      DO 90 I=1,IWCUT,NWJUMP
C gjx       CALL WSSD(BUF,I)
C gjx 90   CONTINUE
 
cD       call start_interval( 3 )
D        call trace_enter (2061) 
      DO 30 NZ=1,NSTEPS,NZJUMP
C
C READ VELOCITY FOR DEPTH LEVEL
C gjx    READ(IDISK1)(VEL(I),I=1,NXY)
C gjx    VELMIN = MINVAL (VEL(1:$NXY)) ! deadcode
C gjx    Pretend this isn't a constant expression
   30    VELMAXse(NZ) = MAXVAL (VEL(1:$NXY,NZ))
 
C gjx DO 100 NZ=1,NSTEPS,NZJUMP ! interchanged from here
C gjx   DSECT = 0.  ! commons are implicitly 0
C gjx   DO 200 NW=1,IWCUT,NWJUMP
D        call trace_exit (2062) 
D        call trace_enter (2063) 
        CDOALL 200 IW=1,IWCUT
          REAL PP1(NX,NY+2),AW(NX,NY+2)
          REAL PM1(NX,NY),CDPP1(NX,NY),CDPM1(NX,NY)
          REAL BUF(NX,NY,2)
          REAL FF1 (:)
          REAL W, WC
          INTEGER IJ, J, NZ
        LOOP
          PM1 = 1.
          CDPM1 = 1.
          DO 100 NZ=1,NSTEPS,NZJUMP
            W=IW*DW
            IF(NZ.EQ.9)THEN
              WC=W*W/(VEL0*VEL0)
              PP1(:,1:$NY) = PM1
 112          PM1(:,1:$NY) = CDPM1

              CALL FFF(PP1,AW, NX,NY)
              CALL FFF(PM1,PP1,NX,NY)
C gjx
              IJ=0
              ALLOCATE (FF1(NX))
              DO 2 J=1,NY+1,2
                IJ=IJ+1
                FF1(:) = (WC - RKY(IJ)) - RKX(1:$NX)
                WHERE (FF1 .LT. ZERO)
                  AW (:,J  ) = 0.
                  AW (:,J+1) = 0.
                  PP1(:,J  ) = 0.
                  PP1(:,J+1) = 0.
                OTHERWISE
                  FF1 = -SQRT (FF1) * VEL0
                  PP1(:,J  ) = FF1 * PP1(:,J  )
                  PP1(:,J+1) = FF1 * PP1(:,J+1)
                END WHERE
 2            CONTINUE
              DEALLOCATE (FF1)
 
              CALL FFB(PM1,PP1,NX,NY)
              CALL FFB(PP1, AW,NX,NY)
 
 113          CDPM1 = PM1(:,1:$NY)
              PM1   = PP1(:,1:$NY)
 
            ENDIF
 
*********************
            CALL MARCH(BUF,VEL(1,NZ),PP1,PM1,CDPP1,CDPM1,AW,IW,W)
*********************
            PP1(:,1:$NY) = BUF(:,:,1)
 55         PM1(:,1:$NY) = BUF(:,:,2)
 
            WC=W*W/(VELMAXse(NZ)**2)
            CALL FFF(PP1, AW,NX,NY)
            CALL FFF(PM1,PP1,NX,NY)
C gjx
            IJ=0
            ALLOCATE (FF1(NX))
            DO 3 J=1,NY+1,2
              IJ=IJ+1
              FF1(:) = (WC - RKY(IJ)) - RKX(1:$NX)
              WHERE (FF1 .LT. ZERO)
                AW (:,J  ) = 0.
                AW (:,J+1) = 0.
                PP1(:,J  ) = 0.
                PP1(:,J+1) = 0.
              END WHERE
 3          CONTINUE
            DEALLOCATE (FF1)
 
            CALL FFB(PM1,PP1,NX,NY)
            CALL FFB(PP1, AW,NX,NY)
 
 66         CDPM1 = PM1(:,1:$NY)
            PM1   = PP1(:,1:$NY)
 100  CONTINUE
            call lock(REDUCTION_LOCK)  
 21           DSECT = DSECT + PM1
            call unlock(REDUCTION_LOCK)
C gjx 20  CONTINUE
C         WRITE P & CDP TO SSD
C gjx     CALL WSSD(BUF,NW)
 200    CONTINUE
cD       call end_interval( 3 )
D        call trace_exit (2064) 
      CALL VERIFY(IDISK2,NX,DSECT)
      RETURN
      END

C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
      SUBROUTINE MUL(PIN,CDPIN,POUT,CDPOUT,VEL,DZR,W,AW)
      COMMON/GENRAL/NTRACE,NSAMP,NLINE,DX,DY,DZ,NFFT,DT,FCUT,NTOT,VEL0,
     .              NWJUMP,NZJUMP,NSTEPS,DW,NX,NY,VELMIN,VELMAX,IWCUT
      COMMON/FFT/TRIGX(1000),TRIGY(1000),IFAX(15),IFAY(15),RKX(400),
     .           RKY(400),RKXC(800),RKYC(800)
      COMMON/IO/NTT,ISSD,IDISK1,IDISK2,IIN,NIO,NLIN,NRES
      DIMENSION  PIN(NX,NY), CDPIN(NX,NY)
      DIMENSION POUT(NX,NY),CDPOUT(NX,NY),VEL(NX,NY)
      DIMENSION AW(NX,NY+2)

cD       call start_interval( 7 )
      POUT = POUT + DZR * CDPIN/VEL
      CDPOUT = CDPOUT - (DZR * W * W) * PIN/VEL
cD       call end_interval( 7 )

      CALL DIFX(PIN,CDPOUT,AW,AW,NX,NY,VEL,DZR)
      CALL DIFY(PIN,CDPOUT,AW,AW,NX,NY,VEL,DZR)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
Consider C*$* EXPAND ROUTINE (RPASS, RPASSM)
        SUBROUTINE RFFT(A,C,N,TRIGS,IFAX,NFAC,ISKIP,ISIGN)
        DIMENSION TRIGS(1)
        INTEGER IFAX(1)
        DIMENSION A(1),C(1)
        MA=N
        LA=1
        II=1
        IF (ISIGN .LE. 0) THEN
C        REAL TO COMPLEX
        NF=NFAC+1
cD       call start_interval( 48 )
D        call trace_enter (2065) 
        DO 102 I=1,NFAC
         IFAC=IFAX(NF-I)
         MA=MA/IFAC
         MASKIP=MA*ISKIP
         IF(II.GT.0) THEN
           CALL RPASS(A,A(1+MASKIP*IFAC),C,C(1+MA),
     .       TRIGS,TRIGS(2),IFAC,MA,LA,ISKIP,1,N)
         ELSE
           CALL RPASS(C,C(1+MA*IFAC),A,A(1+MASKIP),
     .       TRIGS,TRIGS(2),IFAC,MA,LA,1,ISKIP,N)
         ENDIF
         LA=LA*IFAC
         II=-II
102     CONTINUE
C       CALL REMARK(' AFTER RPASS')
cD       call end_interval( 48 )
D        call trace_exit (2066) 
        IF(II.LT.0) THEN
D         call start_interval( 49 )
          A(1:$N:ISKIP) = C(1:$N)
D         call end_interval( 49 )
        END IF
        RETURN
        END IF
100        CONTINUE
C       ------ COMPLEX TO REAL ---------
C        .. MULTIPLY DC (AND NYQUIST) BY 0.5 ACCORDING TO TEMPERTON. ..
        A(1)=0.5*A(1)
        N1=(N-1)*ISKIP+1
        IF(MOD(N,2).EQ.0)A(N1)=0.5*A(N1)
        CON=2./FLOAT(N)
cD       call start_interval( 50 )
D        call trace_enter (2067) 
        DO 103 I=1,NFAC
         IFAC=IFAX(I)
         MA=MA/IFAC
         LASKIP=LA*ISKIP
         IF(II.GT.0) THEN
           CALL RPASSM(A,A(1+LASKIP),C,C(1+LA*IFAC),
     .        TRIGS,TRIGS(2),IFAC,LA,MA,ISKIP,1,N)
         ELSE
           CALL RPASSM(C,C(1+LA),A,A(1+LASKIP*IFAC),
     .        TRIGS,TRIGS(2),IFAC,LA,MA,1,ISKIP,N)
         ENDIF
         LA=LA*IFAC
         II=-II
103     CONTINUE
C       CALL REMARK(' AFTER RPASSM')
cD       call end_interval( 50 )
D        call trace_exit (2068) 
        IF(II.LT.0) THEN
D         call start_interval( 51 )
          A(1:$N:ISKIP) = C(1:$N) * CON
D         call end_interval( 51 )
        ELSE
D         call start_interval( 52 )
          A(1:$N:ISKIP) = A(1:$N:ISKIP) * CON
D         call end_interval( 52 )
        END IF
        RETURN
        END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
C----------------------------------------------------------
C
C       PERFORM REAL TO COMPLEX RFFT PASS
C
C----------------------------------------------------------
        SUBROUTINE RPASS(A,B,C,D,TRIGS,TRIGSI,IFAC,MA,LA,
     .    ISKIP,ISKIP1,N)
        DIMENSION A(N),C(N),TRIGS(1),TRIGSI(1),B(1),D(1)
        SAVE SIN45,SIN60,SIN72,SIN36,SQ54,SN3672,IFLAG
        INTEGER II1, II2, II3, II4, II5, II6, II7, II8, II9, II10, II11
     X    , II12, II13, II14, II15, II16, II17, II18, II19, II20, II21,
     X    II22, L2, K1, II23, II24, II25, II26, II27
        INTEGER JNL1 (:), JNL2 (:), JM2SKP1 (:), JM2SKP2 (:), JM2SKP3 (:
     X    ), JM1L1 (:), JM2SKP4 (:), JNL4 (:), JM2SKP5 (:), JM41 (:),
     X    JNLM2S1 (:), JM2SKP6 (:), JNL5 (:), JM2SKP7 (:), JM42 (:),
     X    JNLM2S2 (:), JNLM41 (:), JM2SKP8 (:)
        REAL A0REAL1 (:), A1REAL1 (:), A0REAL2 (:), A1REAL2 (:), A0IMAG1
     X     (:), A1IMAG1 (:), X01 (:), X11 (:), X21 (:), T11 (:), T21 (:)
     X    , T31 (:), A0REAL3 (:), A1REAL3 (:), A0IMAG2 (:), A1IMAG2 (:)
     X    , A2REAL1 (:), A2IMAG1 (:), T1REAL1 (:), T1IMAG1 (:), T2REAL1
     X     (:), T2IMAG1 (:), T3REAL1 (:), T3IMAG1 (:), X02 (:), X12 (:)
     X    , X22 (:), T12 (:), A0REAL4 (:), A1REAL4 (:), T13 (:), T22 (:)
     X    , T32 (:), A2REAL2 (:), A3REAL1 (:), T41 (:), A0REAL5 (:),
     X    A1REAL5 (:), A0IMAG3 (:), A1IMAG3 (:)
        REAL A2REAL3 (:), A2IMAG2 (:), T1REAL2 (:), T1IMAG2 (:), T2REAL2
     X     (:), T2IMAG2 (:), T3REAL2 (:), T3IMAG2 (:), A3REAL2 (:),
     X    A3IMAG1 (:), T4REAL1 (:), T4IMAG1 (:), X03 (:), X13 (:), X23 (
     X    :), T14 (:), T23 (:), X31 (:), X04 (:), X14 (:), X24 (:), T15
     X     (:), T24 (:), T33 (:), T42 (:), X32 (:), X41 (:), T51 (:),
     X    T61 (:), T71 (:), A0REAL6 (:), A1REAL6 (:), A0IMAG4 (:),
     X    A1IMAG4 (:), A2REAL4 (:), A2IMAG3 (:), T1REAL3 (:), T1IMAG3 (:
     X    ), T2REAL3 (:), T2IMAG3 (:)
        REAL T3REAL3 (:), T3IMAG3 (:), A3REAL3 (:), A3IMAG2 (:), T4REAL2
     X     (:), T4IMAG2 (:), A4REAL1 (:), A4IMAG1 (:), T5REAL1 (:),
     X    T5IMAG1 (:), T6REAL1 (:), T6IMAG1 (:), T7REAL1 (:), T7IMAG1 (:
     X    ), T8REAL1 (:), T8IMAG1 (:), T9REAL1 (:), T9IMAG1 (:), T10REA1
     X     (:), T10IMA1 (:), T11REA1 (:), T11IMA1 (:), X05 (:), X15 (:)
     X    , X25 (:), T16 (:), T25 (:), T34 (:), T43 (:), X33 (:), X42 (:
     X    ), T52 (:), T62 (:), T72 (:), X06 (:), X16 (:), X26 (:),
     X    T1REAL4 (:), T2REAL4 (:), T3REAL4 (:)
        REAL X34 (:), X43 (:), X51 (:), Y0REAL1 (:), Y4REAL1 (:),
     X    Y4IMAG1 (:), Y2REAL1 (:), Y2IMAG1 (:), Y3REAL1 (:), Y1REAL1 (:
     X    ), Y1IMAG1 (:), Y5REAL1 (:), Y5IMAG1 (:), A0REAL7 (:), A1REAL7
     X     (:), A0IMAG5 (:), A1IMAG5 (:), A2REAL5 (:), A2IMAG4 (:),
     X    T1REAL5 (:), T1IMAG4 (:), T2REAL5 (:), T2IMAG4 (:), T3REAL5 (:
     X    ), T3IMAG4 (:), A3REAL4 (:), A3IMAG3 (:), A4REAL2 (:), A4IMAG2
     X     (:), Y0REAL2 (:), Y4REAL2 (:), Y4IMAG2 (:), Y2REAL2 (:),
     X    Y2IMAG2 (:), Y3REAL2 (:), Y1REAL2 (:), Y1IMAG2 (:), Y5REAL2 (:
     X    ), Y5IMAG2 (:), A5REAL1 (:)
        REAL A5IMAG1 (:), Y0IMAG1 (:), Y3IMAG1 (:), X07 (:), X17 (:),
     X    X27 (:), T17 (:), T26 (:), T35 (:), T44 (:), X35 (:), X44 (:)
     X    , T53 (:), T63 (:), X52 (:)
        DATA IFLAG /0/
        IF(IFLAG.EQ.0) THEN
         IFLAG=1
         SIN45=0.5*SQRT(2.)
         SIN60=SIN(3.141592653589793/3.)
         SIN72=SIN(3.141592653589793*72./180.)
         SIN36=SIN(3.141592653589793*36./180.)
         SQ54=0.25*SQRT(5.)
         SN3672=SIN36/SIN72
        END IF
        M=N/IFAC
        M2=M+M
        MSKIP=M*ISKIP
        M2SKIP=MSKIP+MSKIP
        MSKIP1=M*ISKIP1
        M2SKP1=MSKIP1+MSKIP1
        MHLF=M/2
        MASKIP=MA*ISKIP
        MASKP1=MA*ISKIP1
        IB=MASKIP
        JUMP=(IFAC-1)*MASKIP
        JUMP3=JUMP*3
        IJ=(N-MA)*ISKIP1
        GO TO (100,200,300,400,500 ,600),IFAC
 
 100    PRINT *,'**** RADIX ONE ENCOUNTERED ****'
        STOP 999
 200    CONTINUE
C       -------- FACTOR TWO ----------
        L1=1
CDIR$ IVDEP
cD       call start_interval( 68 )
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (A1REAL1(L2), A0REAL1(L2))
          A0REAL1(1:$L2) = A(1:$L2:ISKIP)
          A1REAL1(1:$L2) = A(IB+1:$L2:ISKIP)
          C(1:$L2:ISKIP1) = A0REAL1(1:$L2) + A1REAL1(1:$L2)
          C(IJ+1:$L2:ISKIP1) = A0REAL1(1:$L2) - A1REAL1(1:$L2)
          DEALLOCATE (A0REAL1, A1REAL1)
cD       call end_interval( 68 )
        J=MASKP1+1
        I=MASKIP+1+JUMP
        IF(MA.EQ.M) RETURN
        MM=MHLF
        IF(MOD(LA,2).EQ.0) MM=MM-MA
cD       call start_interval( 69 )
        II2 = J
        II1 = I
        K1 = (MM - MA + MA) / MA
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (JNL1(L2), A1IMAG1(L2), A1REAL2(L2), A0IMAG1(L2),
     X    A0REAL2(L2))
        II23 = (-1)
D        call trace_enter (2069) 
        DO 11 K=MA,MA+((-1)+K1)*MA,MA
        II23 = II23 + 1
         KK=K+K
         JN=IJ-KK*ISKIP1
         KK=KK+1
         TREAL=TRIGS(KK)
         TIMAG=TRIGSI(KK)
         L1=1
CDIR$ IVDEP
         II3 = L1
          A0REAL2(1:$L2) = A(II1+L2*II23*ISKIP+II23*JUMP3:$L2:ISKIP)
          A0IMAG1(1:$L2) = B(II1+L2*II23*ISKIP+II23*JUMP3:$L2:ISKIP)
          A1REAL2(1:$L2) = A(II1+L2*II23*ISKIP+II23*JUMP3+IB:$L2:ISKIP)
          A1IMAG1(1:$L2) = B(II1+L2*II23*ISKIP+II23*JUMP3+IB:$L2:ISKIP)
          C(II2+L2*II23*ISKIP1+II23*MASKP1:$L2:ISKIP1) = A0REAL2(1:$L2)
     X      + A1REAL2(1:$L2) * TREAL + A1IMAG1(1:$L2) * TIMAG
          D(II2+L2*II23*ISKIP1+II23*MASKP1:$L2:ISKIP1) = A0IMAG1(1:$L2)
     X      - A1REAL2(1:$L2) * TIMAG + A1IMAG1(1:$L2) * TREAL
          JNL1(1:$L2) = [JN + II3 :$ L2 : ISKIP1]
          C(JNL1(1:$L2)) = A0REAL2(1:$L2) - A1REAL2(1:$L2) * TREAL -
     X      A1IMAG1(1:$L2) * TIMAG
          D(JNL1(1:$L2)) = -A0IMAG1(1:$L2) - A1REAL2(1:$L2) * TIMAG +
     X      A1IMAG1(1:$L2) * TREAL
          I = II1 + ((-1) + (L2 + L2 * II23)) * ISKIP + II23 * JUMP3 +
     X      ISKIP
          J = II2 + ((-1) + (L2 + L2 * II23)) * ISKIP1 + II23 * MASKP1 +
     X       ISKIP1
11      CONTINUE
D        call trace_exit (2070) 
         I = II1 + L2 * K1 * ISKIP + ((-1) + K1) * JUMP3 + JUMP3
         J = II2 + L2 * K1 * ISKIP1 + ((-1) + K1) * MASKP1 + MASKP1
         DEALLOCATE (A0REAL2, A0IMAG1, A1REAL2, A1IMAG1, JNL1)
cD       call end_interval( 69 )
        IF(MOD(LA,2).NE.0) RETURN
CDIR$ IVDEP
cD       call start_interval( 70 )
        II4 = J
        II5 = I
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
         C(II4:$L2:ISKIP1) = A(II5:$L2:ISKIP)
         D(II4:$L2:ISKIP1) = -A(II5+IB:$L2:ISKIP)
cD       call end_interval( 70 )
        RETURN
C       ------ FACTOR 3 -----------
300        CONTINUE
        MA3SKP=MASKIP*3
        KEND=(N-MA)/2+MA
        IF(MOD(LA,2).EQ.0) KEND=(N-2*MA)/2+MA*2
        KDIF=KEND+KEND-M2-MA
        IF(MOD(LA,2).EQ.0) KDIF=KDIF-MA
        JMPMA3=JUMP+MA3SKP
        IJ2=M2SKP1
        IJ1=IJ2-MASKP1
        IC=IB+MASKIP
        L1=1
CDIR$ IVDEP
cD       call start_interval( 71 )
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (T31(L2), T21(L2), T11(L2), X21(L2), X11(L2), X01(L2))
          X01(1:$L2) = A(1:$L2:ISKIP)
          X11(1:$L2) = A(IB+1:$L2:ISKIP)
          X21(1:$L2) = A(IC+1:$L2:ISKIP)
          T11(1:$L2) = X11(1:$L2) + X21(1:$L2)
          T21(1:$L2) = X01(1:$L2) - 0.5 * T11(1:$L2)
          T31(1:$L2) = SIN60 * (X11(1:$L2) - X21(1:$L2))
          C(1:$L2:ISKIP1) = X01(1:$L2) + T11(1:$L2)
          C(IJ1+1:$L2:ISKIP1) = T21(1:$L2)
          C(IJ2+1:$L2:ISKIP1) = -T31(1:$L2)
          DEALLOCATE (X01, X11, X21, T11, T21, T31)
cD       call end_interval( 71 )
         IF(MA.EQ.M) RETURN
         J=MASKP1+1
         I=MASKIP+1+JUMP
         MM=MHLF
         IF(MOD(LA,2).EQ.0) MM=MM-MA
cD       call start_interval( 72 )
        II7 = J
        II6 = I
        K1 = (MM - MA + MA) / MA
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (JNL2(L2), JM2SKP1(L2), T3IMAG1(L2), T3REAL1(L2),
     X    T2IMAG1(L2), T2REAL1(L2), T1IMAG1(L2), T1REAL1(L2), A2IMAG1(L2
     X    ), A2REAL1(L2), A1IMAG2(L2), A1REAL3(L2), A0IMAG2(L2), A0REAL3
     X    (L2))
        II24 = (-1)
D        call trace_enter (2071) 
        DO 21 K=MA,MA+((-1)+K1)*MA,MA
        II24 = II24 + 1
          K2=K+K
          KJ=KDIF-K2
          KJ=(KJ+KJ)*ISKIP1
          KK=K2+1
          TR1REA = TRIGS(K+K+1)
          TR1IMA = -TRIGSI(K+K+1)
          KK=KK+K2
          TR2REA=TRIGS(KK)
          TR2IMA=-TRIGSI(KK)
CDIR$ IVDEP
           A0REAL3(1:$L2) = A(II6+L2*II24*ISKIP+II24*JMPMA3:$L2:ISKIP)
           A0IMAG2(1:$L2) = B(II6+L2*II24*ISKIP+II24*JMPMA3:$L2:ISKIP)
           A1REAL3(1:$L2) = A(II6+L2*II24*ISKIP+II24*JMPMA3+MA*ISKIP:$L2
     X       :ISKIP) * TR1REA - B(II6+L2*II24*ISKIP+II24*JMPMA3+MA*ISKIP
     X       :$L2:ISKIP) * TR1IMA
           A1IMAG2(1:$L2) = B(II6+L2*II24*ISKIP+II24*JMPMA3+MA*ISKIP:$L2
     X       :ISKIP) * TR1REA + A(II6+L2*II24*ISKIP+II24*JMPMA3+MA*ISKIP
     X       :$L2:ISKIP) * TR1IMA
           A2REAL1(1:$L2) = A(II6+L2*II24*ISKIP+II24*JMPMA3+IC:$L2:ISKIP
     X       ) * TR2REA - B(II6+L2*II24*ISKIP+II24*JMPMA3+IC:$L2:ISKIP)
     X       * TR2IMA
           A2IMAG1(1:$L2) = B(II6+L2*II24*ISKIP+II24*JMPMA3+IC:$L2:ISKIP
     X       ) * TR2REA + A(II6+L2*II24*ISKIP+II24*JMPMA3+IC:$L2:ISKIP)
     X       * TR2IMA
           T1REAL1(1:$L2) = A1REAL3(1:$L2) + A2REAL1(1:$L2)
           T1IMAG1(1:$L2) = A1IMAG2(1:$L2) + A2IMAG1(1:$L2)
           T2REAL1(1:$L2) = A0REAL3(1:$L2) - T1REAL1(1:$L2) * 0.5
           T2IMAG1(1:$L2) = A0IMAG2(1:$L2) - T1IMAG1(1:$L2) * 0.5
           T3REAL1(1:$L2) = SIN60 * (A1REAL3(1:$L2) - A2REAL1(1:$L2))
           T3IMAG1(1:$L2) = SIN60 * (A1IMAG2(1:$L2) - A2IMAG1(1:$L2))
           C(II7+L2*II24*ISKIP1+II24*MASKP1:$L2:ISKIP1) = A0REAL3(1:$L2)
     X        + T1REAL1(1:$L2)
           D(II7+L2*II24*ISKIP1+II24*MASKP1:$L2:ISKIP1) = A0IMAG2(1:$L2)
     X        + T1IMAG1(1:$L2)
           JM2SKP1(1:$L2) = [II7 + L2 * II24 * ISKIP1 + II24 * MASKP1 +
     X       M2SKP1 :$ L2 : ISKIP1]
           C(JM2SKP1(1:$L2)) = T2REAL1(1:$L2) + T3IMAG1(1:$L2)
           D(JM2SKP1(1:$L2)) = T2IMAG1(1:$L2) - T3REAL1(1:$L2)
           JNL2(1:$L2) = [KJ + (II7 + L2 * II24 * ISKIP1 + II24 * MASKP1
     X       ) :$ L2 : ISKIP1]
           C(JNL2(1:$L2)) = T2REAL1(1:$L2) - T3IMAG1(1:$L2)
           D(JNL2(1:$L2)) = -(T2IMAG1(1:$L2) + T3REAL1(1:$L2))
           I = II6 + ((-1) + (L2 + L2 * II24)) * ISKIP + II24 * JMPMA3 +
     X        ISKIP
           J = II7 + ((-1) + (L2 + L2 * II24)) * ISKIP1 + II24 * MASKP1
     X       + ISKIP1
21       CONTINUE
D        call trace_exit (2072) 
          I = II6 + L2 * K1 * ISKIP + ((-1) + K1) * JMPMA3 + JMPMA3
          J = II7 + L2 * K1 * ISKIP1 + ((-1) + K1) * MASKP1 + MASKP1
          DEALLOCATE (A0REAL3, A0IMAG2, A1REAL3, A1IMAG2, A2REAL1,
     X      A2IMAG1, T1REAL1, T1IMAG1, T2REAL1, T2IMAG1, T3REAL1,
     X      T3IMAG1, JM2SKP1, JNL2)
cD       call end_interval( 72 )
         IF(MOD(LA,2).NE.0) RETURN
CDIR$ IVDEP
cD       call start_interval( 73 )
        II9 = J
        II8 = I
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (JM2SKP2(L2), T12(L2), X22(L2), X12(L2), X02(L2))
          X02(1:$L2) = A(II8:$L2:ISKIP)
          X12(1:$L2) = A(II8+IB:$L2:ISKIP)
          X22(1:$L2) = A(II8+IC:$L2:ISKIP)
          T12(1:$L2) = X12(1:$L2) - X22(1:$L2)
          C(II9:$L2:ISKIP1) = X02(1:$L2) + T12(1:$L2) * 0.5
          C(II9+MASKP1:$L2:ISKIP1) = -SIN60 * (X12(1:$L2) + X22(1:$L2))
          JM2SKP2(1:$L2) = [II9 + M2SKIP :$ L2 : ISKIP1]
          C(JM2SKP2(1:$L2)) = X02(1:$L2) - T12(1:$L2)
          DEALLOCATE (X02, X12, X22, T12, JM2SKP2)
cD       call end_interval( 73 )
         RETURN
C       ------ FACTOR 4 -----------
400        CONTINUE
        MA4SKP=MASKIP*4
        JMPMA4=JUMP+MA4SKP
        IJ2=M2SKP1
        IJ1=IJ2-MASKP1
        IC=IB+MASKIP
        ID=IC+MASKIP
        L1=1
CDIR$ IVDEP
cD       call start_interval( 74 )
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (T41(L2), T32(L2), T22(L2), T13(L2), A3REAL1(L2),
     X    A2REAL2(L2), A1REAL4(L2), A0REAL4(L2))
          A0REAL4(1:$L2) = A(1:$L2:ISKIP)
          A1REAL4(1:$L2) = A(IB+1:$L2:ISKIP)
          A2REAL2(1:$L2) = A(IC+1:$L2:ISKIP)
          A3REAL1(1:$L2) = A(ID+1:$L2:ISKIP)
          T13(1:$L2) = A0REAL4(1:$L2) + A2REAL2(1:$L2)
          T22(1:$L2) = A1REAL4(1:$L2) + A3REAL1(1:$L2)
          T32(1:$L2) = A0REAL4(1:$L2) - A2REAL2(1:$L2)
          T41(1:$L2) = A3REAL1(1:$L2) - A1REAL4(1:$L2)
          C(1:$L2:ISKIP1) = T13(1:$L2) + T22(1:$L2)
          C(IJ1+1:$L2:ISKIP1) = T32(1:$L2)
          C(IJ2+1:$L2:ISKIP1) = T41(1:$L2)
          C(IJ+1:$L2:ISKIP1) = T13(1:$L2) - T22(1:$L2)
          DEALLOCATE (A0REAL4, A1REAL4, A2REAL2, A3REAL1, T13, T22, T32
     X      , T41)
cD       call end_interval( 74 )
         IF(MA.EQ.M) RETURN
         J=MASKP1+1
         I=MASKIP+1+JUMP
         MM=MHLF
         IF(MOD(LA,2).EQ.0) MM=MM-MA
cD       call start_interval( 75 )
        II11 = J
        II10 = I
        K1 = (MM - MA + MA) / MA
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (JM1L1(L2), JM2SKP3(L2), T4IMAG1(L2), T4REAL1(L2),
     X    T3IMAG2(L2), T3REAL2(L2), T2IMAG2(L2), T2REAL2(L2), T1IMAG2(L2
     X    ), T1REAL2(L2), A3IMAG1(L2), A3REAL2(L2), A2IMAG2(L2), A2REAL3
     X    (L2), A1IMAG3(L2), A1REAL5(L2), A0IMAG3(L2), A0REAL5(L2))
        II25 = (-1)
D        call trace_enter (2073) 
        DO 31 K=MA,MA+((-1)+K1)*MA,MA
        II25 = II25 + 1
          K2=K+K
          JN=IJ-K2 *ISKIP1
          JM1=JN-M2SKP1
          KK=K2+1
          TR1REA = TRIGS(K+K+1)
          TR1IMA = -TRIGSI(K+K+1)
          KK=KK+K2
          TR2REA=TRIGS(KK)
          TR2IMA=-TRIGSI(KK)
          KK=KK+K2
          TR3REA=TRIGS(KK)
          TR3IMA=-TRIGSI(KK)
          L1=1
CDIR$ IVDEP
          II12 = L1
           A0REAL5(1:$L2) = A(II10+L2*II25*ISKIP+II25*JMPMA4:$L2:ISKIP)
           A0IMAG3(1:$L2) = B(II10+L2*II25*ISKIP+II25*JMPMA4:$L2:ISKIP)
           A1REAL5(1:$L2) = A(II10+L2*II25*ISKIP+II25*(JUMP+4*MASKIP)+MA
     X       *ISKIP:$L2:ISKIP) * TR1REA - B(II10+L2*II25*ISKIP+II25*(
     X       JUMP+4*MASKIP)+MA*ISKIP:$L2:ISKIP) * TR1IMA
           A1IMAG3(1:$L2) = B(II10+L2*II25*ISKIP+II25*(JUMP+4*MASKIP)+MA
     X       *ISKIP:$L2:ISKIP) * TR1REA + A(II10+L2*II25*ISKIP+II25*(
     X       JUMP+4*MASKIP)+MA*ISKIP:$L2:ISKIP) * TR1IMA
           A2REAL3(1:$L2) = A(II10+L2*II25*ISKIP+II25*(JUMP+4*MASKIP)+(
     X       IB+MASKIP):$L2:ISKIP) * TR2REA - B(II10+L2*II25*ISKIP+II25*
     X       (JUMP+4*MASKIP)+(IB+MASKIP):$L2:ISKIP) * TR2IMA
           A2IMAG2(1:$L2) = B(II10+L2*II25*ISKIP+II25*(JUMP+4*MASKIP)+(
     X       IB+MASKIP):$L2:ISKIP) * TR2REA + A(II10+L2*II25*ISKIP+II25*
     X       (JUMP+4*MASKIP)+(IB+MASKIP):$L2:ISKIP) * TR2IMA
           A3REAL2(1:$L2) = A(II10+L2*II25*ISKIP+II25*(JUMP+4*MASKIP)+(
     X       IB+MASKIP+MASKIP):$L2:ISKIP) * TR3REA - B(II10+L2*II25*
     X       ISKIP+II25*(JUMP+4*MASKIP)+(IB+MASKIP+MASKIP):$L2:ISKIP) *
     X       TR3IMA
           A3IMAG1(1:$L2) = B(II10+L2*II25*ISKIP+II25*(JUMP+4*MASKIP)+(
     X       IB+MASKIP+MASKIP):$L2:ISKIP) * TR3REA + A(II10+L2*II25*
     X       ISKIP+II25*(JUMP+4*MASKIP)+(IB+MASKIP+MASKIP):$L2:ISKIP) *
     X       TR3IMA
           T1REAL2(1:$L2) = A0REAL5(1:$L2) + A2REAL3(1:$L2)
           T1IMAG2(1:$L2) = A0IMAG3(1:$L2) + A2IMAG2(1:$L2)
           T2REAL2(1:$L2) = A1REAL5(1:$L2) + A3REAL2(1:$L2)
           T2IMAG2(1:$L2) = A1IMAG3(1:$L2) + A3IMAG1(1:$L2)
           T3REAL2(1:$L2) = A0REAL5(1:$L2) - A2REAL3(1:$L2)
           T3IMAG2(1:$L2) = A0IMAG3(1:$L2) - A2IMAG2(1:$L2)
           T4REAL1(1:$L2) = A1REAL5(1:$L2) - A3REAL2(1:$L2)
           T4IMAG1(1:$L2) = A1IMAG3(1:$L2) - A3IMAG1(1:$L2)
           C(II11+L2*II25*ISKIP1+II25*MASKP1:$L2:ISKIP1) = T1REAL2(1:$L2
     X       ) + T2REAL2(1:$L2)
           D(II11+L2*II25*ISKIP1+II25*MASKP1:$L2:ISKIP1) = T1IMAG2(1:$L2
     X       ) + T2IMAG2(1:$L2)
           JM2SKP3(1:$L2) = [II11 + L2 * II25 * ISKIP1 + II25 * MASKP1 +
     X        M2SKP1 :$ L2 : ISKIP1]
           C(JM2SKP3(1:$L2)) = T3REAL2(1:$L2) + T4IMAG1(1:$L2)
           D(JM2SKP3(1:$L2)) = T3IMAG2(1:$L2) - T4REAL1(1:$L2)
           C((N-MA)*ISKIP1-(K+K)*ISKIP1+II12:$L2:ISKIP1) = T1REAL2(1:$L2
     X       ) - T2REAL2(1:$L2)
           D((N-MA)*ISKIP1-(K+K)*ISKIP1+II12:$L2:ISKIP1) = T2IMAG2(1:$L2
     X       ) - T1IMAG2(1:$L2)
           JM1L1(1:$L2) = [JM1 + II12 :$ L2 : ISKIP1]
           C(JM1L1(1:$L2)) = T3REAL2(1:$L2) - T4IMAG1(1:$L2)
           D(JM1L1(1:$L2)) = -T4REAL1(1:$L2) - T3IMAG2(1:$L2)
           I = II10 + ((-1) + (L2 + L2 * II25)) * ISKIP + II25 * JMPMA4
     X       + ISKIP
           J = II11 + ((-1) + (L2 + L2 * II25)) * ISKIP1 + II25 * MASKP1
     X        + ISKIP1
31       CONTINUE
D        call trace_exit (2074) 
          I = II10 + L2 * K1 * ISKIP + ((-1) + K1) * JMPMA4 + JMPMA4
          J = II11 + L2 * K1 * ISKIP1 + ((-1) + K1) * MASKP1 + MASKP1
          DEALLOCATE (A0REAL5, A0IMAG3, A1REAL5, A1IMAG3, A2REAL3,
     X      A2IMAG2, A3REAL2, A3IMAG1, T1REAL2, T1IMAG2, T2REAL2,
     X      T2IMAG2, T3REAL2, T3IMAG2, T4REAL1, T4IMAG1, JM2SKP3, JM1L1)
cD       call end_interval( 75 )
         IF(MOD(LA,2).NE.0) RETURN
CDIR$ IVDEP
cD       call start_interval( 76 )
        II14 = J
        II13 = I
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (JM2SKP4(L2), T23(L2), T14(L2), X31(L2), X23(L2), X13(
     X    L2), X03(L2))
          X03(1:$L2) = A(II13:$L2:ISKIP)
          X13(1:$L2) = A(II13+IB:$L2:ISKIP)
          X23(1:$L2) = A(II13+IC:$L2:ISKIP)
          X31(1:$L2) = A(II13+ID:$L2:ISKIP)
          T14(1:$L2) = SIN45 * (X13(1:$L2) - X31(1:$L2))
          T23(1:$L2) = SIN45 * (X13(1:$L2) + X31(1:$L2))
          C(II14:$L2:ISKIP1) = X03(1:$L2) + T14(1:$L2)
          D(II14:$L2:ISKIP1) = -T23(1:$L2) - X23(1:$L2)
          JM2SKP4(1:$L2) = [II14 + M2SKP1 :$ L2 : ISKIP1]
          C(JM2SKP4(1:$L2)) = X03(1:$L2) - T14(1:$L2)
          D(JM2SKP4(1:$L2)) = X23(1:$L2) - T23(1:$L2)
          DEALLOCATE (X03, X13, X23, X31, T14, T23, JM2SKP4)
cD       call end_interval( 76 )
         RETURN
C        ------- FACTOR 5 ------------
500        CONTINUE
        MA5SKP=MASKIP*5
        KEND=(N-MA)/2+MA
        IF(MOD(LA,2).EQ.0) KEND=(N-2*MA)/2+MA*2
        KDIF=KEND+KEND-M2-MA-M
        IF(MOD(LA,2).EQ.0) KDIF=KDIF-MA
        JMPMA5=JUMP+MA5SKP
        IJ2=M2SKP1
        IJ1=IJ2-MASKP1
        IJ4=IJ2+M2SKP1
        IJ3=IJ4-MASKP1
        IC=IB+MASKIP
        ID=IC+MASKIP
        IE=ID+MASKIP
        L1=1
CDIR$ IVDEP
cD       call start_interval( 77 )
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (T71(L2), T61(L2), T51(L2), T42(L2), T33(L2), T24(L2),
     X    T15(L2), X41(L2), X32(L2), X24(L2), X14(L2), X04(L2))
          X04(1:$L2) = A(1:$L2:ISKIP)
          X14(1:$L2) = A(IB+1:$L2:ISKIP)
          X24(1:$L2) = A(IC+1:$L2:ISKIP)
          X32(1:$L2) = A(ID+1:$L2:ISKIP)
          X41(1:$L2) = A(IE+1:$L2:ISKIP)
          T15(1:$L2) = X14(1:$L2) + X41(1:$L2)
          T24(1:$L2) = X24(1:$L2) + X32(1:$L2)
          T33(1:$L2) = SIN72 * (X14(1:$L2) - X41(1:$L2))
          T42(1:$L2) = SIN72 * (X24(1:$L2) - X32(1:$L2))
          T51(1:$L2) = T15(1:$L2) + T24(1:$L2)
          T61(1:$L2) = SQ54 * (T15(1:$L2) - T24(1:$L2))
          T71(1:$L2) = X04(1:$L2) - 0.25 * T51(1:$L2)
          C(1:$L2:ISKIP1) = X04(1:$L2) + T51(1:$L2)
          C(IJ1+1:$L2:ISKIP1) = T71(1:$L2) + T61(1:$L2)
          C(IJ2+1:$L2:ISKIP1) = -(T33(1:$L2) + SN3672 * T42(1:$L2))
          C(IJ3+1:$L2:ISKIP1) = T71(1:$L2) - T61(1:$L2)
          C(IJ4+1:$L2:ISKIP1) = -(SN3672 * T33(1:$L2) - T42(1:$L2))
          DEALLOCATE (X04, X14, X24, X32, X41, T15, T24, T33, T42, T51,
     X      T61, T71)
cD       call end_interval( 77 )
         IF(MA.EQ.M) RETURN
         J=MASKP1+1
         I=MASKIP+1+JUMP
         MM=MHLF
         IF(MOD(LA,2).EQ.0) MM=MM-MA
cD       call start_interval( 78 )
        II16 = J
        II15 = I
        K1 = (MM - MA + MA) / MA
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (JNLM2S1(L2), JNL4(L2), JM41(L2), JM2SKP5(L2), T11IMA1(
     X    L2), T11REA1(L2), T10IMA1(L2), T10REA1(L2), T9IMAG1(L2),
     X    T9REAL1(L2), T8IMAG1(L2), T8REAL1(L2), T7IMAG1(L2), T7REAL1(L2
     X    ), T6IMAG1(L2), T6REAL1(L2), T5IMAG1(L2), T5REAL1(L2), T4IMAG2
     X    (L2), T4REAL2(L2), T3IMAG3(L2), T3REAL3(L2), T2IMAG3(L2),
     X    T2REAL3(L2), T1IMAG3(L2), T1REAL3(L2), A4IMAG1(L2), A4REAL1(L2
     X    ), A3IMAG2(L2), A3REAL3(L2), A2IMAG3(L2), A2REAL4(L2), A1IMAG4
     X    (L2), A1REAL6(L2), A0IMAG4(L2), A0REAL6(L2))
        II26 = (-1)
D        call trace_enter (2075) 
        DO 41 K=MA,MA+((-1)+K1)*MA,MA
        II26 = II26 + 1
          K2=K+K
          KJ=KDIF-K2
          KJ=(KJ+KJ)*ISKIP1
          KK=K2+1
          TR1REA = TRIGS(K+K+1)
          TR1IMA = -TRIGSI(K+K+1)
          KK=KK+K2
          TR2REA=TRIGS(KK)
          TR2IMA=-TRIGSI(KK)
          KK=KK+K2
          TR3REA=TRIGS(KK)
          TR3IMA=-TRIGSI(KK)
          KK=KK+K2
          TR4REA=TRIGS(KK)
          TR4IMA=-TRIGSI(KK)
CDIR$ IVDEP
           A0REAL6(1:$L2) = A(II15+L2*II26*ISKIP+II26*JMPMA5:$L2:ISKIP)
           A0IMAG4(1:$L2) = B(II15+L2*II26*ISKIP+II26*JMPMA5:$L2:ISKIP)
           A1REAL6(1:$L2) = A(II15+L2*II26*ISKIP+II26*JMPMA5+MA*ISKIP:$
     X       L2:ISKIP) * TR1REA - B(II15+L2*II26*ISKIP+II26*JMPMA5+MA*
     X       ISKIP:$L2:ISKIP) * TR1IMA
           A1IMAG4(1:$L2) = B(II15+L2*II26*ISKIP+II26*JMPMA5+MA*ISKIP:$
     X       L2:ISKIP) * TR1REA + A(II15+L2*II26*ISKIP+II26*JMPMA5+MA*
     X       ISKIP:$L2:ISKIP) * TR1IMA
           A2REAL4(1:$L2) = A(II15+L2*II26*ISKIP+II26*JMPMA5+IC:$L2:
     X       ISKIP) * TR2REA - B(II15+L2*II26*ISKIP+II26*JMPMA5+IC:$L2:
     X       ISKIP) * TR2IMA
           A2IMAG3(1:$L2) = B(II15+L2*II26*ISKIP+II26*JMPMA5+IC:$L2:
     X       ISKIP) * TR2REA + A(II15+L2*II26*ISKIP+II26*JMPMA5+IC:$L2:
     X       ISKIP) * TR2IMA
           A3REAL3(1:$L2) = A(II15+L2*II26*ISKIP+II26*JMPMA5+ID:$L2:
     X       ISKIP) * TR3REA - B(II15+L2*II26*ISKIP+II26*JMPMA5+ID:$L2:
     X       ISKIP) * TR3IMA
           A3IMAG2(1:$L2) = B(II15+L2*II26*ISKIP+II26*JMPMA5+ID:$L2:
     X       ISKIP) * TR3REA + A(II15+L2*II26*ISKIP+II26*JMPMA5+ID:$L2:
     X       ISKIP) * TR3IMA
           A4REAL1(1:$L2) = A(II15+L2*II26*ISKIP+II26*(JUMP+MA5SKP)+(IB+
     X       MASKIP+MASKIP+MASKIP):$L2:ISKIP) * TR4REA - B(II15+L2*II26*
     X       ISKIP+II26*(JUMP+MA5SKP)+(IB+MASKIP+MASKIP+MASKIP):$L2:
     X       ISKIP) * TR4IMA
           A4IMAG1(1:$L2) = B(II15+L2*II26*ISKIP+II26*(JUMP+MA5SKP)+(IB+
     X       MASKIP+MASKIP+MASKIP):$L2:ISKIP) * TR4REA + A(II15+L2*II26*
     X       ISKIP+II26*(JUMP+MA5SKP)+(IB+MASKIP+MASKIP+MASKIP):$L2:
     X       ISKIP) * TR4IMA
           T1REAL3(1:$L2) = A1REAL6(1:$L2) + A4REAL1(1:$L2)
           T1IMAG3(1:$L2) = A1IMAG4(1:$L2) + A4IMAG1(1:$L2)
           T2REAL3(1:$L2) = A2REAL4(1:$L2) + A3REAL3(1:$L2)
           T2IMAG3(1:$L2) = A2IMAG3(1:$L2) + A3IMAG2(1:$L2)
           T3REAL3(1:$L2) = SIN72 * (A1REAL6(1:$L2) - A4REAL1(1:$L2))
           T3IMAG3(1:$L2) = SIN72 * (A1IMAG4(1:$L2) - A4IMAG1(1:$L2))
           T4REAL2(1:$L2) = SIN72 * (A2REAL4(1:$L2) - A3REAL3(1:$L2))
           T4IMAG2(1:$L2) = SIN72 * (A2IMAG3(1:$L2) - A3IMAG2(1:$L2))
           T5REAL1(1:$L2) = T1REAL3(1:$L2) + T2REAL3(1:$L2)
           T5IMAG1(1:$L2) = T1IMAG3(1:$L2) + T2IMAG3(1:$L2)
           T6REAL1(1:$L2) = SQ54 * (T1REAL3(1:$L2) - T2REAL3(1:$L2))
           T6IMAG1(1:$L2) = SQ54 * (T1IMAG3(1:$L2) - T2IMAG3(1:$L2))
           T7REAL1(1:$L2) = A0REAL6(1:$L2) - T5REAL1(1:$L2) * 0.25
           T7IMAG1(1:$L2) = A0IMAG4(1:$L2) - T5IMAG1(1:$L2) * 0.25
           T8REAL1(1:$L2) = T7REAL1(1:$L2) + T6REAL1(1:$L2)
           T8IMAG1(1:$L2) = T7IMAG1(1:$L2) + T6IMAG1(1:$L2)
           T9REAL1(1:$L2) = T7REAL1(1:$L2) - T6REAL1(1:$L2)
           T9IMAG1(1:$L2) = T7IMAG1(1:$L2) - T6IMAG1(1:$L2)
           T10REA1(1:$L2) = T3REAL3(1:$L2) + SN3672 * T4REAL2(1:$L2)
           T10IMA1(1:$L2) = T3IMAG3(1:$L2) + SN3672 * T4IMAG2(1:$L2)
           T11REA1(1:$L2) = SN3672 * T3REAL3(1:$L2) - T4REAL2(1:$L2)
           T11IMA1(1:$L2) = SN3672 * T3IMAG3(1:$L2) - T4IMAG2(1:$L2)
           C(II16+L2*II26*ISKIP1+II26*MASKP1:$L2:ISKIP1) = A0REAL6(1:$L2
     X       ) + T5REAL1(1:$L2)
           D(II16+L2*II26*ISKIP1+II26*MASKP1:$L2:ISKIP1) = A0IMAG4(1:$L2
     X       ) + T5IMAG1(1:$L2)
           JM2SKP5(1:$L2) = [II16 + L2 * II26 * ISKIP1 + II26 * MASKP1 +
     X        M2SKP1 :$ L2 : ISKIP1]
           C(JM2SKP5(1:$L2)) = T8REAL1(1:$L2) + T10IMA1(1:$L2)
           D(JM2SKP5(1:$L2)) = T8IMAG1(1:$L2) - T10REA1(1:$L2)
           JM41(1:$L2) = [II16 + L2 * II26 * ISKIP1 + II26 * (MA *
     X       ISKIP1) :$ L2 : ISKIP1] + (N / IFAC * ISKIP1 + N / IFAC *
     X       ISKIP1) + M2SKP1
           C(JM41(1:$L2)) = T9REAL1(1:$L2) + T11IMA1(1:$L2)
           D(JM41(1:$L2)) = T9IMAG1(1:$L2) - T11REA1(1:$L2)
           JNL4(1:$L2) = [KJ + (II16 + L2 * II26 * ISKIP1 + II26 *
     X       MASKP1) :$ L2 : ISKIP1]
           C(JNL4(1:$L2)) = T9REAL1(1:$L2) - T11IMA1(1:$L2)
           D(JNL4(1:$L2)) = -(T9IMAG1(1:$L2) + T11REA1(1:$L2))
           JNLM2S1(1:$L2) = [KJ + (II16 + L2 * II26 * ISKIP1 + II26 * (
     X       MA * ISKIP1)) - M2SKP1 :$ L2 : ISKIP1]
           C(JNLM2S1(1:$L2)) = T8REAL1(1:$L2) - T10IMA1(1:$L2)
           D(JNLM2S1(1:$L2)) = -(T8IMAG1(1:$L2) + T10REA1(1:$L2))
           I = II15 + ((-1) + (L2 + L2 * II26)) * ISKIP + II26 * JMPMA5
     X       + ISKIP
           J = II16 + ((-1) + (L2 + L2 * II26)) * ISKIP1 + II26 * MASKP1
     X        + ISKIP1
41       CONTINUE
D        call trace_exit (2076) 
          I = II15 + L2 * K1 * ISKIP + ((-1) + K1) * JMPMA5 + JMPMA5
          J = II16 + L2 * K1 * ISKIP1 + ((-1) + K1) * MASKP1 + MASKP1
          DEALLOCATE (A0REAL6, A0IMAG4, A1REAL6, A1IMAG4, A2REAL4,
     X      A2IMAG3, A3REAL3, A3IMAG2, A4REAL1, A4IMAG1, T1REAL3,
     X      T1IMAG3, T2REAL3, T2IMAG3, T3REAL3, T3IMAG3, T4REAL2,
     X      T4IMAG2, T5REAL1, T5IMAG1, T6REAL1, T6IMAG1, T7REAL1,
     X      T7IMAG1, T8REAL1, T8IMAG1, T9REAL1, T9IMAG1, T10REA1,
     X      T10IMA1, T11REA1, T11IMA1, JM2SKP5, JM41, JNL4, JNLM2S1)
cD       call end_interval( 78 )
         IF(MOD(LA,2).NE.0) RETURN
CDIR$ IVDEP
cD       call start_interval( 79 )
        II18 = J
        II17 = I
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (JM2SKP6(L2), T72(L2), T62(L2), T52(L2), T43(L2), T34(
     X    L2), T25(L2), T16(L2), X42(L2), X33(L2), X25(L2), X15(L2), X05
     X    (L2))
          X05(1:$L2) = A(II17:$L2:ISKIP)
          X15(1:$L2) = A(II17+IB:$L2:ISKIP)
          X25(1:$L2) = A(II17+IC:$L2:ISKIP)
          X33(1:$L2) = A(II17+ID:$L2:ISKIP)
          X42(1:$L2) = A(II17+IE:$L2:ISKIP)
          T16(1:$L2) = X15(1:$L2) - X42(1:$L2)
          T25(1:$L2) = X15(1:$L2) + X42(1:$L2)
          T34(1:$L2) = X25(1:$L2) - X33(1:$L2)
          T43(1:$L2) = X25(1:$L2) + X33(1:$L2)
          T52(1:$L2) = T16(1:$L2) - T34(1:$L2)
          T62(1:$L2) = X05(1:$L2) + 0.25 * T52(1:$L2)
          T72(1:$L2) = SQ54 * (T16(1:$L2) + T34(1:$L2))
          C(II18:$L2:ISKIP1) = T62(1:$L2) + T72(1:$L2)
          D(II18:$L2:ISKIP1) = -SIN36 * T25(1:$L2) - SIN72 * T43(1:$L2)
          JM2SKP6(1:$L2) = [II18 + M2SKP1 :$ L2 : ISKIP1]
          C(JM2SKP6(1:$L2)) = T62(1:$L2) - T72(1:$L2)
          D(JM2SKP6(1:$L2)) = -SIN72 * T25(1:$L2) + SIN36 * T43(1:$L2)
          C(JM2SKP6(1:$L2)+M2SKP1) = X05(1:$L2) - T52(1:$L2)
          DEALLOCATE (X05, X15, X25, X33, X42, T16, T25, T34, T43, T52,
     X      T62, T72, JM2SKP6)
cD       call end_interval( 79 )
         RETURN
C        ---- FACTOR 6 -----------
600        CONTINUE
        MA6SKP=MASKIP*6
        JMPMA6=JUMP+MA6SKP
        IJ2=M2SKP1
        IJ1=IJ2-MASKP1
        IC=IB+MASKIP
        ID=IC+MASKIP
        IE=ID+MASKIP
        IG=IE+MASKIP
        L1=1
CDIR$ IVDEP
cD       call start_interval( 80 )
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (Y5IMAG1(L2), Y5REAL1(L2), Y1IMAG1(L2), Y1REAL1(L2),
     X    Y3REAL1(L2), Y2IMAG1(L2), Y2REAL1(L2), Y4IMAG1(L2), Y4REAL1(L2
     X    ), Y0REAL1(L2), T3REAL4(L2), T2REAL4(L2), T1REAL4(L2), X51(L2)
     X    , X43(L2), X34(L2), X26(L2), X16(L2), X06(L2))
          X06(1:$L2) = A(1:$L2:ISKIP)
          X16(1:$L2) = A(IB+1:$L2:ISKIP)
          X26(1:$L2) = A(IC+1:$L2:ISKIP)
          X34(1:$L2) = A(ID+1:$L2:ISKIP)
          X43(1:$L2) = A(IE+1:$L2:ISKIP)
          X51(1:$L2) = A(IG+1:$L2:ISKIP)
           T1REAL4(1:$L2) = X26(1:$L2) + X43(1:$L2)
           T2REAL4(1:$L2) = X06(1:$L2) - 0.5 * T1REAL4(1:$L2)
           T3REAL4(1:$L2) = SIN60 * (X26(1:$L2) - X43(1:$L2))
           Y0REAL1(1:$L2) = X06(1:$L2) + T1REAL4(1:$L2)
           Y4REAL1(1:$L2) = T2REAL4(1:$L2)
           Y4IMAG1(1:$L2) = -T3REAL4(1:$L2)
           Y2REAL1(1:$L2) = T2REAL4(1:$L2)
           Y2IMAG1(1:$L2) = T3REAL4(1:$L2)
           T1REAL4(1:$L2) = X51(1:$L2) + X16(1:$L2)
           T2REAL4(1:$L2) = X34(1:$L2) - 0.5 * T1REAL4(1:$L2)
           T3REAL4(1:$L2) = SIN60 * (X51(1:$L2) - X16(1:$L2))
           Y3REAL1(1:$L2) = X34(1:$L2) + T1REAL4(1:$L2)
           Y1REAL1(1:$L2) = T2REAL4(1:$L2)
           Y1IMAG1(1:$L2) = -T3REAL4(1:$L2)
           Y5REAL1(1:$L2) = T2REAL4(1:$L2)
           Y5IMAG1(1:$L2) = T3REAL4(1:$L2)
           C(1:$L2:ISKIP1) = Y0REAL1(1:$L2) + Y3REAL1(1:$L2)
           C(M2SKP1-MASKP1+1:$L2:ISKIP1) = Y4REAL1(1:$L2) - Y1REAL1(1:$
     X       L2)
           D(M2SKP1-MASKP1+1:$L2:ISKIP1) = Y4IMAG1(1:$L2) - Y1IMAG1(1:$
     X       L2)
           C(M2SKP1-MASKP1+(N/IFAC*ISKIP1+N/IFAC*ISKIP1)+1:$L2:ISKIP1)
     X        = Y2REAL1(1:$L2) + Y5REAL1(1:$L2)
           D(M2SKP1-MASKP1+(N/IFAC*ISKIP1+N/IFAC*ISKIP1)+1:$L2:ISKIP1)
     X        = Y2IMAG1(1:$L2) + Y5IMAG1(1:$L2)
           C(IJ+1:$L2:ISKIP1) = Y0REAL1(1:$L2) - Y3REAL1(1:$L2)
           DEALLOCATE (X06, X16, X26, X34, X43, X51, T1REAL4, T2REAL4,
     X       T3REAL4, Y0REAL1, Y4REAL1, Y4IMAG1, Y2REAL1, Y2IMAG1,
     X       Y3REAL1, Y1REAL1, Y1IMAG1, Y5REAL1, Y5IMAG1)
cD       call end_interval( 80 )
         IF(MA.EQ.M) RETURN
         J=MASKP1+1
         I=MASKIP+1+JUMP
         MM=MHLF
         IF(MOD(LA,2).EQ.0) MM=MM-MA
cD       call start_interval( 81 )
        II20 = J
        II19 = I
        K1 = (MM - MA + MA) / MA
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (JNLM41(L2), JNLM2S2(L2), JNL5(L2), JM42(L2), JM2SKP7(
     X    L2), Y5IMAG2(L2), Y5REAL2(L2), Y1IMAG2(L2), Y1REAL2(L2),
     X    Y3IMAG1(L2), Y3REAL2(L2), Y2IMAG2(L2), Y2REAL2(L2), Y4IMAG2(L2
     X    ), Y4REAL2(L2), Y0IMAG1(L2), Y0REAL2(L2), T3IMAG4(L2), T3REAL5
     X    (L2), T2IMAG4(L2), T2REAL5(L2), T1IMAG4(L2), T1REAL5(L2),
     X    A5IMAG1(L2), A5REAL1(L2), A4IMAG2(L2), A4REAL2(L2), A3IMAG3(L2
     X    ), A3REAL4(L2), A2IMAG4(L2), A2REAL5(L2), A1IMAG5(L2), A1REAL7
     X    (L2), A0IMAG5(L2), A0REAL7(L2))
        II27 = (-1)
D        call trace_enter (2077) 
        DO 51 K=MA,MA+((-1)+K1)*MA,MA
        II27 = II27 + 1
          K2=K+K
         JN=IJ-K2*ISKIP1
         JM1=JN-M2SKP1
          KK=K2+1
          TR1REA = TRIGS(K+K+1)
          TR1IMA = -TRIGSI(K+K+1)
          KK=KK+K2
          TR2REA=TRIGS(KK)
          TR2IMA=-TRIGSI(KK)
          KK=KK+K2
          TR3REA=TRIGS(KK)
          TR3IMA=-TRIGSI(KK)
          KK=KK+K2
          TR4REA=TRIGS(KK)
          TR4IMA=-TRIGSI(KK)
          KK=KK+K2
          TR5REA=TRIGS(KK)
          TR5IMA=-TRIGSI(KK)
CDIR$ IVDEP
           A0REAL7(1:$L2) = A(II19+L2*II27*ISKIP+II27*JMPMA6:$L2:ISKIP)
           A0IMAG5(1:$L2) = B(II19+L2*II27*ISKIP+II27*JMPMA6:$L2:ISKIP)
           A1REAL7(1:$L2) = A(II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+MA
     X       *ISKIP:$L2:ISKIP) * TR1REA - B(II19+L2*II27*ISKIP+II27*(
     X       JUMP+6*MASKIP)+MA*ISKIP:$L2:ISKIP) * TR1IMA
           A1IMAG5(1:$L2) = B(II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+MA
     X       *ISKIP:$L2:ISKIP) * TR1REA + A(II19+L2*II27*ISKIP+II27*(
     X       JUMP+6*MASKIP)+MA*ISKIP:$L2:ISKIP) * TR1IMA
           A2REAL5(1:$L2) = A(II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+(
     X       IB+MASKIP):$L2:ISKIP) * TR2REA - B(II19+L2*II27*ISKIP+II27*
     X       (JUMP+6*MASKIP)+(IB+MASKIP):$L2:ISKIP) * TR2IMA
           A2IMAG4(1:$L2) = B(II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+(
     X       IB+MASKIP):$L2:ISKIP) * TR2REA + A(II19+L2*II27*ISKIP+II27*
     X       (JUMP+6*MASKIP)+(IB+MASKIP):$L2:ISKIP) * TR2IMA
           A3REAL4(1:$L2) = A(II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+(
     X       IB+MASKIP+MASKIP):$L2:ISKIP) * TR3REA - B(II19+L2*II27*
     X       ISKIP+II27*(JUMP+6*MASKIP)+(IB+MASKIP+MASKIP):$L2:ISKIP) *
     X       TR3IMA
           A3IMAG3(1:$L2) = B(II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+(
     X       IB+MASKIP+MASKIP):$L2:ISKIP) * TR3REA + A(II19+L2*II27*
     X       ISKIP+II27*(JUMP+6*MASKIP)+(IB+MASKIP+MASKIP):$L2:ISKIP) *
     X       TR3IMA
           A4REAL2(1:$L2) = A(II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+(
     X       IB+MASKIP+MASKIP+MASKIP):$L2:ISKIP) * TR4REA - B(II19+L2*
     X       II27*ISKIP+II27*(JUMP+6*MASKIP)+(IB+MASKIP+MASKIP+MASKIP):$
     X       L2:ISKIP) * TR4IMA
           A4IMAG2(1:$L2) = B(II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+(
     X       IB+MASKIP+MASKIP+MASKIP):$L2:ISKIP) * TR4REA + A(II19+L2*
     X       II27*ISKIP+II27*(JUMP+6*MASKIP)+(IB+MASKIP+MASKIP+MASKIP):$
     X       L2:ISKIP) * TR4IMA
           A5REAL1(1:$L2) = A(II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+(
     X       IB+MASKIP+MASKIP+MASKIP+MASKIP):$L2:ISKIP) * TR5REA - B(
     X       II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+(IB+MASKIP+MASKIP+
     X       MASKIP+MASKIP):$L2:ISKIP) * TR5IMA
           A5IMAG1(1:$L2) = B(II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+(
     X       IB+MASKIP+MASKIP+MASKIP+MASKIP):$L2:ISKIP) * TR5REA + A(
     X       II19+L2*II27*ISKIP+II27*(JUMP+6*MASKIP)+(IB+MASKIP+MASKIP+
     X       MASKIP+MASKIP):$L2:ISKIP) * TR5IMA
           T1REAL5(1:$L2) = A2REAL5(1:$L2) + A4REAL2(1:$L2)
           T1IMAG4(1:$L2) = A2IMAG4(1:$L2) + A4IMAG2(1:$L2)
           T2REAL5(1:$L2) = A0REAL7(1:$L2) - 0.5 * T1REAL5(1:$L2)
           T2IMAG4(1:$L2) = A0IMAG5(1:$L2) - 0.5 * T1IMAG4(1:$L2)
           T3REAL5(1:$L2) = SIN60 * (A2REAL5(1:$L2) - A4REAL2(1:$L2))
           T3IMAG4(1:$L2) = SIN60 * (A2IMAG4(1:$L2) - A4IMAG2(1:$L2))
           Y0REAL2(1:$L2) = A0REAL7(1:$L2) + T1REAL5(1:$L2)
           Y0IMAG1(1:$L2) = A0IMAG5(1:$L2) + T1IMAG4(1:$L2)
           Y4REAL2(1:$L2) = T2REAL5(1:$L2) + T3IMAG4(1:$L2)
           Y4IMAG2(1:$L2) = T2IMAG4(1:$L2) - T3REAL5(1:$L2)
           Y2REAL2(1:$L2) = T2REAL5(1:$L2) - T3IMAG4(1:$L2)
           Y2IMAG2(1:$L2) = T2IMAG4(1:$L2) + T3REAL5(1:$L2)
           T1REAL5(1:$L2) = A5REAL1(1:$L2) + A1REAL7(1:$L2)
           T1IMAG4(1:$L2) = A5IMAG1(1:$L2) + A1IMAG5(1:$L2)
           T2REAL5(1:$L2) = A3REAL4(1:$L2) - 0.5 * T1REAL5(1:$L2)
           T2IMAG4(1:$L2) = A3IMAG3(1:$L2) - 0.5 * T1IMAG4(1:$L2)
           T3REAL5(1:$L2) = SIN60 * (A5REAL1(1:$L2) - A1REAL7(1:$L2))
           T3IMAG4(1:$L2) = SIN60 * (A5IMAG1(1:$L2) - A1IMAG5(1:$L2))
           Y3REAL2(1:$L2) = A3REAL4(1:$L2) + T1REAL5(1:$L2)
           Y3IMAG1(1:$L2) = A3IMAG3(1:$L2) + T1IMAG4(1:$L2)
           Y1REAL2(1:$L2) = T2REAL5(1:$L2) + T3IMAG4(1:$L2)
           Y1IMAG2(1:$L2) = T2IMAG4(1:$L2) - T3REAL5(1:$L2)
           Y5REAL2(1:$L2) = T2REAL5(1:$L2) - T3IMAG4(1:$L2)
           Y5IMAG2(1:$L2) = T2IMAG4(1:$L2) + T3REAL5(1:$L2)
           C(II20+L2*II27*ISKIP1+II27*MASKP1:$L2:ISKIP1) = Y0REAL2(1:$L2
     X       ) + Y3REAL2(1:$L2)
           D(II20+L2*II27*ISKIP1+II27*MASKP1:$L2:ISKIP1) = Y0IMAG1(1:$L2
     X       ) + Y3IMAG1(1:$L2)
           JM2SKP7(1:$L2) = [II20 + L2 * II27 * ISKIP1 + II27 * MASKP1 +
     X        M2SKP1 :$ L2 : ISKIP1]
           C(JM2SKP7(1:$L2)) = Y4REAL2(1:$L2) - Y1REAL2(1:$L2)
           D(JM2SKP7(1:$L2)) = Y4IMAG2(1:$L2) - Y1IMAG2(1:$L2)
           JM42(1:$L2) = [II20 + L2 * II27 * ISKIP1 + II27 * (MA *
     X       ISKIP1) :$ L2 : ISKIP1] + (N / IFAC * ISKIP1 + N / IFAC *
     X       ISKIP1) + M2SKP1
           C(JM42(1:$L2)) = Y2REAL2(1:$L2) + Y5REAL2(1:$L2)
           D(JM42(1:$L2)) = Y2IMAG2(1:$L2) + Y5IMAG2(1:$L2)
           JNL5(1:$L2) = [JN + 1 :$ L2 : ISKIP]
           C((N-MA)*ISKIP1-(K+K)*ISKIP1+1:$L2:ISKIP) = Y0REAL2(1:$L2) -
     X       Y3REAL2(1:$L2)
           D((N-MA)*ISKIP1-(K+K)*ISKIP1+1:$L2:ISKIP) = -(Y0IMAG1(1:$L2)
     X       - Y3IMAG1(1:$L2))
           JNLM2S2(1:$L2) = JNL5(1:$L2) - M2SKP1
           C(JNLM2S2(1:$L2)) = Y4REAL2(1:$L2) + Y1REAL2(1:$L2)
           D(JNLM2S2(1:$L2)) = -(Y4IMAG2(1:$L2) + Y1IMAG2(1:$L2))
           JNLM41(1:$L2) = JNLM2S2(1:$L2) - M2SKP1
           C(JNLM41(1:$L2)) = Y2REAL2(1:$L2) - Y5REAL2(1:$L2)
           D(JNLM41(1:$L2)) = -(Y2IMAG2(1:$L2) - Y5IMAG2(1:$L2))
           I = II19 + ((-1) + (L2 + L2 * II27)) * ISKIP + II27 * JMPMA6
     X       + ISKIP
           J = II20 + ((-1) + (L2 + L2 * II27)) * ISKIP1 + II27 * MASKP1
     X        + ISKIP1
51       CONTINUE
D        call trace_exit (2078) 
          I = II19 + L2 * K1 * ISKIP + ((-1) + K1) * JMPMA6 + JMPMA6
          J = II20 + L2 * K1 * ISKIP1 + ((-1) + K1) * MASKP1 + MASKP1
          DEALLOCATE (A0REAL7, A0IMAG5, A1REAL7, A1IMAG5, A2REAL5,
     X      A2IMAG4, A3REAL4, A3IMAG3, A4REAL2, A4IMAG2, A5REAL1,
     X      A5IMAG1, T1REAL5, T1IMAG4, T2REAL5, T2IMAG4, T3REAL5,
     X      T3IMAG4, Y0REAL2, Y0IMAG1, Y4REAL2, Y4IMAG2, Y2REAL2,
     X      Y2IMAG2, Y3REAL2, Y3IMAG1, Y1REAL2, Y1IMAG2, Y5REAL2,
     X      Y5IMAG2, JM2SKP7, JM42, JNL5, JNLM2S2, JNLM41)
cD       call end_interval( 81 )
         IF(MOD(LA,2).NE.0) RETURN
CDIR$ IVDEP
cD       call start_interval( 82 )
        II22 = J
        II21 = I
        L2 = (MA * ISKIP + ISKIP - 1) / ISKIP
        ALLOCATE (JM2SKP8(L2), T63(L2), T53(L2), T44(L2), T35(L2), T26(
     X    L2), T17(L2), X52(L2), X44(L2), X35(L2), X27(L2), X17(L2), X07
     X    (L2))
          X07(1:$L2) = A(II21:$L2:ISKIP)
          X17(1:$L2) = A(II21+IB:$L2:ISKIP)
          X27(1:$L2) = A(II21+IC:$L2:ISKIP)
          X35(1:$L2) = A(II21+ID:$L2:ISKIP)
          X44(1:$L2) = A(II21+IE:$L2:ISKIP)
          X52(1:$L2) = A(II21+IG:$L2:ISKIP)
          T17(1:$L2) = SIN60 * (X52(1:$L2) - X17(1:$L2))
          T26(1:$L2) = SIN60 * (X27(1:$L2) + X44(1:$L2))
          T35(1:$L2) = X27(1:$L2) - X44(1:$L2)
          T44(1:$L2) = X17(1:$L2) + X52(1:$L2)
          T53(1:$L2) = X07(1:$L2) + 0.5 * T35(1:$L2)
          T63(1:$L2) = -X35(1:$L2) - 0.5 * T44(1:$L2)
          C(II22:$L2:ISKIP1) = T53(1:$L2) - T17(1:$L2)
          D(II22:$L2:ISKIP1) = T63(1:$L2) - T26(1:$L2)
          JM2SKP8(1:$L2) = [II22 + M2SKP1 :$ L2 : ISKIP1]
          C(JM2SKP8(1:$L2)) = X07(1:$L2) - T35(1:$L2)
          D(JM2SKP8(1:$L2)) = X35(1:$L2) - T44(1:$L2)
          C(JM2SKP8(1:$L2)+(N/IFAC*ISKIP1+N/IFAC*ISKIP1)) = T53(1:$L2) +
     X       T17(1:$L2)
          D(JM2SKP8(1:$L2)+(N/IFAC*ISKIP1+N/IFAC*ISKIP1)) = T63(1:$L2) +
     X       T26(1:$L2)
          DEALLOCATE (X07, X17, X27, X35, X44, X52, T17, T26, T35, T44,
     X      T53, T63, JM2SKP8)
cD       call end_interval( 82 )
         RETURN
         END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
C-----------------------------------------------------------------
C
C       PERFORM COMPLEX TO REAL RFFT PASS BASED ON DECIMATION IN
C        FREQUENCY
C
C-----------------------------------------------------------------
        SUBROUTINE RPASSM(A,B,C,D,TRIGS,TRIGSI,IFAC,LA,MA,
     .      ISKIP,ISKIP1,N)
        DIMENSION A(N),C(N),TRIGS(1),TRIGSI(1),B(1),D(1)
        SAVE SIN45,SIN60,SIN72,SIN36,SQ54,SN3672,IFLAG
        INTEGER II7, II8, II11, II12, II13
     X    , II14, II15, II16, K1, II23
        INTEGER IM2SKP1 (:), JNL1 (:), IM2SKP2 (:), IM2SKP4 (:), IM2SKP5
     X     (:), JNL3 (:), IM41 (:), JNLM2S1 (:), IM2SKP6 (:)
        REAL Y01 (:), Y11 (:), A0REAL1 (:), ALJNRE1 (:), A0IMAG1 (:),
     X    ALJNIM1 (:), A01 (:), A11 (:), B11 (:), T21 (:), T31 (:),
     X    A0REAL2 (:), A0IMAG2 (:), A1REAL1 (:), A1IMAG1 (:), A2REAL1 (:
     X    ), A2IMAG1 (:), T1REAL1 (:), T1IMAG1 (:), T2REAL1 (:), T2IMAG1
     X     (:), T3REAL1 (:), T3IMAG1 (:), X1REAL1 (:), X1IMAG1 (:),
     X    X2REAL1 (:), X2IMAG1 (:), A02 (:), A12 (:), B01 (:), T12 (:),
     X    Y02 (:), Y12 (:), T32 (:), T13 (:), Y31 (:), Y21 (:), A03 (:)
     X    , A13 (:), B12 (:)
        REAL T22 (:), B02 (:), T14 (:), A0REAL4 (:), A0IMAG4 (:),
     X    A1REAL3 (:), A1IMAG3 (:), A2REAL3 (:), A2IMAG3 (:), T1REAL3 (:
     X    ), T1IMAG3 (:), T2REAL3 (:), T2IMAG3 (:), T3REAL3 (:), T3IMAG3
     X     (:), X1REAL3 (:), X1IMAG3 (:), X2REAL3 (:), X2IMAG3 (:),
     X    A3REAL2 (:), A3IMAG2 (:), T4REAL2 (:), T4IMAG2 (:), X3REAL2 (:
     X    ), X3IMAG2 (:), A4REAL1 (:), A4IMAG1 (:), T5REAL1 (:), T5IMAG1
     X     (:), T6REAL1 (:), T6IMAG1 (:), T7REAL1 (:), T7IMAG1 (:),
     X    T8REAL1 (:), T8IMAG1 (:), T9REAL1 (:), T9IMAG1 (:), T10REA1 (:
     X    ), T10IMA1 (:), T11REA1 (:)
        REAL T11IMA1 (:), X4REAL1 (:), X4IMAG1 (:), A05 (:), A15 (:),
     X    B14 (:), T23 (:), T34 (:), B03 (:), T15 (:), A22 (:), T42 (:)
     X    , T52 (:), T62 (:), T72 (:), A06 (:), A16 (:), B15 (:),
     X    T2REAL4 (:), T3IMAG4 (:), X1REAL4 (:), X2REAL4 (:), X3REAL3 (:
     X    ), A23 (:), B22 (:), X4REAL2 (:), A31 (:), Y0REAL1 (:),
     X    Y4REAL1 (:), Y2REAL1 (:), Y3REAL1 (:), Y1REAL1 (:), Y5REAL1 (:
     X    ), X0REAL1 (:), X5REAL1 (:)
        DATA IFLAG /0/
        IF(IFLAG.EQ.0) THEN
         IFLAG=1
         SIN45=0.5*SQRT(2.)
         SIN60=SIN(3.141592653589793/3.)
         SIN72=SIN(3.141592653589793*72./180.)
         SIN36=SIN(3.141592653589793*36./180.)
         SQ54=0.25*SQRT(5.)
         SN3672=SIN36/SIN72
        END IF
        M=N/IFAC
        M2=M+M
        MSKIP=M*ISKIP
        M2SKIP=MSKIP+MSKIP
        MHLF=M/2
        LASKIP=LA*ISKIP
        LASKP1=LA*ISKIP1
        IB=LASKP1
        JUMP=(IFAC-1)*LASKP1
        JUMP3=JUMP*3
        IJ=(N-LA)*ISKIP
        GO TO (100,200,300,400,500,600),IFAC
 
 100    PRINT *,'**** RADIX ONE ENCOUNTERED ****'
        STOP 999
 
 200    CONTINUE
C       ------- FACTOR TWO ------------
C         CALCULATE DC
        L1=1
CDIR$ IVDEP
cD       call start_interval( 53 )
        ALLOCATE (Y11(LA), Y01(LA))
          Y01(1:$LA) = A(1:$LA:ISKIP)
          Y11(1:$LA) = A(IJ+1:$LA:ISKIP)
          C(1:$LA:ISKIP1) = Y01(1:$LA) + Y11(1:$LA)
          C(IB+1:$LA:ISKIP1) = Y01(1:$LA) - Y11(1:$LA)
          DEALLOCATE (Y01, Y11)
cD       call end_interval( 53 )
        IF(LA.EQ.M) RETURN
        I=LASKIP+1
        J=LASKP1+1+JUMP
        MM=MHLF
        IF(MOD(MA,2).EQ.0) MM=MM-LA
cD       call start_interval( 54 )
        ALLOCATE (ALJNIM1(LA), A0IMAG1(LA), ALJNRE1(LA), A0REAL1(LA))
D        call trace_enter (2079) 
        DO 11 K=LA,MM,LA
          KK=K+K
          JN=IJ-KK*ISKIP
          KK=KK+1
          TREAL=TRIGS(KK)
          TIMAG=TRIGSI(KK)
C gjx
          A0REAL1(1:$LA) = A(I   :$LA:ISKIP)
          ALJNRE1(1:$LA) = A(JN+1:$LA:ISKIP)
          A0IMAG1(1:$LA) = B(I   :$LA:ISKIP)
          ALJNIM1(1:$LA) = B(JN+1:$LA:ISKIP)
          C(J:$LA:ISKIP1) = A0REAL1(1:$LA) + ALJNRE1(1:$LA)
          A0REAL1(1:$LA)  = A0REAL1(1:$LA) - ALJNRE1(1:$LA)
          D(J:$LA:ISKIP1) = A0IMAG1(1:$LA) - ALJNIM1(1:$LA)
          A0IMAG1(1:$LA)  = A0IMAG1(1:$LA) + ALJNIM1(1:$LA)
          J = J + LASKP1
          C(J:$LA:ISKIP1) = TREAL * A0REAL1(1:$LA) - TIMAG * A0IMAG1(1:$LA)
          D(J:$LA:ISKIP1) = TIMAG * A0REAL1(1:$LA) + TREAL * A0IMAG1(1:$LA)
          I = I + 2 * LASKIP
          J = J + JUMP3
 11     CONTINUE
D        call trace_exit (2080) 
        DEALLOCATE (A0REAL1, ALJNRE1, A0IMAG1, ALJNIM1)
cD       call end_interval( 54 )

cD       call start_interval( 55 )
          C(J:$LA:ISKIP1) = A(I:$LA:ISKIP)
          C(J+LASKP1:$LA:ISKIP1) = -B(I:$LA:ISKIP)
cD       call end_interval( 55 )
        RETURN
 
C        --------- FACTOR THREE ------------
 300    CONTINUE
        LA3SKP=LASKP1*3
        KEND=(N-LA)/2+LA
        IF(MOD(MA,2).EQ.0) KEND=(N-2*LA)/2+LA+LA
        KDIF=KEND+KEND-M2-LA
        IF(MOD(MA,2).EQ.0) KDIF=KDIF-LA
        JMPLA3=JUMP+LA3SKP
        IJ2=M2SKIP
        IJ1=IJ2-LASKIP
        IC=IB+LASKP1
C         CALCULATE DC
        L1=1
CDIR$ IVDEP
cD       call start_interval( 56 )
        ALLOCATE (T31(LA), T21(LA), B11(LA), A11(LA), A01(LA))
         A01(1:$LA) = A(1:$LA:ISKIP)
         A11(1:$LA) = A(IJ1+1:$LA:ISKIP)
         B11(1:$LA) = A(IJ2+1:$LA:ISKIP)
         T21(1:$LA) = A01(1:$LA) - 0.5 * A11(1:$LA)
         T31(1:$LA) = SIN60 * B11(1:$LA)
         C(1:$LA:ISKIP1) = A01(1:$LA) + A11(1:$LA)
         C(IB+1:$LA:ISKIP1) = T21(1:$LA) - T31(1:$LA)
         C(IC+1:$LA:ISKIP1) = T21(1:$LA) + T31(1:$LA)
         DEALLOCATE (A01, A11, B11, T21, T31)
cD       call end_interval( 56 )
        IF(LA.EQ.M) RETURN
        I=LASKIP+1
        J=LASKP1+1+JUMP
        MM=MHLF
        IF(MOD(MA,2).EQ.0) MM=MM-LA
cD       call start_interval( 57 )
        ALLOCATE (
     X    T3IMAG1(LA), T3REAL1(LA), T2IMAG1(LA), T2REAL1(LA), T1IMAG1(LA
     X    ), T1REAL1(LA), A2IMAG1(LA), A2REAL1(LA), A1IMAG1(LA
     X    ), A1REAL1(LA), A0IMAG2(LA), A0REAL2(LA))
D        call trace_enter (2081) 
        DO 15 K=LA,MM,LA
          K2=K+K
          KJ=KDIF-K2
          KJ=(KJ+KJ)*ISKIP
CDIR$ IVDEP
C gjx Stmt reordering  & Temp renaming (for register minimization)
          A1REAL1(1:$LA) = A(I+M2SKIP:$LA:ISKIP)
          A1IMAG1(1:$LA) = B(I+M2SKIP:$LA:ISKIP)
          A2REAL1(1:$LA) = A(I+KJ:$LA:ISKIP)
          A2IMAG1(1:$LA) = -B(I+KJ:$LA:ISKIP)
          T1REAL1(1:$LA) =          A1REAL1(1:$LA) + A2REAL1(1:$LA)
          T3REAL1(1:$LA) = SIN60 * (A1REAL1(1:$LA) - A2REAL1(1:$LA))
          T1IMAG1(1:$LA) =          A1IMAG1(1:$LA) + A2IMAG1(1:$LA)
          T3IMAG1(1:$LA) = SIN60 * (A1IMAG1(1:$LA) - A2IMAG1(1:$LA))

          A0REAL2(1:$LA) = A(I:$LA:ISKIP)
          A0IMAG2(1:$LA) = B(I:$LA:ISKIP)
          C(J:$LA:ISKIP1) = A0REAL2(1:$LA) + T1REAL1(1:$LA)
          D(J:$LA:ISKIP1) = A0IMAG2(1:$LA) + T1IMAG1(1:$LA)

          T2REAL1(1:$LA) = A0REAL2(1:$LA) - 0.5 * T1REAL1(1:$LA)
          T2IMAG1(1:$LA) = A0IMAG2(1:$LA) - 0.5 * T1IMAG1(1:$LA)
          
          T1REAL1(1:$LA) = T2REAL1(1:$LA) - T3IMAG1(1:$LA)
          T1IMAG1(1:$LA) = T2IMAG1(1:$LA) + T3REAL1(1:$LA)
          KK=K2+1
          TR1REA = TRIGS(KK)
          TR1IMA = TRIGSI(KK)
          J = J + LASKP1
          C(J:$LA:ISKIP1) = TR1REA * T1REAL1(1:$LA) - TR1IMA * T1IMAG1(1:$LA)
          D(J:$LA:ISKIP1) = TR1IMA * T1REAL1(1:$LA) + TR1REA * T1IMAG1(1:$LA)
          
          T1REAL1(1:$LA) = T2REAL1(1:$LA) + T3IMAG1(1:$LA)
          T1IMAG1(1:$LA) = T2IMAG1(1:$LA) - T3REAL1(1:$LA)
          KK=KK+K2
          TR2REA=TRIGS(KK)
          TR2IMA=TRIGSI(KK)
          J = J + LASKP1
          C(J:$LA:ISKIP1) = TR2REA * T1REAL1(1:$LA) - TR2IMA * T1IMAG1(1:$LA)
          D(J:$LA:ISKIP1) = TR2IMA * T1REAL1(1:$LA) + TR2REA * T1IMAG1(1:$LA)
          I = I + LASKIP + LASKIP
          J = J + LASKP1 + LASKP1 + JUMP
 15     CONTINUE
D        call trace_exit (2082) 
        DEALLOCATE (A0REAL2, A0IMAG2, A1REAL1, A1IMAG1
     X       , A2REAL1, A2IMAG1, T1REAL1, T1IMAG1, T2REAL1, T2IMAG1,
     X       T3REAL1, T3IMAG1)
cD       call end_interval( 57 )

         IF(MOD(MA,2).NE.0)RETURN
CDIR$ IVDEP
cD       call start_interval( 58 )
        II8 = J
        II7 = I
        ALLOCATE (T12(LA), A12(LA), IM2SKP2(LA), B01(LA), A02(LA))
          A02(1:$LA) = A(II7:$LA:ISKIP)
          B01(1:$LA) = A(II7+LASKIP:$LA:ISKIP)
          IM2SKP2(1:$LA) = [II7 + M2SKIP :$ LA : ISKIP]
          A12(1:$LA) = A(IM2SKP2(1:$LA))
          T12(1:$LA) = 0.5 * A02(1:$LA) - A12(1:$LA)
          C(II8:$LA:ISKIP1) = A02(1:$LA) + A12(1:$LA)
          C(II8+IB:$LA:ISKIP1) = T12(1:$LA) - SIN60 * B01(1:$LA)
          C(II8+IC:$LA:ISKIP1) = -T12(1:$LA) - SIN60 * B01(1:$LA)
          DEALLOCATE (A02, B01, IM2SKP2, A12, T12)
cD       call end_interval( 58 )
        RETURN
C       ------ FACTOR 4 -----------
400        CONTINUE
        LA4SKP=LASKP1*4
        JMPLA4=JUMP+LA4SKP
        IJ2=M2SKIP
        IJ1=IJ2-LASKIP
        IC=IB+LASKP1
        ID=IC+LASKP1
        L1=1
CDIR$ IVDEP
cD       call start_interval( 59 )
        ALLOCATE (T32(LA), T13(LA), Y21(LA), Y31(LA), Y12(LA), Y02(LA))
         Y02(1:$LA) = A(1:$LA:ISKIP)
         Y12(1:$LA) = A(IJ1+1:$LA:ISKIP)
         Y31(1:$LA) = A(IJ2+1:$LA:ISKIP)
         Y21(1:$LA) = A(IJ+1:$LA:ISKIP)
         T13(1:$LA) = Y02(1:$LA) + Y21(1:$LA)
         T32(1:$LA) = Y02(1:$LA) - Y21(1:$LA)
         C(1:$LA:ISKIP1) = T13(1:$LA) + Y12(1:$LA)
         C(IB+1:$LA:ISKIP1) = T32(1:$LA) - Y31(1:$LA)
         C(IC+1:$LA:ISKIP1) = T13(1:$LA) - Y12(1:$LA)
         C(ID+1:$LA:ISKIP1) = T32(1:$LA) + Y31(1:$LA)
         DEALLOCATE (Y02, Y12, Y31, Y21, T13, T32)
cD       call end_interval( 59 )
        IF(LA.EQ.M) RETURN
        I=LASKIP+1
        J=LASKP1+1+JUMP
        MM=MHLF
        IF(MOD(MA,2).EQ.0) MM=MM-LA
cD       call start_interval( 60 )
D        call trace_enter (2083) 
        DO 21 K=LA,MM,LA
          K2=K+K
          JN=IJ-K2*ISKIP
          JM1=JN-M2SKIP
          KK=K2+1
          TR1REA=TRIGS(KK)
          TR1IMA=TRIGSI(KK)
          KK=KK+K2
          TR2REA=TRIGS(KK)
          TR2IMA=TRIGSI(KK)
          KK=KK+K2
          TR3REA=TRIGS(KK)
          TR3IMA=TRIGSI(KK)
CDIR$ IVDEP
          DO 22 L=1,LASKIP,ISKIP
           A0REAL=A(I)
           A0IMAG=B(I)
           IM2SKP=I+M2SKIP
           A1REAL=A(IM2SKP)
           A1IMAG=B(IM2SKP)
           JNL=JN+L
           A2REAL=A(JNL)
           A2IMAG=-B(JNL)
           JM1L=JM1+L
           A3REAL=A(JM1L)
           A3IMAG=-B(JM1L)
           T1REAL=A0REAL+A2REAL
           T1IMAG=A0IMAG+A2IMAG
           T2REAL=A1REAL+A3REAL
           T2IMAG=A1IMAG+A3IMAG
           T3REAL=A0REAL-A2REAL
           T3IMAG=A0IMAG-A2IMAG
           T4REAL=A1REAL-A3REAL
           T4IMAG=A1IMAG-A3IMAG
           C(J)=T1REAL+T2REAL
           D(J  )=T1IMAG+T2IMAG
           X1REAL=T3REAL-T4IMAG
           X1IMAG=T3IMAG+T4REAL
           X2REAL=T1REAL-T2REAL
           X2IMAG=T1IMAG-T2IMAG
           X3REAL=T3REAL+T4IMAG
           X3IMAG=T3IMAG-T4REAL
           JIB=J+IB
           C(JIB)=TR1REA*X1REAL-TR1IMA*X1IMAG
           D(JIB)=TR1IMA*X1REAL+TR1REA*X1IMAG
           JIC=J+IC
           C(JIC)=TR2REA*X2REAL-TR2IMA*X2IMAG
           D(JIC)=TR2IMA*X2REAL+TR2REA*X2IMAG
           JID=J+ID
           C(JID)=TR3REA*X3REAL-TR3IMA*X3IMAG
           D(JID)=TR3IMA*X3REAL+TR3REA*X3IMAG
           I=I+ISKIP
           J=J+ISKIP1
22        CONTINUE
          J=J+JMPLA4
          I=I+LASKIP
21       CONTINUE
CDIR$ IVDEP
cD       call end_interval( 60 )
cD       call start_interval( 61 )
D        call trace_exit (2084) 
        II12 = J
        II11 = I
        ALLOCATE (T22(LA), T14(LA), B12(LA), A13(LA), IM2SKP4(LA), B02(
     X    LA), A03(LA))
          A03(1:$LA) = A(II11:$LA:ISKIP)
          B02(1:$LA) = B(II11:$LA:ISKIP)
          IM2SKP4(1:$LA) = [II11 + M2SKIP :$ LA : ISKIP]
          A13(1:$LA) = A(IM2SKP4(1:$LA))
          B12(1:$LA) = B(IM2SKP4(1:$LA))
          T14(1:$LA) = SIN45 * (B02(1:$LA) + B12(1:$LA))
          T22(1:$LA) = SIN45 * (A03(1:$LA) - A13(1:$LA))
          C(II12:$LA:ISKIP1) = A03(1:$LA) + A13(1:$LA)
          C(II12+IB:$LA:ISKIP1) = T22(1:$LA) - T14(1:$LA)
          C(II12+IC:$LA:ISKIP1) = B12(1:$LA) - B02(1:$LA)
          C(II12+ID:$LA:ISKIP1) = -(T22(1:$LA) + T14(1:$LA))
          DEALLOCATE (A03, B02, IM2SKP4, A13, B12, T14, T22)
cD       call end_interval( 61 )
        RETURN
C        ------- FACTOR 5 ---------
500        CONTINUE
        LA5SKP=LASKP1*5
        KEND=(N-LA)/2+LA
        IF(MOD(MA,2).EQ.0) KEND=(N-2*LA)/2+LA+LA
        KDIF=KEND+KEND-M2-LA-M
        IF(MOD(MA,2).EQ.0) KDIF=KDIF-LA
        JMPLA5=JUMP+LA5SKP
        IJ2=M2SKIP
        IJ1=IJ2-LASKIP
        IJ4=M2SKIP+M2SKIP
        IJ3=IJ4-LASKIP
        IC=IB+LASKP1
        ID=IC+LASKP1
        IE=ID+LASKP1
C         CALCULATE DC
        L1=1
cD       call start_interval( 62 )
D        call trace_enter (2085) 
        DO 30 L=1,LASKIP,ISKIP
         A0=A(L)
         A1=A(L+IJ1)
         B1=A(L+IJ2)
         A2=A(L+IJ3)
         B2=A(L+IJ4)
         T3=SIN72*B1
         T4=SIN72*B2
         T5=A1+A2
         T6=SQ54*(A1-A2)
         T7=A0-0.25*T5
         T8=T7+T6
         T9=T7-T6
         T10=T3+SN3672*T4
         T11=SN3672*T3-T4
         C(L1)=A0+T5
         C(L1+IB)=T8-T10
         C(L1+IC)=T9-T11
         C(L1+ID)=T9+T11
         C(L1+IE)=T8+T10
         L1=L1+ISKIP1
30      CONTINUE
cD       call end_interval( 62 )
D        call trace_exit (2086) 
        IF(LA.EQ.M) RETURN
        I=LASKIP+1
        J=LASKP1+1+JUMP
        MM=MHLF
        IF(MOD(MA,2).EQ.0) MM=MM-LA
cD       call start_interval( 63 )
        II14 = J
        II13 = I
        K1 = (MM - LA + LA) / LA
        ALLOCATE (X4IMAG1(LA), X4REAL1(LA), X3IMAG2(LA), X3REAL2(LA),
     X    X2IMAG3(LA), X2REAL3(LA), X1IMAG3(LA), X1REAL3(LA), T11IMA1(LA
     X    ), T11REA1(LA), T10IMA1(LA), T10REA1(LA), T9IMAG1(LA), T9REAL1
     X    (LA), T8IMAG1(LA), T8REAL1(LA), T7IMAG1(LA), T7REAL1(LA),
     X    T6IMAG1(LA), T6REAL1(LA), T5IMAG1(LA), T5REAL1(LA), T4IMAG2(LA
     X    ), T4REAL2(LA), T3IMAG3(LA), T3REAL3(LA), T2IMAG3(LA), T2REAL3
     X    (LA), T1IMAG3(LA), T1REAL3(LA), A4IMAG1(LA), A4REAL1(LA),
     X    JNLM2S1(LA), A3IMAG2(LA), A3REAL2(LA), JNL3(LA), A2IMAG3(LA),
     X    A2REAL3(LA), IM41(LA), A1IMAG3(LA), A1REAL3(LA), IM2SKP5(LA),
     X    A0IMAG4(LA), A0REAL4(LA))
        II23 = (-1)
D        call trace_enter (2087) 
        DO 31 K=LA,LA+((-1)+K1)*LA,LA
        II23 = II23 + 1
          K2=K+K
          KJ=KDIF-K2
          KJ=(KJ+KJ)*ISKIP
          KK=K2+1
          TR1REA = TRIGS(K+K+1)
          TR1IMA = TRIGSI(K+K+1)
          KK=KK+K2
          TR2REA=TRIGS(KK)
          TR2IMA=TRIGSI(KK)
          KK=KK+K2
          TR3REA=TRIGS(KK)
          TR3IMA=TRIGSI(KK)
          KK=KK+K2
          TR4REA=TRIGS(KK)
          TR4IMA=TRIGSI(KK)
CDIR$ IVDEP
           A0REAL4(1:$LA) = A(II13+LA*II23*ISKIP+II23*LASKIP:$LA:ISKIP)
           A0IMAG4(1:$LA) = B(II13+LA*II23*ISKIP+II23*LASKIP:$LA:ISKIP)
           IM2SKP5(1:$LA) = [II13 + LA * II23 * ISKIP + II23 * LASKIP +
     X       M2SKIP :$ LA : ISKIP]
           A1REAL3(1:$LA) = A(IM2SKP5(1:$LA))
           A1IMAG3(1:$LA) = B(IM2SKP5(1:$LA))
           IM41(1:$LA) = [II13 + LA * II23 * ISKIP + II23 * (LA * ISKIP)
     X        :$ LA : ISKIP] + (N / IFAC * ISKIP + N / IFAC * ISKIP) +
     X       M2SKIP
           A2REAL3(1:$LA) = A(IM41(1:$LA))
           A2IMAG3(1:$LA) = B(IM41(1:$LA))
           JNL3(1:$LA) = [KJ + (II13 + LA * II23 * ISKIP + II23 * LASKIP
     X       ) :$ LA : ISKIP]
           A3REAL2(1:$LA) = A(JNL3(1:$LA))
           A3IMAG2(1:$LA) = -B(JNL3(1:$LA))
           JNLM2S1(1:$LA) = [KJ + (II13 + LA * II23 * ISKIP + II23 * (LA
     X        * ISKIP)) - M2SKIP :$ LA : ISKIP]
           A4REAL1(1:$LA) = A(JNLM2S1(1:$LA))
           A4IMAG1(1:$LA) = -B(JNLM2S1(1:$LA))
           T1REAL3(1:$LA) = A1REAL3(1:$LA) + A4REAL1(1:$LA)
           T1IMAG3(1:$LA) = A1IMAG3(1:$LA) + A4IMAG1(1:$LA)
           T2REAL3(1:$LA) = A2REAL3(1:$LA) + A3REAL2(1:$LA)
           T2IMAG3(1:$LA) = A2IMAG3(1:$LA) + A3IMAG2(1:$LA)
           T3REAL3(1:$LA) = SIN72 * (A1REAL3(1:$LA) - A4REAL1(1:$LA))
           T3IMAG3(1:$LA) = SIN72 * (A1IMAG3(1:$LA) - A4IMAG1(1:$LA))
           T4REAL2(1:$LA) = SIN72 * (A2REAL3(1:$LA) - A3REAL2(1:$LA))
           T4IMAG2(1:$LA) = SIN72 * (A2IMAG3(1:$LA) - A3IMAG2(1:$LA))
           T5REAL1(1:$LA) = T1REAL3(1:$LA) + T2REAL3(1:$LA)
           T5IMAG1(1:$LA) = T1IMAG3(1:$LA) + T2IMAG3(1:$LA)
           T6REAL1(1:$LA) = SQ54 * (T1REAL3(1:$LA) - T2REAL3(1:$LA))
           T6IMAG1(1:$LA) = SQ54 * (T1IMAG3(1:$LA) - T2IMAG3(1:$LA))
           T7REAL1(1:$LA) = A0REAL4(1:$LA) - T5REAL1(1:$LA) * 0.25
           T7IMAG1(1:$LA) = A0IMAG4(1:$LA) - T5IMAG1(1:$LA) * 0.25
           T8REAL1(1:$LA) = T7REAL1(1:$LA) + T6REAL1(1:$LA)
           T8IMAG1(1:$LA) = T7IMAG1(1:$LA) + T6IMAG1(1:$LA)
           T9REAL1(1:$LA) = T7REAL1(1:$LA) - T6REAL1(1:$LA)
           T9IMAG1(1:$LA) = T7IMAG1(1:$LA) - T6IMAG1(1:$LA)
           T10REA1(1:$LA) = T3REAL3(1:$LA) + SN3672 * T4REAL2(1:$LA)
           T10IMA1(1:$LA) = T3IMAG3(1:$LA) + SN3672 * T4IMAG2(1:$LA)
           T11REA1(1:$LA) = SN3672 * T3REAL3(1:$LA) - T4REAL2(1:$LA)
           T11IMA1(1:$LA) = SN3672 * T3IMAG3(1:$LA) - T4IMAG2(1:$LA)
           C(II14+LA*II23*ISKIP1+II23*JMPLA5:$LA:ISKIP1) = A0REAL4(1:$LA
     X       ) + T5REAL1(1:$LA)
           D(II14+LA*II23*ISKIP1+II23*JMPLA5:$LA:ISKIP1) = A0IMAG4(1:$LA
     X       ) + T5IMAG1(1:$LA)
           X1REAL3(1:$LA) = T8REAL1(1:$LA) - T10IMA1(1:$LA)
           X1IMAG3(1:$LA) = T8IMAG1(1:$LA) + T10REA1(1:$LA)
           X2REAL3(1:$LA) = T9REAL1(1:$LA) - T11IMA1(1:$LA)
           X2IMAG3(1:$LA) = T9IMAG1(1:$LA) + T11REA1(1:$LA)
           X3REAL2(1:$LA) = T9REAL1(1:$LA) + T11IMA1(1:$LA)
           X3IMAG2(1:$LA) = T9IMAG1(1:$LA) - T11REA1(1:$LA)
           X4REAL1(1:$LA) = T8REAL1(1:$LA) + T10IMA1(1:$LA)
           X4IMAG1(1:$LA) = T8IMAG1(1:$LA) - T10REA1(1:$LA)
           C(II14+LA*II23*ISKIP1+II23*(JUMP+5*LASKP1)+LA*ISKIP1:$LA:
     X       ISKIP1) = TR1REA * X1REAL3(1:$LA) - TR1IMA * X1IMAG3(1:$LA)
           D(II14+LA*II23*ISKIP1+II23*(JUMP+5*LASKP1)+LA*ISKIP1:$LA:
     X       ISKIP1) = TR1IMA * X1REAL3(1:$LA) + TR1REA * X1IMAG3(1:$LA)
           C(II14+LA*II23*ISKIP1+II23*(JUMP+5*LASKP1)+(IB+LASKP1):$LA:
     X       ISKIP1) = TR2REA * X2REAL3(1:$LA) - TR2IMA * X2IMAG3(1:$LA)
           D(II14+LA*II23*ISKIP1+II23*(JUMP+5*LASKP1)+(IB+LASKP1):$LA:
     X       ISKIP1) = TR2IMA * X2REAL3(1:$LA) + TR2REA * X2IMAG3(1:$LA)
           C(II14+LA*II23*ISKIP1+II23*(JUMP+5*LASKP1)+(IB+LASKP1+LASKP1)
     X       :$LA:ISKIP1) = TR3REA * X3REAL2(1:$LA) - TR3IMA * X3IMAG2(1
     X       :$LA)
           D(II14+LA*II23*ISKIP1+II23*(JUMP+5*LASKP1)+(IB+LASKP1+LASKP1)
     X       :$LA:ISKIP1) = TR3IMA * X3REAL2(1:$LA) + TR3REA * X3IMAG2(1
     X       :$LA)
           C(II14+LA*II23*ISKIP1+II23*(JUMP+5*LASKP1)+(IB+LASKP1+LASKP1+
     X       LASKP1):$LA:ISKIP1) = TR4REA * X4REAL1(1:$LA) - TR4IMA *
     X       X4IMAG1(1:$LA)
           D(II14+LA*II23*ISKIP1+II23*(JUMP+5*LASKP1)+(IB+LASKP1+LASKP1+
     X       LASKP1):$LA:ISKIP1) = TR4IMA * X4REAL1(1:$LA) + TR4REA *
     X       X4IMAG1(1:$LA)
           I = II13 + ((-1) + (LA + LA * II23)) * ISKIP + II23 * LASKIP
     X       + ISKIP
           J = II14 + ((-1) + (LA + LA * II23)) * ISKIP1 + II23 * JMPLA5
     X        + ISKIP1
31       CONTINUE
D        call trace_exit (2088) 
          J = II14 + LA * K1 * ISKIP1 + ((-1) + K1) * JMPLA5 + JMPLA5
          I = II13 + LA * K1 * ISKIP + ((-1) + K1) * LASKIP + LASKIP
          DEALLOCATE (A0REAL4, A0IMAG4, IM2SKP5, A1REAL3, A1IMAG3, IM41
     X      , A2REAL3, A2IMAG3, JNL3, A3REAL2, A3IMAG2, JNLM2S1, A4REAL1
     X      , A4IMAG1, T1REAL3, T1IMAG3, T2REAL3, T2IMAG3, T3REAL3,
     X      T3IMAG3, T4REAL2, T4IMAG2, T5REAL1, T5IMAG1, T6REAL1,
     X      T6IMAG1, T7REAL1, T7IMAG1, T8REAL1, T8IMAG1, T9REAL1,
     X      T9IMAG1, T10REA1, T10IMA1, T11REA1, T11IMA1, X1REAL3,
     X      X1IMAG3, X2REAL3, X2IMAG3, X3REAL2, X3IMAG2, X4REAL1,
     X      X4IMAG1)
cD       call end_interval( 63 )
         IF(MOD(MA,2).NE.0)RETURN
CDIR$ IVDEP
cD       call start_interval( 64 )
        II16 = J
        II15 = I
        ALLOCATE (T72(LA), T62(LA), T52(LA), T42(LA), T34(LA), T23(LA),
     X    T15(LA), A22(LA), B14(LA), A15(LA), IM2SKP6(LA), B03(LA), A05(
     X    LA))
          A05(1:$LA) = A(II15:$LA:ISKIP)
          B03(1:$LA) = B(II15:$LA:ISKIP)
          IM2SKP6(1:$LA) = [II15 + M2SKIP :$ LA : ISKIP]
          A15(1:$LA) = A(IM2SKP6(1:$LA))
          B14(1:$LA) = B(IM2SKP6(1:$LA))
          A22(1:$LA) = A(IM2SKP6(1:$LA)+(N/IFAC*ISKIP+N/IFAC*ISKIP))
          T15(1:$LA) = A05(1:$LA) + A15(1:$LA)
          T23(1:$LA) = 0.25 * T15(1:$LA) - A22(1:$LA)
          T34(1:$LA) = SQ54 * (A05(1:$LA) - A15(1:$LA))
          T42(1:$LA) = SIN36 * B03(1:$LA) + SIN72 * B14(1:$LA)
          T52(1:$LA) = SIN72 * B03(1:$LA) - SIN36 * B14(1:$LA)
          T62(1:$LA) = T34(1:$LA) + T23(1:$LA)
          T72(1:$LA) = T34(1:$LA) - T23(1:$LA)
          C(II16:$LA:ISKIP1) = T15(1:$LA) + A22(1:$LA)
          C(II16+IB:$LA:ISKIP1) = T62(1:$LA) - T42(1:$LA)
          C(II16+IC:$LA:ISKIP1) = T72(1:$LA) - T52(1:$LA)
          C(II16+ID:$LA:ISKIP1) = -T72(1:$LA) - T52(1:$LA)
          C(II16+IE:$LA:ISKIP1) = -T62(1:$LA) - T42(1:$LA)
          DEALLOCATE (A05, B03, IM2SKP6, A15, B14, A22, T15, T23, T34,
     X      T42, T52, T62, T72)
cD       call end_interval( 64 )
        RETURN
C        ----- FACTOR 6 -----------------
600        CONTINUE
        LA6SKP=LASKP1*6
        JMPLA6=JUMP+LA6SKP
        IJ2=M2SKIP
        IJ1=IJ2-LASKIP
        IC=IB+LASKP1
        ID=IC+LASKP1
        IE=ID+LASKP1
        IG=IE+LASKP1
        L1=1
CDIR$ IVDEP
cD       call start_interval( 65 )
        ALLOCATE (X5REAL1(LA), X4REAL2(LA), X3REAL3(LA), X2REAL4(LA),
     X    X1REAL4(LA), X0REAL1(LA), Y5REAL1(LA), Y1REAL1(LA), Y3REAL1(LA
     X    ), Y2REAL1(LA), Y4REAL1(LA), Y0REAL1(LA), T3IMAG4(LA), T2REAL4
     X    (LA), A31(LA), B22(LA), A23(LA), B15(LA), A16(LA), A06(LA))
          A06(1:$LA) = A(1:$LA:ISKIP)
          A16(1:$LA) = A(M2SKIP-LASKIP+1:$LA:ISKIP)
          B15(1:$LA) = B(M2SKIP-LASKIP+1:$LA:ISKIP)
          A23(1:$LA) = A(M2SKIP-LASKIP+(N/IFAC*ISKIP+N/IFAC*ISKIP)+1:$LA
     X      :ISKIP)
          B22(1:$LA) = B(M2SKIP-LASKIP+(N/IFAC*ISKIP+N/IFAC*ISKIP)+1:$LA
     X      :ISKIP)
          A31(1:$LA) = A(IJ+1:$LA:ISKIP)
          T2REAL4(1:$LA) = A06(1:$LA) - A23(1:$LA) * 0.5
          T3IMAG4(1:$LA) = SIN60 * B22(1:$LA)
          Y0REAL1(1:$LA) = A06(1:$LA) + A23(1:$LA)
          Y4REAL1(1:$LA) = T2REAL4(1:$LA) - T3IMAG4(1:$LA)
          Y2REAL1(1:$LA) = T2REAL4(1:$LA) + T3IMAG4(1:$LA)
          T2REAL4(1:$LA) = A31(1:$LA) - A16(1:$LA) * 0.5
          T3IMAG4(1:$LA) = -SIN60 * B15(1:$LA)
          Y3REAL1(1:$LA) = A31(1:$LA) + A16(1:$LA)
          Y1REAL1(1:$LA) = T2REAL4(1:$LA) - T3IMAG4(1:$LA)
          Y5REAL1(1:$LA) = T2REAL4(1:$LA) + T3IMAG4(1:$LA)
          X0REAL1(1:$LA) = Y0REAL1(1:$LA) + Y3REAL1(1:$LA)
          X1REAL4(1:$LA) = Y4REAL1(1:$LA) - Y1REAL1(1:$LA)
          X2REAL4(1:$LA) = Y2REAL1(1:$LA) + Y5REAL1(1:$LA)
          X3REAL3(1:$LA) = Y0REAL1(1:$LA) - Y3REAL1(1:$LA)
          X4REAL2(1:$LA) = Y4REAL1(1:$LA) + Y1REAL1(1:$LA)
          X5REAL1(1:$LA) = Y2REAL1(1:$LA) - Y5REAL1(1:$LA)
          C(1:$LA:ISKIP1) = X0REAL1(1:$LA)
          C(IB+1:$LA:ISKIP1) = X1REAL4(1:$LA)
          C(IC+1:$LA:ISKIP1) = X2REAL4(1:$LA)
          C(ID+1:$LA:ISKIP1) = X3REAL3(1:$LA)
          C(IE+1:$LA:ISKIP1) = X4REAL2(1:$LA)
          C(IG+1:$LA:ISKIP1) = X5REAL1(1:$LA)
          DEALLOCATE (A06, A16, B15, A23, B22, A31, T2REAL4, T3IMAG4,
     X      Y0REAL1, Y4REAL1, Y2REAL1, Y3REAL1, Y1REAL1, Y5REAL1,
     X      X0REAL1, X1REAL4, X2REAL4, X3REAL3, X4REAL2, X5REAL1)
cD       call end_interval( 65 )
        IF(LA.EQ.M) RETURN
        I=LASKIP+1
        J=LASKP1+1+JUMP
        MM=MHLF
        IF(MOD(MA,2).EQ.0) MM=MM-LA
cD       call start_interval( 66 )
D        call trace_enter (2089) 
        DO 42 K=LA,MM,LA
          K2=K+K
          JN=IJ-K2*ISKIP
          JM1=JN-M2SKIP
          KK=K2+1
          TR1REA=TRIGS(KK)
          TR1IMA=TRIGSI(KK)
          KK=KK+K2
          TR2REA=TRIGS(KK)
          TR2IMA=TRIGSI(KK)
          KK=KK+K2
          TR3REA=TRIGS(KK)
          TR3IMA=TRIGSI(KK)
          KK=KK+K2
          TR4REA=TRIGS(KK)
          TR4IMA=TRIGSI(KK)
          KK=KK+K2
          TR5REA=TRIGS(KK)
          TR5IMA=TRIGSI(KK)
CDIR$ IVDEP
          DO 43 L=1,LASKIP,ISKIP
           A0REAL=A(I)
           A0IMAG=B(I)
           IM2SKP=I+M2SKIP
           A1REAL=A(IM2SKP)
           A1IMAG=B(IM2SKP)
           IM4=IM2SKP+M2SKIP
           A2REAL=A(IM4)
           A2IMAG=B(IM4)
           JNL=JN+L
           A3REAL=A(JNL)
           A3IMAG=-B(JNL)
           JNLM2S=JNL-M2SKIP
           A4REAL=A(JNLM2S)
           A4IMAG=-B(JNLM2S)
           JNLM4=JNLM2S-M2SKIP
           A5REAL=A(JNLM4)
           A5IMAG=-B(JNLM4)
           T1REAL=A2REAL+A4REAL
           T1IMAG=A2IMAG+A4IMAG
           T2REAL=A0REAL-0.5*T1REAL
           T2IMAG=A0IMAG-0.5*T1IMAG
           T3REAL=SIN60*(A2REAL-A4REAL)
           T3IMAG=SIN60*(A2IMAG-A4IMAG)
           Y0REAL=A0REAL+T1REAL
           Y0IMAG=A0IMAG+T1IMAG
           Y4REAL=T2REAL-T3IMAG
           Y4IMAG=T2IMAG+T3REAL
           Y2REAL=T2REAL+T3IMAG
           Y2IMAG=T2IMAG-T3REAL
           T1REAL=A5REAL+A1REAL
           T1IMAG=A5IMAG+A1IMAG
           T2REAL=A3REAL-0.5*T1REAL
           T2IMAG=A3IMAG-0.5*T1IMAG
           T3REAL=SIN60*(A5REAL-A1REAL)
           T3IMAG=SIN60*(A5IMAG-A1IMAG)
           Y3REAL=A3REAL+T1REAL
           Y3IMAG=A3IMAG+T1IMAG
           Y1REAL=T2REAL-T3IMAG
           Y1IMAG=T2IMAG+T3REAL
           Y5REAL=T2REAL+T3IMAG
           Y5IMAG=T2IMAG-T3REAL
           X0REAL=Y0REAL+Y3REAL
           X0IMAG=Y0IMAG+Y3IMAG
           X4REAL=Y4REAL+Y1REAL
           X4IMAG=Y4IMAG+Y1IMAG
           X2REAL=Y2REAL+Y5REAL
           X2IMAG=Y2IMAG+Y5IMAG
           X3REAL=Y0REAL-Y3REAL
           X3IMAG=Y0IMAG-Y3IMAG
           X1REAL=Y4REAL-Y1REAL
           X1IMAG=Y4IMAG-Y1IMAG
           X5REAL=Y2REAL-Y5REAL
           X5IMAG=Y2IMAG-Y5IMAG
           C(J    )=X0REAL
           D(J      )=X0IMAG
           JIB=J+IB
           C(JIB)=TR1REA*X1REAL-TR1IMA*X1IMAG
           D(JIB)=TR1IMA*X1REAL+TR1REA*X1IMAG
           JIC=J+IC
           C(JIC)=TR2REA*X2REAL-TR2IMA*X2IMAG
           D(JIC)=TR2IMA*X2REAL+TR2REA*X2IMAG
           JID=J+ID
           C(JID)=TR3REA*X3REAL-TR3IMA*X3IMAG
           D(JID)=TR3IMA*X3REAL+TR3REA*X3IMAG
           JIE=J+IE
           C(JIE)=TR4REA*X4REAL-TR4IMA*X4IMAG
           D(JIE)=TR4IMA*X4REAL+TR4REA*X4IMAG
           JIG=J+IG
           C(JIG)=TR5REA*X5REAL-TR5IMA*X5IMAG
           D(JIG)=TR5IMA*X5REAL+TR5REA*X5IMAG
           I=I+ISKIP
           J=J+ISKIP1
43        CONTINUE
          J=J+JMPLA6
          I=I+LASKIP
42       CONTINUE
cD       call end_interval( 66 )
D        call trace_exit (2090) 
         IF(MOD(MA,2).NE.0) RETURN
CDIR$ IVDEP
cD       call start_interval( 67 )
D        call trace_enter (2091) 
         DO 44 L=1,LASKIP,ISKIP
          A0=A(I)
          B0=B(I)
          IM2SKP=I+M2SKIP
          A1=A(IM2SKP)
          B1=B(IM2SKP)
          IM4=IM2SKP+M2SKIP
          A2=A(IM4)
          B2=B(IM4)
          T1=A0+A2
          T2=B0+B2
          T3=SIN60*(A0-A2)
          T4=SIN60*(B0-B2)
          T5=0.5*T1-A1
          T6=0.5*T2+B1
          C(J)=A1+T1
          C(J+IB)=T3-T6
          C(J+IC)=T5-T4
          C(J+ID)=B1-T2
          C(J+IE)=-(T4+T5)
          C(J+IG)=-(T3+T6)
          I=I+ISKIP
          J=J+ISKIP1
44       CONTINUE
cD       call end_interval( 67 )
D        call trace_exit (2092) 
         RETURN
        END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3 21 Nov 1991 17:21:52
 
C      SUBROUTINE FFTTRG(N,TR)
C      COMPLEX TR(1),CC
C      DN = 2.*3.14159265/N
C      DO 1 I=1,N
C         CC = (I-1)*DN
C    1    TR(I) = EXP((0.,1.)*CC)
C      RETURN
C      END
 
      SUBROUTINE VERIFY(IDISK2,NX,DSECT)
      DIMENSION DSECT(NX,1)
C
      WRITE(10,1)
1     FORMAT(1X,'OUTPUT FOR PERFECT CLUB BENCHMARK: MG3D'/
     *       1X,'$Revision: 1.A.2 $ $by: jaxon $'/)
      WRITE(10,2)
2     FORMAT(1X,'VALIDATION PARAMETERS:'/)
C
C     WRITE DEPTH LEVEL
C
      WRITE(IDISK2,231)(DSECT(I, 61),I=1,NX)
231   FORMAT(1X,5E15.8)
      WRITE(10,231)(DSECT(I, 61),I=1,3)
C
      IVALID=0
C
      IF(ABS((DSECT(1,61)-.70482932E+04)/.70482932E+04).GE.1E-2)
     .   IVALID=1
      IF(ABS((DSECT(2,61)-.70231017E+04)/.70231017E+04).GE.1E-2)
     .   IVALID=1
      IF(ABS((DSECT(3,61)-.69990724E+04)/.69990724E+04).GE.1E-2)
     .   IVALID=1
C
      IF(IVALID.EQ.0)THEN
        WRITE(10,3)
3       FORMAT(//1X,'RESULTS FOR THIS RUN ARE:   VALID')
      ELSE
        WRITE(10,4)
4       FORMAT(//1X,'RESULTS FOR THIS RUN ARE: INVALID')
      ENDIF
C
      RETURN
      END
